Package: Rsubread
Version: 2.26.0
Date: 2026-03-17
Title: Mapping, quantification and variant analysis of sequencing data
Author: Wei Shi, Yang Liao and Gordon K Smyth with contributions from Jenny Dai
Maintainer: Wei Shi <wei.shi2@monash.edu>, Yang Liao <yang.liao@monash.edu> and Gordon K Smyth <smyth@wehi.edu.au>
Description: Alignment, quantification and analysis of
        RNA sequencing data (including both bulk RNA-seq and scRNA-seq) and
        DNA sequenicng data (including ATAC-seq, ChIP-seq, WGS, WES etc). 
        Includes functionality for read mapping, read counting, SNP calling, 
        structural variant detection and gene fusion discovery. Can be applied
        to all major sequencing techologies and to both short and long
        sequence reads.
URL: http://bioconductor.org/packages/Rsubread
License: GPL (>=3)
Imports: grDevices, stats, utils, Matrix
biocViews: Sequencing, Alignment, SequenceMatching, RNASeq, ChIPSeq,
        SingleCell, GeneExpression, GeneRegulation, Genetics,
        ImmunoOncology, SNP, GeneticVariability, Preprocessing,
        QualityControl, GenomeAnnotation, GeneFusionDetection,
        IndelDetection, VariantAnnotation, VariantDetection,
        MultipleSequenceAlignment
git_url: https://git.bioconductor.org/packages/Rsubread
git_branch: RELEASE_3_23
git_last_commit: 2c0bab4
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-29 00:27:29 UTC; biocbuild

useDynLib(Rsubread)

exportPattern("^[^\\.]")

importFrom("grDevices", "dev.off", "pdf")
importFrom("stats", "approxfun", "density", "dgamma", "dpois", "lowess",
           "median", "ppois", "runif", "rmultinom", "dmultinom", "p.adjust")
importFrom("utils", "download.file", "read.csv", "read.delim",
           "write.table", "head", "read.table")
importFrom("Matrix", "readMM")

propmapped <- function(files,countFragments=TRUE,properlyPaired=FALSE,verbose=FALSE)
{
  out.base.names <- basename(files)
  if(any(duplicated(out.base.names))){
    out.table.rows <- files
  }else{
    out.table.rows <- out.base.names
  }

  #out.table.rows <-gsub("[[:punct:]]+", ".", out.table.rows)
  #out.table.rows <-gsub(" ", ".", out.table.rows)

  files <- .check_and_NormPath(files, mustWork=T, opt="files")
  if(any(duplicated(files)))stop("Error: duplicated input files are provided. No result is generated.")
  fout <- file.path(".",paste(".Rsubread_propmapped_pid",Sys.getpid(),sep=""))

  for(i in 1:length(files)){
    opt <- paste("-i",files[i],sep=.R_param_splitor)

    if(countFragments)
    opt <- paste(opt,"-f",sep=.R_param_splitor)
    if(properlyPaired)
    opt <- paste(opt,"-p",sep=.R_param_splitor)

    if(verbose)
    opt <- paste(opt,"-V",sep=.R_param_splitor)

    opt <- paste(opt,"-o",fout,sep=.R_param_splitor)
    cmd <- paste("propmapped",opt,sep=.R_param_splitor)
    n <- length(unlist(strsplit(cmd,.R_param_splitor)))
    C_args <- .C("R_propmapped_wrapper",as.integer(n),as.character(cmd),PACKAGE="Rsubread")
  }

  x1 <- read.csv(fout,header=FALSE,row.names=1,stringsAsFactors=FALSE)
  rownames(x1) <- out.table.rows
  file.remove(fout)

  colnames(x1) <- c("NumTotal","NumMapped","PropMapped")
  x1
}

repair <- function(inFiles,inFormat="BAM",outFiles=paste(inFiles,"repair",sep="."),addDummy=TRUE,fullData=TRUE,compress=FALSE,nthreads=8)
{
    .check_string_param(inFormat,"inFormat")
	inFiles <- .check_and_NormPath(inFiles, mustWork=T, opt="inFiles")
	outFiles <- .check_and_NormPath(outFiles, mustWork=F, opt="outFiles")

	if(length(inFiles) != length(outFiles))
		stop("Number of input files is different from number of output files.")

	if(!all(file.exists(inFiles)))
		stop("One or more input files cannot be found.")

	if(!all(file.exists(dirname(outFiles))))
		stop("Invalid path was found in output file names.")
	
	for(i in 1:length(inFiles)){
		opt <- paste("-i",inFiles[i],sep=.R_param_splitor)

		if(tolower(inFormat) == "sam")
			opt <- paste(opt,"-S",sep=.R_param_splitor)	  

		if(!addDummy)
			opt <- paste(opt,"-d",sep=.R_param_splitor)

		if(!fullData)
			opt <- paste(opt,"-t",sep=.R_param_splitor)

		if(compress)
			opt <- paste(opt,"-c",sep=.R_param_splitor)

		opt <- paste(opt,"-T",nthreads,"-o",outFiles[i],sep=.R_param_splitor)

		cmd <- paste("repair",opt,sep=.R_param_splitor)
		n <- length(unlist(strsplit(cmd,.R_param_splitor)))
		C_args <- .C("R_repair_wrapper",as.integer(n),as.character(cmd),PACKAGE="Rsubread")
	}
	invisible()
}

exactSNP <- function(readFile,isBAM=FALSE,refGenomeFile,SNPAnnotationFile=NULL,outputFile=paste0(readFile,".exactSNP.VCF"),qvalueCutoff=12,minAllelicFraction=0,minAllelicBases=1,minReads=1,maxReads=1000000, minBaseQuality=13,nTrimmedBases=3,nthreads=1)
{
  if(length(readFile) > 1L)
	stop("only one input file is allowed.")

  readFile <- normalizePath(readFile, mustWork=T)
  refGenomeFile <- normalizePath(refGenomeFile, mustWork=T);
  outputFile <- normalizePath(outputFile, mustWork=F)
  if(!is.null(SNPAnnotationFile))SNPAnnotationFile <- normalizePath(SNPAnnotationFile, mustWork=T)

  opt <- paste("-i",readFile,sep=.R_param_splitor)
  
  if(isBAM)
    opt <- paste(opt,"-b",sep=.R_param_splitor)
	
  if(!is.null(SNPAnnotationFile))
    opt <- paste(opt,"-a",SNPAnnotationFile,sep=.R_param_splitor)

  opt <- paste(opt,"-g",refGenomeFile,"-o",outputFile,"-Q",qvalueCutoff,"-f",minAllelicFraction,"-n",minAllelicBases,"-r",minReads,"-x",maxReads,"-s",minBaseQuality,"-t",nTrimmedBases,"-T",nthreads,sep=.R_param_splitor)

  cmd <- paste("SNPcalling",opt,sep=.R_param_splitor)
  n <- length(unlist(strsplit(cmd,.R_param_splitor)))
  C_args <- .C("R_SNPcalling_wrapper",as.integer(n),as.character(cmd),PACKAGE="Rsubread")

}

.stop_quietly <- function() {
  opt <- options(show.error.messages = FALSE)
  on.exit(options(opt))
  stop()
}

.load.delete.summary <- function(bam.name){
  sumfile <- paste0(bam.name,".summary")
  if(!file.exists(sumfile)){
#    stop("Summary file ",sumfile," was not generated! The program terminated wrongly!")
    .stop_quietly()
  } 

  tmp.frame <- read.delim(sumfile, header=FALSE, row.names=1, stringsAsFactors=FALSE)
#  file.remove(sumfile)
  return(tmp.frame)
}

align <- function(index,readfile1,readfile2=NULL,type="rna",input_format="gzFASTQ",output_format="BAM",output_file=paste(readfile1,"subread",output_format,sep="."),phredOffset=33,nsubreads=10,TH1=3,TH2=1,maxMismatches=3,unique=FALSE,nBestLocations=1,indels=5,complexIndels=FALSE,nTrim5=0,nTrim3=0,minFragLength=50,maxFragLength=600,PE_orientation="fr",nthreads=1,readGroupID=NULL,readGroup=NULL,keepReadOrder=FALSE,sortReadsByCoordinates=FALSE,color2base=FALSE,DP_GapOpenPenalty=-1,DP_GapExtPenalty=0,DP_MismatchPenalty=0,DP_MatchScore=2,detectSV=FALSE,useAnnotation=FALSE,annot.inbuilt="mm39",annot.ext=NULL,isGTF=FALSE,GTF.featureType="exon",GTF.attrType="gene_id",chrAliases=NULL)
{
  if(!.is.64bit.system()) cat("WARNING: your system seems to be 32-bit. Rsubread supports 32-bit systems to a very limited level.\nIt is highly recommended to run Rsubread on a 64-bit system to avoid errors.\n\n")

  extra.params <- .retrieve.tmp.parameters()
  isBCLinput <- FALSE
  isScRNAFastqinput <- FALSE
  isScRNABAMinput <- FALSE
  if("isBCLinput" %in% names(extra.params))isBCLinput <- extra.params[["isBCLinput"]]
  if("isScRNAFastqinput" %in% names(extra.params))isScRNAFastqinput <- extra.params[["isScRNAFastqinput"]]
  if("isScRNABAMinput" %in% names(extra.params)) isScRNABAMinput <- extra.params[["isScRNABAMinput"]]

  .check_string_param(input_format,"input_format")
  .check_string_param(output_format,"output_format")
  .check_string_param(PE_orientation,"PE_orientation")
  .check_string_param(annot.inbuilt,"annot.inbuilt")
  .check_string_param(GTF.featureType,"GTF.featureType")
  .check_string_param(GTF.attrType,"GTF.attrType")
  .check_string_param(readGroupID,"readGroupID")
  .check_string_param(readGroup,"readGroup")
  
  out.base.names <- basename(output_file)
  if(any(duplicated(out.base.names))){
    out.table.cols <- output_file
  }else{
    out.table.cols <- out.base.names
  }
  #out.table.cols <-gsub("[[:punct:]]+", ".", out.table.cols)
  #out.table.cols <-gsub(" ", ".", out.table.cols)

  readfile1 <- as.character(readfile1)
  if(!isScRNAFastqinput)readfile1 <- .check_and_NormPath(readfile1, mustWork=TRUE, opt="readfile1")
  output_file <- .check_and_NormPath(output_file, mustWork=FALSE, opt="output_file")
  index <- .check_and_NormPath(index, mustWork=FALSE, opt="index")
  if((!is.null(annot.ext)) && is.character(annot.ext)) annot.ext = .check_and_NormPath(annot.ext, mustWork=TRUE, opt="annot.ext")
  if(!is.null(chrAliases)) chrAliases = .check_and_NormPath(chrAliases, mustWork=TRUE, opt="chrAliases")

  if(length(readfile1) != length(output_file))
    stop("The number of input file names is different from the number of output file names.")

  if(!is.null(readfile2)){
    readfile2 <- as.character(readfile2)
    readfile2 <- .check_and_NormPath(readfile2, mustWork=TRUE, "readfile2")
    if(length(readfile1) != length(readfile2))
      stop("The number of file names for the first reads is different from the number of file names for the second reads.")
  }

  if(!all(file.exists(dirname(output_file))))
    stop("Invalid path was found in output file name(s).")

  opt <- paste("-i",index,sep=.R_param_splitor)
  
  type_C <- -1
  if(is.character(type)){
    if(tolower(type) == "rna") type_C <- 0
    if(tolower(type) == "dna") type_C <- 1
  }
  if(is.numeric(type)){
    if (type == 0 || type == 1) type_C <- type
  }
  if(type_C == -1) stop("Invalid value was provided for data type.")
  
  opt <- paste(opt,"--type",type_C,sep=.R_param_splitor)

  if(tolower(input_format) == "sam")
    opt <- paste(opt,"--SAMinput",sep=.R_param_splitor)
  if(tolower(input_format) == "bam")
    opt <- paste(opt,"--BAMinput",sep=.R_param_splitor)

  if(tolower(output_format) == "sam")
    opt <- paste(opt,"--SAMoutput",sep=.R_param_splitor)

  opt <- paste(opt,"-n",nsubreads,"-m",TH1,"-p",TH2,"-M",maxMismatches,"-T",nthreads,"-I",indels,sep=.R_param_splitor)

  if(complexIndels)
    opt <- paste(opt,"--complexIndels",sep=.R_param_splitor)

  if(isScRNAFastqinput)
    opt <- paste(opt,"--scRNA_FQinput",sep=.R_param_splitor)

  if(isScRNABAMinput)
    opt <- paste(opt,"--scRNA_BAMinput",sep=.R_param_splitor)

  if(!unique)
    opt <- paste(opt,"--multiMapping",sep=.R_param_splitor)

  if(isBCLinput)
    opt <- paste(opt,"--BCLinput",sep=.R_param_splitor)

  opt <- paste(opt,"-B",nBestLocations,"-d",minFragLength,"-D",maxFragLength,"-S",PE_orientation,"--trim5",nTrim5,"--trim3",nTrim3,sep=.R_param_splitor)

  if(!is.null(readGroupID))
    opt <- paste(opt,"--rg-id",readGroupID,sep=.R_param_splitor)
  if(!is.null(readGroup))
    opt <- paste(opt,"--rg",readGroup,sep=.R_param_splitor)
  if(color2base)
    opt <- paste(opt,"-b",sep=.R_param_splitor)
  if(keepReadOrder)
    opt <- paste(opt,"--keepReadOrder",sep=.R_param_splitor)
  if(sortReadsByCoordinates)
    opt <- paste(opt,"--sortReadsByCoordinates",sep=.R_param_splitor)

  opt <- paste(opt,"-G",DP_GapOpenPenalty,"-E",DP_GapExtPenalty,"-X",DP_MismatchPenalty,"-Y",DP_MatchScore,sep=.R_param_splitor)

  if(detectSV)
    opt <- paste(opt,"--sv",sep=.R_param_splitor)

  flag <- FALSE
  if(useAnnotation){
    annot.display <- "R data.frame"
    if(is.null(annot.ext)){
      switch(tolower(as.character(annot.inbuilt)),
      mm9={
        ann <- system.file("annot","mm9_RefSeq_exon.txt",package="Rsubread")
        annot.display <- "inbuilt (mm9)"
      },
      mm10={
        ann <- system.file("annot","mm10_RefSeq_exon.txt",package="Rsubread")
        annot.display <- "inbuilt (mm10)"
      },
      mm39={
        ann <- system.file("annot","mm39_RefSeq_exon.txt.gz",package="Rsubread")
        annot.display <- "inbuilt (mm39)"
      },
      hg19={
        ann <- system.file("annot","hg19_RefSeq_exon.txt",package="Rsubread")
        annot.display <- "inbuilt (hg19)"
      },
      hg38={
        ann <- system.file("annot","hg38_RefSeq_exon.txt",package="Rsubread")
        annot.display <- "inbuilt (hg38)"
      },
      {
        stop("In-built annotation for ", annot.inbuilt, " is not available.\n")
      }
      ) # end switch
    }
    else{
      if(is.character(annot.ext)){
        ann <- annot.ext
        annot.display <- paste0(basename(ann), " (", ifelse(isGTF,"GTF","SAF"),")")
      }
      else{
        annot_df <- as.data.frame(annot.ext,stringsAsFactors=FALSE)
        if(sum(c("geneid","chr","start","end", "strand") %in% tolower(colnames(annot_df))) != 5)
          stop("One or more required columns are missing in the provided annotation data. Please refer to help page for annotation format.\n")
        colnames(annot_df) <- tolower(colnames(annot_df))
        annot_df <- data.frame(geneid=annot_df$geneid,chr=annot_df$chr,start=annot_df$start,end=annot_df$end,strand=annot_df$strand,stringsAsFactors=FALSE)
        annot_df$chr <- as.character(annot_df$chr)
        fout_annot <- file.path(".",paste(".Rsubread_align_UserProvidedAnnotation_pid",Sys.getpid(),sep=""))
        oldScipen <- options(scipen=999)
        write.table(x=annot_df,file=fout_annot,sep="\t",row.names=FALSE,quote=FALSE)
        options(oldScipen)
        ann <- fout_annot
        flag <- TRUE
      }
    }

    opt <- paste(opt,"-a",ann,sep=.R_param_splitor)

    if(isGTF)
      opt <- paste(opt,"-F","GTF","--gtfFeature",GTF.featureType,"--gtfAttr",GTF.attrType,sep=.R_param_splitor)
    else
      opt <- paste(opt,"-F","SAF",sep=.R_param_splitor)

    if(!is.null(chrAliases))
      opt <- paste(opt,"-A",chrAliases,sep=.R_param_splitor)

    opt <- paste(opt, "--exonAnnotationScreenOut", annot.display, sep=.R_param_splitor)
  }

  if(phredOffset == 33)
    opt <- paste(opt,"-P",3,sep=.R_param_splitor)
  else
    opt <- paste(opt,"-P",6,sep=.R_param_splitor)

  for(i in 1:length(readfile1)){
    opt_files <- paste("-r",readfile1[i],sep=.R_param_splitor)
    if(!is.null(readfile2)) 
      opt_files <- paste(opt_files,"-R",readfile2[i],sep=.R_param_splitor)
    opt_files <- paste(opt_files,"-o",output_file[i],sep=.R_param_splitor)

    cmd <- paste("subread-align",opt_files,opt,sep=.R_param_splitor)
    n <- length(unlist(strsplit(cmd,.R_param_splitor)))
    C_args <- .C("R_align_wrapper",as.integer(n),as.character(cmd),PACKAGE="Rsubread")
    summary.data <- .load.delete.summary(output_file[i])
    if(i == 1){
      return.summary <- summary.data
    }else{
      return.summary <- data.frame(return.summary, summary.data)
    }
  }

  if(flag)
    file.remove(fout_annot)

  names(return.summary) <- out.table.cols # basename(output_file)
  return.summary
}

buildindex <- function(basename,reference,gappedIndex=FALSE,indexSplit=FALSE,memory=8000,TH_subread=100,colorspace=FALSE)
{
    if(!.is.64bit.system()) cat("WARNING: your system seems to be 32-bit. Rsubread supports 32-bit systems to a very limited level.\nIt is highly recommended to run Rsubread on a 64-bit system to avoid errors.\n\n")

	basename <- .check_and_NormPath(basename, mustWork=F, opt="basename")
	reference <- .check_and_NormPath(reference, mustWork=T, opt="reference")

	opt <- paste("-o",basename,"-f",TH_subread,"-M",memory,reference,sep=.R_param_splitor)

	if(gappedIndex == FALSE) opt <- paste("-F",opt,sep=.R_param_splitor)
	if(indexSplit == FALSE) opt <- paste("-B",opt,sep=.R_param_splitor)
	if(colorspace) opt <- paste("-c",opt,sep=.R_param_splitor)
		
	cmd <- paste("subread-buildindex",opt,sep=.R_param_splitor)
	n <- length(unlist(strsplit(cmd,.R_param_splitor)))
	C_args <- .C("R_buildindex_wrapper",argc=as.integer(n),argv=as.character(cmd),PACKAGE="Rsubread")
}

qualityScores <- function(filename,input_format="gzFASTQ",offset=33,nreads=10000)
{
    .check_string_param(input_format,"input_format")
	if(length(filename)>1) stop("The qualityScores function only allows one input file.")
	filename <- .check_and_NormPath(filename, mustWork=T, opt="filename")

	if (file.exists(filename) == FALSE)
		stop("Can not find the input file. Pleaes check whether the file name is correct.")
	
	score_file = paste(".Rsubread_qualityScores_score_pid",Sys.getpid(),sep="")
	
	opt <- paste("-i",filename,"-o",score_file,sep=.R_param_splitor)

	if(tolower(input_format) == "gzfastq")
		opt <- paste(opt,"--gzFASTQinput",sep=.R_param_splitor)
	  	
	if(tolower(input_format) == "sam")
		opt <- paste(opt,"--SAMinput",sep=.R_param_splitor)

	if(tolower(input_format) == "bam")
		opt <- paste(opt,"--BAMinput",sep=.R_param_splitor)

    if(nreads<=0){
      if(nreads==-1) nreads <- "100000000000" 
      else stop("ERROR: nreads cannot be zero or negative.")
    }
	opt <- paste(opt,"--phred-offset",offset,"--counted-reads",nreads,sep=.R_param_splitor)

	cmd <- paste("qualityScores",opt,sep=.R_param_splitor)
	n <- length(unlist(strsplit(cmd,.R_param_splitor)))
	C_args <- .C("R_qualityScores_wrapper",as.integer(n),as.character(cmd),PACKAGE="Rsubread")
	
	scores <- read.csv(score_file,header=FALSE,stringsAsFactors=FALSE)
    scores <- scores[, colSums( is.na(scores) ) < nrow(scores) ] # remove all-NA columns
	scores <- as.matrix(scores)
	colnames(scores) <- 1:ncol(scores)
	
	file.remove(score_file)
	
	scores
}

flattenGTF <- function(GTFfile,GTF.featureType="exon",GTF.attrType="gene_id",method="merge"){
  .check_string_param(GTF.featureType,"GTF.featureType")
  .check_string_param(GTF.attrType,"GTF.attrType")
  .check_string_param(method,"method")

  method <- match.arg(method,c("merge","chop"))
  GTFfile <- .check_and_NormPath(GTFfile, mustWork=TRUE, opt="GTFfile")

  fout <- file.path(".",paste0(".Rsubread_flattenGTF_pid",Sys.getpid()))
  cmd <- paste("RflattenGTF","-a",GTFfile,sep=.R_param_splitor)
  cmd <- paste(cmd,"-g",GTF.attrType,sep=.R_param_splitor)
  cmd <- paste(cmd,"-t",GTF.featureType,sep=.R_param_splitor)
  cmd <- paste(cmd,"-o",fout,sep=.R_param_splitor)
  if(method == 'chop') cmd <- paste(cmd,"-C",sep=.R_param_splitor)

  n <- length(unlist(strsplit(cmd,.R_param_splitor)))
  C_args <- .C("R_flattenGTF_wrapper",n,cmd,PACKAGE="Rsubread")
  if(file.exists(fout)){
	z <- read.delim(fout,stringsAsFactors=FALSE,colClasses=c("character","character","integer","integer","character"))
	file.remove(fout)
	z
  }else{
	warning("No output was generated.")
	data.frame()
  }
}

findCommonVariants <- function(VCF_files)
{
	VCF_files <- .check_and_NormPath(VCF_files, mustWork=T, opt="VCF_files")
	fout <- file.path(".",paste(".Rsubread_featureCounts_pid",Sys.getpid(),sep=""))

	files_C <- paste(VCF_files,collapse=.R_param_splitor)

	cmd <- paste('-o', fout, files_C, sep=.R_param_splitor)

	n <- 2 + length(VCF_files)

	C_args <- .C("R_mergeVCF",as.integer(n),as.character(cmd),PACKAGE="Rsubread")

	x <- try(read.delim(fout,stringsAsFactors=FALSE, comment.char="#"),silent=TRUE)
	file.remove(fout)
	if(class(x)!='try-error') {
		colnames(x)[1:8] <- c("Chr","Pos","Reference","Identity","Alternative","Quality", "Filter","Info")
		x
	}
	else{
		NA
	}

}

.findCommonVariants_inner <- function(VCF_files)
{
    stop("Unused function, to be removed.")
	
	for(vcf_file in VCF_files)
	{
		print(paste("Doing", vcf_file))
		vcf_body <- read.delim(vcf_file, comment.char='#', header=FALSE)
		
		nky <- 0
		for(row_no in 1:nrow(vcf_body))
		{
			alts <- strsplit(as.vector(vcf_body$V5[row_no]), ',')
			alts <- alts[[1]]
			nky <- nky + length(alts)
		}

		print(paste("NROW =", nky))
		
		data_mat <- matrix(ncol = 3, nrow = nky)

		n2 <- 1
		for(row_no in 1:nrow(vcf_body))
		{
			vcf_row <- vcf_body[row_no,]
			key_values <- strsplit(as.vector(vcf_row$V8), ';')
			key_values <- key_values[[1]]
			key_type <- ifelse('INDEL' %in% key_values, 'INDEL','SNP')
			alts <- strsplit(as.vector(vcf_row$V5), ',')
			alts <- alts[[1]]

			chro <- vcf_row$V1
			pos <- vcf_row$V2
			qual <- vcf_row$V6
			for(alt in alts)
			{
				ky = paste(key_type, chro, pos, alt)
				data_mat[n2,1] <- ky
				data_mat[n2,2] <- qual
				data_mat[n2,3] <- as.vector(vcf_row$V8)
				n2<-n2+1
			}
			print(paste("CUR_ROW" , n2))
				n2<-n2+1
		}

	}
}

txUnique <- function(GTF_Annotation_File, Feature_Type = "exon", Gene_ID_Attribute = "gene_id", Transcript_ID_Attribute = "transcript_id"){
    .check_string_param(Feature_Type, "Feature_Type")
    .check_string_param(Gene_ID_Attribute,"Gene_ID_Attribute")
    .check_string_param(Transcript_ID_Attribute,"Transcript_ID_Attribute")
    GTF_Annotation_File <- .check_and_NormPath(GTF_Annotation_File, mustWork=T, opt="GTF_Annotation_File")
    
    fout <- file.path(".",paste(".Rsubread_txUnique_pid",Sys.getpid(),sep=""))
    opt <- paste("-a",GTF_Annotation_File,sep=.R_param_splitor)
    opt <- paste(opt,"-o",fout,sep=.R_param_splitor)
    opt <- paste(opt,"-g",Gene_ID_Attribute,sep=.R_param_splitor)
    opt <- paste(opt,"-t",Transcript_ID_Attribute,sep=.R_param_splitor)
    cmd <- paste(opt,"-f",Feature_Type,sep=.R_param_splitor)
    n <- length(unlist(strsplit(cmd,.R_param_splitor)))
    C_args <- .C("R_txUnique_wrapper",as.integer(n),as.character(cmd),PACKAGE="Rsubread")
    if(file.exists(fout)){
    	z <- read.delim(fout)
    	z <- z[ order(z[,'Gene_ID'], z[,'Transcript_ID']) ,]
    	file.remove(fout)
    	z
    }else{
    	print("No output was generated.")
    	NA
    }
}

removeDupReads <- function(inputFile,threshold=50,outputFile,outputFormat="BAM")
{
  SAMfile <- .check_and_NormPath(inputFile, mustWork=T, opt="SAMfile")
  outputFile <- .check_and_NormPath(outputFile, mustWork=F, opt="outputFile")
  cmd <- paste("removeDupReads","-i",SAMfile,"-r",threshold,"-o",outputFile,sep=.R_param_splitor)

  if(outputFormat=="SAM") cmd <- paste(cmd, "-S", sep=.R_param_splitor)
  else if(outputFormat!="BAM") stop("ERROR: Unknown output format! Only 'BAM' or 'SAM' are accepted!")

  n <- length(unlist(strsplit(cmd, .R_param_splitor)))
  C_args <- .C("R_removeDupReads_wrapper",as.integer(n),as.character(cmd),PACKAGE="Rsubread")
}

.write.tmp.parameters <- function(param){
  temp.file.prefix <- file.path(".",paste(".Rsubread_PARAM_cellCounts_",Sys.getpid(),sep=""))
  param$PMR_CREATE_TIME <- Sys.time()
  saveRDS(param, temp.file.prefix)
}

.retrieve.tmp.parameters <- function(){
  temp.file.prefix <- file.path(".",paste(".Rsubread_PARAM_cellCounts_",Sys.getpid(),sep=""))
  if(!file.exists(temp.file.prefix)) return (NA)
  rv <- readRDS(temp.file.prefix)
  file.remove(temp.file.prefix)
  if( Sys.time() - rv$PMR_CREATE_TIME > 5) return (NA) # the file should be created no longer than 5 seconds ago
  rv
}

.index.names.to.sheet.BAM.mode<-function(fqtab, fname){
  lines <- paste(fqtab$BAMFile, fqtab$SampleName , sep=",")
  fileConn<-file(fname)
  writeLines(c("EMFileVersion,4","[data]","BAMFile,Sample_Name",lines), fileConn)
  close(fileConn)
}

.index.names.to.sheet.FASTQ.mode<-function(fqtab, fname){
  lines <- paste(fqtab$BarcodeUMIFile, fqtab$ReadFile, fqtab$SampleName , sep=",")
  fileConn<-file(fname)
  writeLines(c("EMFileVersion,4","[data]","BarcodeUMIFile,ReadFile,Sample_Name",lines), fileConn)
  close(fileConn)
}

.index.names.to.sheet.raw.dir.mode<-function(dirname, nametab, fname, sample.name=NA, which.dual.index=NULL){
  lanes <- c()
  index.names <- c()
  sample.names <- c()
  index.seq <- c()
  is_dual_index <- c() 
  Aarr <- c()
  Barr <- c()
  if(F==is.null(which.dual.index) && is.na(which.dual.index))which.dual.index<-NULL
  for(cli in 1:nrow(nametab)){
    if(nametab$InputDirectory[cli]!=dirname)next
    if((!is.na(sample.name)) && as.character(nametab$SampleName[cli])!=sample.name)next
    seqs.list <- .convert.sample_index.id.to.seq(nametab$IndexSetName[cli])
    if(!is.null(which.dual.index)){
       seqs.list <- seqs.list[[which.dual.index]]
    }
    for(seq in unlist(seqs.list)){
      is_dual_index <- c(is_dual_index , nchar(seq)>12)
      lanes <-c(lanes, nametab$Lane[cli])
      index.names <-c(index.names, nametab$IndexSetName[cli])
      sample.names <- c(sample.names, as.character(nametab$SampleName[cli]))
      index.seq <- c(index.seq, seq)
    }
    if(any(is_dual_index) && is.null(which.dual.index)){
      Aarr <- c(Aarr, seqs.list$A)
      Barr <- c(Barr, seqs.list$B)
    }
  }
  sdf<-data.frame(Lane=lanes, Sample_ID=index.names, Sample_Name=sample.names, index=index.seq, Sample_Project=rep("cellCounts", length(lanes)), stringsAsFactors=F)
  fileConn<-file(fname)
  lines <- paste( sdf$Lane, sdf$Sample_ID, sdf$Sample_Name, sdf$index, sdf$Sample_Project ,sep=",")
  writeLines(c("EMFileVersion,4","[data]","Lane,Sample_ID,Sample_Name,index,Sample_Project",lines), fileConn)
  close(fileConn)
  if(any(is_dual_index != is_dual_index[1])) stop("Dual-index and single-index samples cannot be mixed in the sample data-frame.")
  if(is_dual_index[1]) return(list(A=Aarr, B=Barr))
  return(NULL)
}

.convert.sample_index.id.to.seq <- function(spid){
  seqs <- .one.convert.sample_index.id.to.seq(spid)
  if(any(is.na(seqs))){
    spid <- gsub("-","_", spid)
    seqs <- .one.convert.sample_index.id.to.seq(spid)
  }
  if(any(is.na(seqs)))stop(paste("Unable to find sample index for", spid))
  seqs
}
.one.convert.sample_index.id.to.seq <- function(spid){
  spseqs <- NA
  if(spid == "SI_001") spseqs <- c('TCGCCATA', 'GTATACAC', 'AATGGTGG', 'CGCATGCT')
  if(spid == "SI_002") spseqs <- c('TATCCTCG', 'GCGAGGTC', 'CGCTTCAA', 'ATAGAAGT')
  if(spid == "SI_003") spseqs <- c('TGACGTCG', 'CTTGTGTA', 'ACGACCGT', 'GACTAAAC')
  if(spid == "SI_004") spseqs <- c('ATCTAGCT', 'GAGCGTAC', 'TCAGCCTG', 'CGTATAGA')
  if(spid == "SI_005") spseqs <- c('CCGTTCCC', 'ATACAGTT', 'TGTAGTAA', 'GACGCAGG')
  if(spid == "SI_006") spseqs <- c('TCAATTGG', 'AGTTAGAA', 'GAGCGCTT', 'CTCGCACC')
  if(spid == "SI_007") spseqs <- c('CTGCCTTG', 'ACTAGCCC', 'GGCTAGAT', 'TAAGTAGA')
  if(spid == "SI_008") spseqs <- c('GGCAGAAA', 'ACGGTTCT', 'CATTCGTC', 'TTACACGG')
  if(spid == "SI_P01_A1") spseqs <- c('TTGTAAGA', 'GGCGTTTC', 'CCTACCAT', 'AAACGGCG')
  if(spid == "SI_P01_B1") spseqs <- c('CTAGCTGT', 'GCCAACAA', 'AGGCTACC', 'TATTGGTG')
  if(spid == "SI_P01_C1") spseqs <- c('GATGCAGT', 'AGACTTTC', 'TTCTACAG', 'CCGAGGCA')
  if(spid == "SI_P01_D1") spseqs <- c('AGCTGCGT', 'GTGGAGCA', 'TCTATTAG', 'CAACCATC')
  if(spid == "SI_P01_E1") spseqs <- c('CGCCCGTA', 'GTTTGCCT', 'TAAGTTAG', 'ACGAAAGC')
  if(spid == "SI_P01_F1") spseqs <- c('TGACTAGT', 'GATAGGTA', 'CCGTACAG', 'ATCGCTCC')
  if(spid == "SI_P01_G1") spseqs <- c('CATATGCG', 'ATGCGATT', 'TCCGCTAC', 'GGATACGA')
  if(spid == "SI_P01_H1") spseqs <- c('TCTTGTCC', 'CGGGAGTA', 'GTCACAGG', 'AAACTCAT')
  if(spid == "SI_P01_A2") spseqs <- c('AGCCCTTT', 'TCTTAGGC', 'GTGAGAAG', 'CAAGTCCA')
  if(spid == "SI_P01_B2") spseqs <- c('GGTCGAGC', 'TTAGATTG', 'CCCACCCA', 'AAGTTGAT')
  if(spid == "SI_P01_C2") spseqs <- c('CCGAGAAC', 'TGCTCTGT', 'GTAGTGCG', 'AATCACTA')
  if(spid == "SI_P01_D2") spseqs <- c('ACATTCCG', 'GACACAAT', 'CTGCGGTA', 'TGTGATGC')
  if(spid == "SI_P01_E2") spseqs <- c('TCATCAAG', 'GTTGGTCC', 'AGGCTGGT', 'CACAACTA')
  if(spid == "SI_P01_F2") spseqs <- c('TGCCCGCT', 'GCAAACGC', 'CATTGATA', 'ATGGTTAG')
  if(spid == "SI_P01_G2") spseqs <- c('CGGTGAGC', 'ATAACCTA', 'TCCGAGCG', 'GATCTTAT')
  if(spid == "SI_P01_H2") spseqs <- c('CCGAACTC', 'AACGGTCA', 'TTATTGGT', 'GGTCCAAG')
  if(spid == "SI_P01_A3") spseqs <- c('AAAGCATA', 'GCCTTTAT', 'CTGCAGCC', 'TGTAGCGG')
  if(spid == "SI_P01_B3") spseqs <- c('TCATCCTT', 'ATTGGACG', 'CAGCTTAC', 'GGCAAGGA')
  if(spid == "SI_P01_C3") spseqs <- c('ACGTTACA', 'TTACCTAC', 'GACGACGG', 'CGTAGGTT')
  if(spid == "SI_P01_D3") spseqs <- c('GAGCACGC', 'CGAAGTTG', 'TTCGTGAA', 'ACTTCACT')
  if(spid == "SI_P01_E3") spseqs <- c('TCTGCAGG', 'CGGCTCCA', 'AACAAGTC', 'GTATGTAT')
  if(spid == "SI_P01_F3") spseqs <- c('TTAGGACC', 'AGTCTGTA', 'GCCTCCGT', 'CAGAATAG')
  if(spid == "SI_P01_G3") spseqs <- c('TACGAGTT', 'ATGTCCAG', 'GCTATAGC', 'CGACGTCA')
  if(spid == "SI_P01_H3") spseqs <- c('TTGGGCTT', 'GACAAACC', 'ACACCTAA', 'CGTTTGGG')
  if(spid == "SI_P01_A4") spseqs <- c('CATGGCAG', 'AGAACGCC', 'GTCTTTGA', 'TCGCAATT')
  if(spid == "SI_P01_B4") spseqs <- c('GACAGGCT', 'CCTCTAAC', 'AGGGACTG', 'TTATCTGA')
  if(spid == "SI_P01_C4") spseqs <- c('ACATTGGC', 'GAGCCCAT', 'CTTAGTCA', 'TGCGAATG')
  if(spid == "SI_P01_D4") spseqs <- c('AAATCGTC', 'GCGATCGG', 'CTTCGAAT', 'TGCGATCA')
  if(spid == "SI_P01_E4") spseqs <- c('GTAAACAT', 'TATCCTGA', 'AGCTGACG', 'CCGGTGTC')
  if(spid == "SI_P01_F4") spseqs <- c('GCATGATA', 'CGTCCTCT', 'AACGACAC', 'TTGATGGG')
  if(spid == "SI_P01_G4") spseqs <- c('CCTGCGGT', 'GTACAACG', 'AGCTTCTC', 'TAGAGTAA')
  if(spid == "SI_P01_H4") spseqs <- c('TTCCATCT', 'ACTGGAGC', 'CGGTCGTG', 'GAAATCAA')
  if(spid == "SI_P01_A5") spseqs <- c('CAGTCTGG', 'TCACACTC', 'ATTGGGAA', 'GGCATACT')
  if(spid == "SI_P01_B5") spseqs <- c('TCATGCGA', 'ATCGTACT', 'CATCAGTG', 'GGGACTAC')
  if(spid == "SI_P01_C5") spseqs <- c('TCAGTCAA', 'CACTGACT', 'ATGCATTC', 'GGTACGGG')
  if(spid == "SI_P01_D5") spseqs <- c('GTCGACTC', 'AGACGGAT', 'CCTTTAGA', 'TAGACTCG')
  if(spid == "SI_P01_E5") spseqs <- c('CCGTTGAA', 'TATGCTCT', 'ATCCAAGG', 'GGAAGCTC')
  if(spid == "SI_P01_F5") spseqs <- c('TCTGACTA', 'GTACGGCT', 'CGGTTTAG', 'AACACAGC')
  if(spid == "SI_P01_G5") spseqs <- c('ATGAAGTA', 'GAAGCTCG', 'TCTTTCGT', 'CGCCGAAC')
  if(spid == "SI_P01_H5") spseqs <- c('ATAGTATG', 'TATAAGGA', 'GGCTCCAC', 'CCGCGTCT')
  if(spid == "SI_P01_A6") spseqs <- c('CTTTCGAC', 'ACGGGACT', 'TGCATCTG', 'GAACATGA')
  if(spid == "SI_P01_B6") spseqs <- c('GCGCACCT', 'AACGCGAA', 'CTATTTGG', 'TGTAGATC')
  if(spid == "SI_P01_C6") spseqs <- c('CGCTCAGG', 'GAGGTTTA', 'ACTCAGAC', 'TTAAGCCT')
  if(spid == "SI_P01_D6") spseqs <- c('GAAGTCTT', 'TGCAGGGC', 'ATGCCAAA', 'CCTTATCG')
  if(spid == "SI_P01_E6") spseqs <- c('TGATGGCT', 'GCCATTTG', 'ATTGAAAC', 'CAGCCCGA')
  if(spid == "SI_P01_F6") spseqs <- c('GACTTCCT', 'TGAGGAAG', 'ATGCCGGC', 'CCTAATTA')
  if(spid == "SI_P01_G6") spseqs <- c('GTGCGACA', 'TCAGTGTT', 'AGCACTGG', 'CATTACAC')
  if(spid == "SI_P01_H6") spseqs <- c('AAGCATAA', 'CCCATCGC', 'TTAGCGCT', 'GGTTGATG')
  if(spid == "SI_P01_A7") spseqs <- c('CTCATCAT', 'TAACGTCC', 'AGGTCATA', 'GCTGAGGG')
  if(spid == "SI_P01_B7") spseqs <- c('TCCACACG', 'CTTCTGTT', 'GAATGCAC', 'AGGGATGA')
  if(spid == "SI_P01_C7") spseqs <- c('GGCGGAAT', 'ACACCGGG', 'CATAATCC', 'TTGTTCTA')
  if(spid == "SI_P01_D7") spseqs <- c('CCGGATCC', 'GGTCGCAT', 'TTAACGTG', 'AACTTAGA')
  if(spid == "SI_P01_E7") spseqs <- c('AAGACGTG', 'CCATGTGT', 'GTTCACAA', 'TGCGTACC')
  if(spid == "SI_P01_F7") spseqs <- c('GGTTAGAC', 'CAAACTTT', 'ACCCGAGA', 'TTGGTCCG')
  if(spid == "SI_P01_G7") spseqs <- c('GCCGGTAA', 'TGACTGCC', 'ATTACCGG', 'CAGTAATT')
  if(spid == "SI_P01_H7") spseqs <- c('TGGCACGA', 'AACGGGTG', 'CTAATTCT', 'GCTTCAAC')
  if(spid == "SI_P01_A8") spseqs <- c('GACTGTTC', 'ATGATACG', 'CCACAGAA', 'TGTGCCGT')
  if(spid == "SI_P01_B8") spseqs <- c('ACGTTCAC', 'TGCCCAGA', 'CAAGGTCT', 'GTTAAGTG')
  if(spid == "SI_P01_C8") spseqs <- c('TTTATCCC', 'GCACGTTT', 'CAGGAAGA', 'AGCTCGAG')
  if(spid == "SI_P01_D8") spseqs <- c('AATCTTTG', 'GGATGAGT', 'CTCAAGAC', 'TCGGCCCA')
  if(spid == "SI_P01_E8") spseqs <- c('GCTTACAT', 'TAGGGTGC', 'AGCCTATG', 'CTAACGCA')
  if(spid == "SI_P01_F8") spseqs <- c('AGTTGGGA', 'TACATTCT', 'CCAGAAAG', 'GTGCCCTC')
  if(spid == "SI_P01_G8") spseqs <- c('AAGTACTC', 'GGAACTCT', 'TCCCTGAG', 'CTTGGAGA')
  if(spid == "SI_P01_H8") spseqs <- c('AAGAGCGG', 'TCATAGCA', 'GGCCCATC', 'CTTGTTAT')
  if(spid == "SI_P01_A9") spseqs <- c('GAGTGCGT', 'CTCCAACA', 'ACAACTTG', 'TGTGTGAC')
  if(spid == "SI_P01_B9") spseqs <- c('AAGCGTGT', 'CTTGACCG', 'TGATTAAC', 'GCCACGTA')
  if(spid == "SI_P01_C9") spseqs <- c('AGATCGGT', 'CATCGTCG', 'GTCATATA', 'TCGGACAC')
  if(spid == "SI_P01_D9") spseqs <- c('CAAGGGAC', 'ACCTACTG', 'GGGACACA', 'TTTCTTGT')
  if(spid == "SI_P01_E9") spseqs <- c('AGTAAGCA', 'TACCGCGG', 'CCGGTAAT', 'GTATCTTC')
  if(spid == "SI_P01_F9") spseqs <- c('AGTTAGTT', 'GTACTTAA', 'CACGCACG', 'TCGAGCGC')
  if(spid == "SI_P01_G9") spseqs <- c('TTGACTTC', 'GCCGAAGT', 'CAATGGCA', 'AGTCTCAG')
  if(spid == "SI_P01_H9") spseqs <- c('GGAATATG', 'ACCTGCCA', 'CTTCATAC', 'TAGGCGGT')
  if(spid == "SI_P01_A10") spseqs <- c('ACAGCAAC', 'TTTCGCGA', 'CGCAATTT', 'GAGTTGCG')
  if(spid == "SI_P01_B10") spseqs <- c('ACCATTAA', 'CTGGACGT', 'GAACGGTC', 'TGTTCACG')
  if(spid == "SI_P01_C10") spseqs <- c('CGTGCTAA', 'TCACTCCT', 'ATCTGATC', 'GAGAAGGG')
  if(spid == "SI_P01_D10") spseqs <- c('CTTATTTG', 'GCGGGCAT', 'AGATAACA', 'TACCCGGC')
  if(spid == "SI_P01_E10") spseqs <- c('GCACCAGT', 'CGCAGGAG', 'TAGTACCA', 'ATTGTTTC')
  if(spid == "SI_P01_F10") spseqs <- c('TCGACAAT', 'GAATACTG', 'ATTCGTGC', 'CGCGTGCA')
  if(spid == "SI_P01_G10") spseqs <- c('CGGAGACT', 'TCCTATGA', 'ATACTGAG', 'GATGCCTC')
  if(spid == "SI_P01_H10") spseqs <- c('GACCGCCA', 'TCGAATTG', 'ATTTCAGC', 'CGAGTGAT')
  if(spid == "SI_P01_A11") spseqs <- c('CTTTCCTT', 'TAGGTAAA', 'ACCAGTCC', 'GGACAGGG')
  if(spid == "SI_P01_B11") spseqs <- c('TCCAGATA', 'GATTCGCT', 'CGACATAG', 'ATGGTCGC')
  if(spid == "SI_P01_C11") spseqs <- c('GTTTGTGG', 'ACCGAACA', 'TAGACGAC', 'CGACTCTT')
  if(spid == "SI_P01_D11") spseqs <- c('GCTACTTC', 'CACCTCAG', 'ATATGAGA', 'TGGGAGCT')
  if(spid == "SI_P01_E11") spseqs <- c('ATCGCCAT', 'TCACGGTA', 'GGGTTTCC', 'CATAAAGG')
  if(spid == "SI_P01_F11") spseqs <- c('GAACCCGG', 'AGCAGTTA', 'TCGTAGAT', 'CTTGTACC')
  if(spid == "SI_P01_G11") spseqs <- c('AGGGCGTT', 'CTATACGC', 'TACATAAG', 'GCTCGTCA')
  if(spid == "SI_P01_H11") spseqs <- c('TCTCGACT', 'AGGATCGA', 'CACGATTC', 'GTATCGAG')
  if(spid == "SI_P01_A12") spseqs <- c('TTATGGAA', 'ACTACTGT', 'CGGGAACG', 'GACCTCTC')
  if(spid == "SI_P01_B12") spseqs <- c('GAAAGACA', 'CGCTACAT', 'ACGCTTGG', 'TTTGCGTC')
  if(spid == "SI_P01_C12") spseqs <- c('TAAGCCAC', 'CCGTTATG', 'GGTAATGT', 'ATCCGGCA')
  if(spid == "SI_P01_D12") spseqs <- c('GCTGTGTA', 'AGAAACGT', 'CACTCAAC', 'TTGCGTCG')
  if(spid == "SI_P01_E12") spseqs <- c('CGCTATCC', 'ACGCGGAA', 'TAAATCGT', 'GTTGCATG')
  if(spid == "SI_P01_F12") spseqs <- c('AATTGAAC', 'TGGACCCT', 'CCAGTGGA', 'GTCCATTG')
  if(spid == "SI_P01_G12") spseqs <- c('CATGCGTA', 'ACCCGCAC', 'TGATATCG', 'GTGATAGT')
  if(spid == "SI_P01_H12") spseqs <- c('TGTGTATA', 'GTCCAGGC', 'CAATCCCT', 'ACGAGTAG')
  
  if(spid == "SI_3A_A1" || spid == "SI_P03_A1") spseqs <- c('AAACGGCG', 'CCTACCAT', 'GGCGTTTC', 'TTGTAAGA')
  if(spid == "SI_3A_B1" || spid == "SI_P03_B1") spseqs <- c('AGGCTACC', 'CTAGCTGT', 'GCCAACAA', 'TATTGGTG')
  if(spid == "SI_3A_C1" || spid == "SI_P03_C1") spseqs <- c('AGACTTTC', 'CCGAGGCA', 'GATGCAGT', 'TTCTACAG')
  if(spid == "SI_3A_D1" || spid == "SI_P03_D1") spseqs <- c('AGCTGCGT', 'CAACCATC', 'GTGGAGCA', 'TCTATTAG')
  if(spid == "SI_3A_E1" || spid == "SI_P03_E1") spseqs <- c('ACGAAAGC', 'CGCCCGTA', 'GTTTGCCT', 'TAAGTTAG')
  if(spid == "SI_3A_F1" || spid == "SI_P03_F1") spseqs <- c('ATCGCTCC', 'CCGTACAG', 'GATAGGTA', 'TGACTAGT')
  if(spid == "SI_3A_G1" || spid == "SI_P03_G1") spseqs <- c('ATGCGATT', 'CATATGCG', 'GGATACGA', 'TCCGCTAC')
  if(spid == "SI_3A_H1" || spid == "SI_P03_H1") spseqs <- c('AAACTCAT', 'CGGGAGTA', 'GTCACAGG', 'TCTTGTCC')
  if(spid == "SI_3A_A2" || spid == "SI_P03_A2") spseqs <- c('AGCCCTTT', 'CAAGTCCA', 'GTGAGAAG', 'TCTTAGGC')
  if(spid == "SI_3A_B2" || spid == "SI_P03_B2") spseqs <- c('AAGTTGAT', 'CCCACCCA', 'GGTCGAGC', 'TTAGATTG')
  if(spid == "SI_3A_C2" || spid == "SI_P03_C2") spseqs <- c('AATCACTA', 'CCGAGAAC', 'GTAGTGCG', 'TGCTCTGT')
  if(spid == "SI_3A_D2" || spid == "SI_P03_D2") spseqs <- c('ACATTCCG', 'CTGCGGTA', 'GACACAAT', 'TGTGATGC')
  if(spid == "SI_3A_E2" || spid == "SI_P03_E2") spseqs <- c('AGGCTGGT', 'CACAACTA', 'GTTGGTCC', 'TCATCAAG')
  if(spid == "SI_3A_F2" || spid == "SI_P03_F2") spseqs <- c('ATGGTTAG', 'CATTGATA', 'GCAAACGC', 'TGCCCGCT')
  if(spid == "SI_3A_G2" || spid == "SI_P03_G2") spseqs <- c('ATAACCTA', 'CGGTGAGC', 'GATCTTAT', 'TCCGAGCG')
  if(spid == "SI_3A_H2" || spid == "SI_P03_H2") spseqs <- c('AACGGTCA', 'CCGAACTC', 'GGTCCAAG', 'TTATTGGT')
  if(spid == "SI_3A_A3" || spid == "SI_P03_A3") spseqs <- c('AAAGCATA', 'CTGCAGCC', 'GCCTTTAT', 'TGTAGCGG')
  if(spid == "SI_3A_B3" || spid == "SI_P03_B3") spseqs <- c('ATTGGACG', 'CAGCTTAC', 'GGCAAGGA', 'TCATCCTT')
  if(spid == "SI_3A_C3" || spid == "SI_P03_C3") spseqs <- c('ACGTTACA', 'CGTAGGTT', 'GACGACGG', 'TTACCTAC')
  if(spid == "SI_3A_D3" || spid == "SI_P03_D3") spseqs <- c('ACTTCACT', 'CGAAGTTG', 'GAGCACGC', 'TTCGTGAA')
  if(spid == "SI_3A_E3" || spid == "SI_P03_E3") spseqs <- c('AACAAGTC', 'CGGCTCCA', 'GTATGTAT', 'TCTGCAGG')
  if(spid == "SI_3A_F3" || spid == "SI_P03_F3") spseqs <- c('AGTCTGTA', 'CAGAATAG', 'GCCTCCGT', 'TTAGGACC')
  if(spid == "SI_3A_G3" || spid == "SI_P03_G3") spseqs <- c('ATGTCCAG', 'CGACGTCA', 'GCTATAGC', 'TACGAGTT')
  if(spid == "SI_3A_H3" || spid == "SI_P03_H3") spseqs <- c('ACACCTAA', 'CGTTTGGG', 'GACAAACC', 'TTGGGCTT')
  if(spid == "SI_3A_A4" || spid == "SI_P03_A4") spseqs <- c('AGAACGCC', 'CATGGCAG', 'GTCTTTGA', 'TCGCAATT')
  if(spid == "SI_3A_B4" || spid == "SI_P03_B4") spseqs <- c('AGGGACTG', 'CCTCTAAC', 'GACAGGCT', 'TTATCTGA')
  if(spid == "SI_3A_C4" || spid == "SI_P03_C4") spseqs <- c('ACATTGGC', 'CTTAGTCA', 'GAGCCCAT', 'TGCGAATG')
  if(spid == "SI_3A_D4" || spid == "SI_P03_D4") spseqs <- c('AAATCGTC', 'CTTCGAAT', 'GCGATCGG', 'TGCGATCA')
  if(spid == "SI_3A_E4" || spid == "SI_P03_E4") spseqs <- c('AGCTGACG', 'CCGGTGTC', 'GTAAACAT', 'TATCCTGA')
  if(spid == "SI_3A_F4" || spid == "SI_P03_F4") spseqs <- c('AACGACAC', 'CGTCCTCT', 'GCATGATA', 'TTGATGGG')
  if(spid == "SI_3A_G4" || spid == "SI_P03_G4") spseqs <- c('AGCTTCTC', 'CCTGCGGT', 'GTACAACG', 'TAGAGTAA')
  if(spid == "SI_3A_H4" || spid == "SI_P03_H4") spseqs <- c('ACTGGAGC', 'CGGTCGTG', 'GAAATCAA', 'TTCCATCT')
  if(spid == "SI_3A_A5" || spid == "SI_P03_A5") spseqs <- c('ATTGGGAA', 'CAGTCTGG', 'GGCATACT', 'TCACACTC')
  if(spid == "SI_3A_B5" || spid == "SI_P03_B5") spseqs <- c('ATCGTACT', 'CATCAGTG', 'GGGACTAC', 'TCATGCGA')
  if(spid == "SI_3A_C5" || spid == "SI_P03_C5") spseqs <- c('ATGCATTC', 'CACTGACT', 'GGTACGGG', 'TCAGTCAA')
  if(spid == "SI_3A_D5" || spid == "SI_P03_D5") spseqs <- c('AGACGGAT', 'CCTTTAGA', 'GTCGACTC', 'TAGACTCG')
  if(spid == "SI_3A_E5" || spid == "SI_P03_E5") spseqs <- c('ATCCAAGG', 'CCGTTGAA', 'GGAAGCTC', 'TATGCTCT')
  if(spid == "SI_3A_F5" || spid == "SI_P03_F5") spseqs <- c('AACACAGC', 'CGGTTTAG', 'GTACGGCT', 'TCTGACTA')
  if(spid == "SI_3A_G5" || spid == "SI_P03_G5") spseqs <- c('ATGAAGTA', 'CGCCGAAC', 'GAAGCTCG', 'TCTTTCGT')
  if(spid == "SI_3A_H5" || spid == "SI_P03_H5") spseqs <- c('ATAGTATG', 'CCGCGTCT', 'GGCTCCAC', 'TATAAGGA')
  if(spid == "SI_3A_A6" || spid == "SI_P03_A6") spseqs <- c('ACGGGACT', 'CTTTCGAC', 'GAACATGA', 'TGCATCTG')
  if(spid == "SI_3A_B6" || spid == "SI_P03_B6") spseqs <- c('AACGCGAA', 'CTATTTGG', 'GCGCACCT', 'TGTAGATC')
  if(spid == "SI_3A_C6" || spid == "SI_P03_C6") spseqs <- c('ACTCAGAC', 'CGCTCAGG', 'GAGGTTTA', 'TTAAGCCT')
  if(spid == "SI_3A_D6" || spid == "SI_P03_D6") spseqs <- c('ATGCCAAA', 'CCTTATCG', 'GAAGTCTT', 'TGCAGGGC')
  if(spid == "SI_3A_E6" || spid == "SI_P03_E6") spseqs <- c('ATTGAAAC', 'CAGCCCGA', 'GCCATTTG', 'TGATGGCT')
  if(spid == "SI_3A_F6" || spid == "SI_P03_F6") spseqs <- c('ATGCCGGC', 'CCTAATTA', 'GACTTCCT', 'TGAGGAAG')
  if(spid == "SI_3A_G6" || spid == "SI_P03_G6") spseqs <- c('AGCACTGG', 'CATTACAC', 'GTGCGACA', 'TCAGTGTT')
  if(spid == "SI_3A_H6" || spid == "SI_P03_H6") spseqs <- c('AAGCATAA', 'CCCATCGC', 'GGTTGATG', 'TTAGCGCT')
  if(spid == "SI_3A_A7" || spid == "SI_P03_A7") spseqs <- c('AGGTCATA', 'CTCATCAT', 'GCTGAGGG', 'TAACGTCC')
  if(spid == "SI_3A_B7" || spid == "SI_P03_B7") spseqs <- c('AGGGATGA', 'CTTCTGTT', 'GAATGCAC', 'TCCACACG')
  if(spid == "SI_3A_C7" || spid == "SI_P03_C7") spseqs <- c('ACACCGGG', 'CATAATCC', 'GGCGGAAT', 'TTGTTCTA')
  if(spid == "SI_3A_D7" || spid == "SI_P03_D7") spseqs <- c('AACTTAGA', 'CCGGATCC', 'GGTCGCAT', 'TTAACGTG')
  if(spid == "SI_3A_E7" || spid == "SI_P03_E7") spseqs <- c('AAGACGTG', 'CCATGTGT', 'GTTCACAA', 'TGCGTACC')
  if(spid == "SI_3A_F7" || spid == "SI_P03_F7") spseqs <- c('ACCCGAGA', 'CAAACTTT', 'GGTTAGAC', 'TTGGTCCG')
  if(spid == "SI_3A_G7" || spid == "SI_P03_G7") spseqs <- c('ATTACCGG', 'CAGTAATT', 'GCCGGTAA', 'TGACTGCC')
  if(spid == "SI_3A_H7" || spid == "SI_P03_H7") spseqs <- c('AACGGGTG', 'CTAATTCT', 'GCTTCAAC', 'TGGCACGA')
  if(spid == "SI_3A_A8" || spid == "SI_P03_A8") spseqs <- c('ATGATACG', 'CCACAGAA', 'GACTGTTC', 'TGTGCCGT')
  if(spid == "SI_3A_B8" || spid == "SI_P03_B8") spseqs <- c('ACGTTCAC', 'CAAGGTCT', 'GTTAAGTG', 'TGCCCAGA')
  if(spid == "SI_3A_C8" || spid == "SI_P03_C8") spseqs <- c('AGCTCGAG', 'CAGGAAGA', 'GCACGTTT', 'TTTATCCC')
  if(spid == "SI_3A_D8" || spid == "SI_P03_D8") spseqs <- c('AATCTTTG', 'CTCAAGAC', 'GGATGAGT', 'TCGGCCCA')
  if(spid == "SI_3A_E8" || spid == "SI_P03_E8") spseqs <- c('AGCCTATG', 'CTAACGCA', 'GCTTACAT', 'TAGGGTGC')
  if(spid == "SI_3A_F8" || spid == "SI_P03_F8") spseqs <- c('AGTTGGGA', 'CCAGAAAG', 'GTGCCCTC', 'TACATTCT')
  if(spid == "SI_3A_G8" || spid == "SI_P03_G8") spseqs <- c('AAGTACTC', 'CTTGGAGA', 'GGAACTCT', 'TCCCTGAG')
  if(spid == "SI_3A_H8" || spid == "SI_P03_H8") spseqs <- c('AAGAGCGG', 'CTTGTTAT', 'GGCCCATC', 'TCATAGCA')
  if(spid == "SI_3A_A9" || spid == "SI_P03_A9") spseqs <- c('ACAACTTG', 'CTCCAACA', 'GAGTGCGT', 'TGTGTGAC')
  if(spid == "SI_3A_B9" || spid == "SI_P03_B9") spseqs <- c('AAGCGTGT', 'CTTGACCG', 'GCCACGTA', 'TGATTAAC')
  if(spid == "SI_3A_C9" || spid == "SI_P03_C9") spseqs <- c('AGATCGGT', 'CATCGTCG', 'GTCATATA', 'TCGGACAC')
  if(spid == "SI_3A_D9" || spid == "SI_P03_D9") spseqs <- c('ACCTACTG', 'CAAGGGAC', 'GGGACACA', 'TTTCTTGT')
  if(spid == "SI_3A_E9" || spid == "SI_P03_E9") spseqs <- c('AGTAAGCA', 'CCGGTAAT', 'GTATCTTC', 'TACCGCGG')
  if(spid == "SI_3A_F9" || spid == "SI_P03_F9") spseqs <- c('AGTTAGTT', 'CACGCACG', 'GTACTTAA', 'TCGAGCGC')
  if(spid == "SI_3A_G9" || spid == "SI_P03_G9") spseqs <- c('AGTCTCAG', 'CAATGGCA', 'GCCGAAGT', 'TTGACTTC')
  if(spid == "SI_3A_H9" || spid == "SI_P03_H9") spseqs <- c('ACCTGCCA', 'CTTCATAC', 'GGAATATG', 'TAGGCGGT')
  if(spid == "SI_3A_A10" || spid == "SI_P03_A10") spseqs <- c('ACAGCAAC', 'CGCAATTT', 'GAGTTGCG', 'TTTCGCGA')
  if(spid == "SI_3A_B10" || spid == "SI_P03_B10") spseqs <- c('ACCATTAA', 'CTGGACGT', 'GAACGGTC', 'TGTTCACG')
  if(spid == "SI_3A_C10" || spid == "SI_P03_C10") spseqs <- c('ATCTGATC', 'CGTGCTAA', 'GAGAAGGG', 'TCACTCCT')
  if(spid == "SI_3A_D10" || spid == "SI_P03_D10") spseqs <- c('AGATAACA', 'CTTATTTG', 'GCGGGCAT', 'TACCCGGC')
  if(spid == "SI_3A_E10" || spid == "SI_P03_E10") spseqs <- c('ATTGTTTC', 'CGCAGGAG', 'GCACCAGT', 'TAGTACCA')
  if(spid == "SI_3A_F10" || spid == "SI_P03_F10") spseqs <- c('ATTCGTGC', 'CGCGTGCA', 'GAATACTG', 'TCGACAAT')
  if(spid == "SI_3A_G10" || spid == "SI_P03_G10") spseqs <- c('ATACTGAG', 'CGGAGACT', 'GATGCCTC', 'TCCTATGA')
  if(spid == "SI_3A_H10" || spid == "SI_P03_H10") spseqs <- c('ATTTCAGC', 'CGAGTGAT', 'GACCGCCA', 'TCGAATTG')
  if(spid == "SI_3A_A11" || spid == "SI_P03_A11") spseqs <- c('ACCAGTCC', 'CTTTCCTT', 'GGACAGGG', 'TAGGTAAA')
  if(spid == "SI_3A_B11" || spid == "SI_P03_B11") spseqs <- c('ATGGTCGC', 'CGACATAG', 'GATTCGCT', 'TCCAGATA')
  if(spid == "SI_3A_C11" || spid == "SI_P03_C11") spseqs <- c('ACCGAACA', 'CGACTCTT', 'GTTTGTGG', 'TAGACGAC')
  if(spid == "SI_3A_D11" || spid == "SI_P03_D11") spseqs <- c('ATATGAGA', 'CACCTCAG', 'GCTACTTC', 'TGGGAGCT')
  if(spid == "SI_3A_E11" || spid == "SI_P03_E11") spseqs <- c('ATCGCCAT', 'CATAAAGG', 'GGGTTTCC', 'TCACGGTA')
  if(spid == "SI_3A_F11" || spid == "SI_P03_F11") spseqs <- c('AGCAGTTA', 'CTTGTACC', 'GAACCCGG', 'TCGTAGAT')
  if(spid == "SI_3A_G11" || spid == "SI_P03_G11") spseqs <- c('AGGGCGTT', 'CTATACGC', 'GCTCGTCA', 'TACATAAG')
  if(spid == "SI_3A_H11" || spid == "SI_P03_H11") spseqs <- c('AGGATCGA', 'CACGATTC', 'GTATCGAG', 'TCTCGACT')
  if(spid == "SI_3A_A12" || spid == "SI_P03_A12") spseqs <- c('ACTACTGT', 'CGGGAACG', 'GACCTCTC', 'TTATGGAA')
  if(spid == "SI_3A_B12" || spid == "SI_P03_B12") spseqs <- c('ACGCTTGG', 'CGCTACAT', 'GAAAGACA', 'TTTGCGTC')
  if(spid == "SI_3A_C12" || spid == "SI_P03_C12") spseqs <- c('ATCCGGCA', 'CCGTTATG', 'GGTAATGT', 'TAAGCCAC')
  if(spid == "SI_3A_D12" || spid == "SI_P03_D12") spseqs <- c('AGAAACGT', 'CACTCAAC', 'GCTGTGTA', 'TTGCGTCG')
  if(spid == "SI_3A_E12" || spid == "SI_P03_E12") spseqs <- c('ACGCGGAA', 'CGCTATCC', 'GTTGCATG', 'TAAATCGT')
  if(spid == "SI_3A_F12" || spid == "SI_P03_F12") spseqs <- c('AATTGAAC', 'CCAGTGGA', 'GTCCATTG', 'TGGACCCT')
  if(spid == "SI_3A_G12" || spid == "SI_P03_G12") spseqs <- c('ACCCGCAC', 'CATGCGTA', 'GTGATAGT', 'TGATATCG')
  if(spid == "SI_3A_H12" || spid == "SI_P03_H12") spseqs <- c('ACGAGTAG', 'CAATCCCT', 'GTCCAGGC', 'TGTGTATA')
  
  
  if(spid == "SI_T2_1") spseqs <- c('GGGTGATC', 'TTACCGAT', 'AATGACGA', 'CCCATTCG')
  if(spid == "SI_T2_2") spseqs <- c('GGGTCGAA', 'ATCCGCCC', 'TCTATAGT', 'CAAGATTG')
  if(spid == "SI_T2_3") spseqs <- c('GCTGATAT', 'TGCCGAGC', 'AAATTGCG', 'CTGACCTA')
  if(spid == "SI_T2_4") spseqs <- c('ACTTCTGA', 'TTCATCTT', 'CGACGACG', 'GAGGAGAC')
  if(spid == "SI_T2_5") spseqs <- c('GAATACAA', 'AGCATACC', 'TCGGGTTT', 'CTTCCGGG')
  if(spid == "SI_T2_6") spseqs <- c('TATTGAGA', 'GTAGTCAG', 'CGCCATTC', 'ACGACGCT')
  if(spid == "SI_T2_7") spseqs <- c('AAATCTGT', 'GTCCAACC', 'TCTGGCTG', 'CGGATGAA')
  if(spid == "SI_T2_8") spseqs <- c('CCTTGAAC', 'GAAATCGG', 'TGGCCTCT', 'ATCGAGTA')
  
  
  if(spid == "SI_GA_A1" || spid == "SI_P2_A1") spseqs <- c('GGTTTACT', 'CTAAACGG', 'TCGGCGTC', 'AACCGTAA')
  if(spid == "SI_GA_A2" || spid == "SI_P2_A2") spseqs <- c('TTTCATGA', 'ACGTCCCT', 'CGCATGTG', 'GAAGGAAC')
  if(spid == "SI_GA_A3" || spid == "SI_P2_A3") spseqs <- c('CAGTACTG', 'AGTAGTCT', 'GCAGTAGA', 'TTCCCGAC')
  if(spid == "SI_GA_A4" || spid == "SI_P2_A4") spseqs <- c('TATGATTC', 'CCCACAGT', 'ATGCTGAA', 'GGATGCCG')
  if(spid == "SI_GA_A5" || spid == "SI_P2_A5") spseqs <- c('CTAGGTGA', 'TCGTTCAG', 'AGCCAATT', 'GATACGCC')
  if(spid == "SI_GA_A6" || spid == "SI_P2_A6") spseqs <- c('CGCTATGT', 'GCTGTCCA', 'TTGAGATC', 'AAACCGAG')
  if(spid == "SI_GA_A7" || spid == "SI_P2_A7") spseqs <- c('ACAGAGGT', 'TATAGTTG', 'CGGTCCCA', 'GTCCTAAC')
  if(spid == "SI_GA_A8" || spid == "SI_P2_A8") spseqs <- c('GCATCTCC', 'TGTAAGGT', 'CTGCGATG', 'AACGTCAA')
  if(spid == "SI_GA_A9" || spid == "SI_P2_A9") spseqs <- c('TCTTAAAG', 'CGAGGCTC', 'GTCCTTCT', 'AAGACGGA')
  if(spid == "SI_GA_A10" || spid == "SI_P2_A10") spseqs <- c('GAAACCCT', 'TTTCTGTC', 'CCGTGTGA', 'AGCGAAAG')
  if(spid == "SI_GA_A11" || spid == "SI_P2_A11") spseqs <- c('GTCCGGTC', 'AAGATCAT', 'CCTGAAGG', 'TGATCTCA')
  if(spid == "SI_GA_A12" || spid == "SI_P2_A12") spseqs <- c('AGTGGAAC', 'GTCTCCTT', 'TCACATCA', 'CAGATGGG')
  if(spid == "SI_GA_B1" || spid == "SI_P2_B1") spseqs <- c('GTAATCTT', 'TCCGGAAG', 'AGTTCGGC', 'CAGCATCA')
  if(spid == "SI_GA_B2" || spid == "SI_P2_B2") spseqs <- c('TACTCTTC', 'CCTGTGCG', 'GGACACGT', 'ATGAGAAA')
  if(spid == "SI_GA_B3" || spid == "SI_P2_B3") spseqs <- c('GTGTATTA', 'TGTGCGGG', 'ACCATAAC', 'CAACGCCT')
  if(spid == "SI_GA_B4" || spid == "SI_P2_B4") spseqs <- c('ACTTCATA', 'GAGATGAC', 'TGCCGTGG', 'CTAGACCT')
  if(spid == "SI_GA_B5" || spid == "SI_P2_B5") spseqs <- c('AATAATGG', 'CCAGGGCA', 'TGCCTCAT', 'GTGTCATC')
  if(spid == "SI_GA_B6" || spid == "SI_P2_B6") spseqs <- c('CGTTAATC', 'GCCACGCT', 'TTACTCAG', 'AAGGGTGA')
  if(spid == "SI_GA_B7" || spid == "SI_P2_B7") spseqs <- c('AAACCTCA', 'GCCTTGGT', 'CTGGACTC', 'TGTAGAAG')
  if(spid == "SI_GA_B8" || spid == "SI_P2_B8") spseqs <- c('AAAGTGCT', 'GCTACCTG', 'TGCTGTAA', 'CTGCAAGC')
  if(spid == "SI_GA_B9" || spid == "SI_P2_B9") spseqs <- c('CTGTAACT', 'TCTAGCGA', 'AGAGTGTG', 'GACCCTAC')
  if(spid == "SI_GA_B10" || spid == "SI_P2_B10") spseqs <- c('ACCGTATG', 'GATTAGAT', 'CTGACTGA', 'TGACGCCC')
  if(spid == "SI_GA_B11" || spid == "SI_P2_B11") spseqs <- c('GTTCCTCA', 'AGGTACGC', 'TAAGTATG', 'CCCAGGAT')
  if(spid == "SI_GA_B12" || spid == "SI_P2_B12") spseqs <- c('TACCACCA', 'CTAAGTTT', 'GGGTCAAG', 'ACTGTGGC')
  if(spid == "SI_GA_C1" || spid == "SI_P2_C1") spseqs <- c('CCACTTAT', 'AACTGGCG', 'TTGGCATA', 'GGTAACGC')
  if(spid == "SI_GA_C2" || spid == "SI_P2_C2") spseqs <- c('CCTAGACC', 'ATCTCTGT', 'TAGCTCTA', 'GGAGAGAG')
  if(spid == "SI_GA_C3" || spid == "SI_P2_C3") spseqs <- c('TCAGCCGT', 'CAGAGGCC', 'GGTCAATA', 'ATCTTTAG')
  if(spid == "SI_GA_C4" || spid == "SI_P2_C4") spseqs <- c('ACAATTCA', 'TGCGCAGC', 'CATCACTT', 'GTGTGGAG')
  if(spid == "SI_GA_C5" || spid == "SI_P2_C5") spseqs <- c('CGACTTGA', 'TACAGACT', 'ATTGCGTG', 'GCGTACAC')
  if(spid == "SI_GA_C6" || spid == "SI_P2_C6") spseqs <- c('ATTACTTC', 'TGCGAACT', 'GCATTCGG', 'CAGCGGAA')
  if(spid == "SI_GA_C7" || spid == "SI_P2_C7") spseqs <- c('GTCTCTCG', 'AATCTCTC', 'CGGAGGGA', 'TCAGAAAT')
  if(spid == "SI_GA_C8" || spid == "SI_P2_C8") spseqs <- c('GTTGAGAA', 'AGATCTGG', 'TCGATACT', 'CACCGCTC')
  if(spid == "SI_GA_C9" || spid == "SI_P2_C9") spseqs <- c('GCGCAGAA', 'ATCTTACC', 'TATGGTGT', 'CGAACCTG')
  if(spid == "SI_GA_C10" || spid == "SI_P2_C10") spseqs <- c('TCTCAGTG', 'GAGACTAT', 'CGCTTAGC', 'ATAGGCCA')
  if(spid == "SI_GA_C11" || spid == "SI_P2_C11") spseqs <- c('GAGGATCT', 'AGACCATA', 'TCCTGCGC', 'CTTATGAG')
  if(spid == "SI_GA_C12" || spid == "SI_P2_C12") spseqs <- c('TCTCGTTT', 'GGCTAGCG', 'ATGACCGC', 'CAAGTAAA')
  if(spid == "SI_GA_D1" || spid == "SI_P2_D1") spseqs <- c('CACTCGGA', 'GCTGAATT', 'TGAAGTAC', 'ATGCTCCG')
  if(spid == "SI_GA_D2" || spid == "SI_P2_D2") spseqs <- c('TAACAAGG', 'GGTTCCTC', 'ATCATGCA', 'CCGGGTAT')
  if(spid == "SI_GA_D3" || spid == "SI_P2_D3") spseqs <- c('ACATTACT', 'TTTGGGTA', 'CAGCCCAC', 'GGCAATGG')
  if(spid == "SI_GA_D4" || spid == "SI_P2_D4") spseqs <- c('CCCTAACA', 'ATTCCGAT', 'TGGATTGC', 'GAAGGCTG')
  if(spid == "SI_GA_D5" || spid == "SI_P2_D5") spseqs <- c('CTCGTCAC', 'GATCAGCA', 'ACAACAGG', 'TGGTGTTT')
  if(spid == "SI_GA_D6" || spid == "SI_P2_D6") spseqs <- c('CATGCGAT', 'TGATATTC', 'GTGATCGA', 'ACCCGACG')
  if(spid == "SI_GA_D7" || spid == "SI_P2_D7") spseqs <- c('ATTTGCTA', 'TAGACACC', 'CCACAGGG', 'GGCGTTAT')
  if(spid == "SI_GA_D8" || spid == "SI_P2_D8") spseqs <- c('GCAACAAA', 'TAGTTGTC', 'CGCCATCG', 'ATTGGCGT')
  if(spid == "SI_GA_D9" || spid == "SI_P2_D9") spseqs <- c('AGGAGATG', 'GATGTGGT', 'CTACATCC', 'TCCTCCAA')
  if(spid == "SI_GA_D10" || spid == "SI_P2_D10") spseqs <- c('CAATACCC', 'TGTCTATG', 'ACCACGAA', 'GTGGGTGT')
  if(spid == "SI_GA_D11" || spid == "SI_P2_D11") spseqs <- c('CTTTGCGG', 'TGCACAAA', 'AAGCAGTC', 'GCAGTTCT')
  if(spid == "SI_GA_D12" || spid == "SI_P2_D12") spseqs <- c('GCACAATG', 'CTTGGTAC', 'TGCACCGT', 'AAGTTGCA')
  if(spid == "SI_GA_E1" || spid == "SI_P2_E1") spseqs <- c('TGGTAAAC', 'GAAAGGGT', 'ACTGCTCG', 'CTCCTCTA')
  if(spid == "SI_GA_E2" || spid == "SI_P2_E2") spseqs <- c('GTGGTACC', 'TACTATAG', 'ACAAGGTA', 'CGTCCCGT')
  if(spid == "SI_GA_E3" || spid == "SI_P2_E3") spseqs <- c('AGGTATTG', 'CTCCTAGT', 'TCAAGGCC', 'GATGCCAA')
  if(spid == "SI_GA_E4" || spid == "SI_P2_E4") spseqs <- c('TTCGCCCT', 'GGATGGGC', 'AATCAATG', 'CCGATTAA')
  if(spid == "SI_GA_E5" || spid == "SI_P2_E5") spseqs <- c('CATTAGCG', 'TTCGCTGA', 'ACAAGAAT', 'GGGCTCTC')
  if(spid == "SI_GA_E6" || spid == "SI_P2_E6") spseqs <- c('CTGCGGCT', 'GACTCAAA', 'AGAAACTC', 'TCTGTTGG')
  if(spid == "SI_GA_E7" || spid == "SI_P2_E7") spseqs <- c('CACGCCTT', 'GTATATAG', 'TCTCGGGC', 'AGGATACA')
  if(spid == "SI_GA_E8" || spid == "SI_P2_E8") spseqs <- c('ATAGTTAC', 'TGCTGAGT', 'CCTACGTA', 'GAGCACCG')
  if(spid == "SI_GA_E9" || spid == "SI_P2_E9") spseqs <- c('TTGTTTCC', 'GGAGGAGG', 'CCTAACAA', 'AACCCGTT')
  if(spid == "SI_GA_E10" || spid == "SI_P2_E10") spseqs <- c('AAATGTGC', 'GGGCAAAT', 'TCTATCCG', 'CTCGCGTA')
  if(spid == "SI_GA_E11" || spid == "SI_P2_E11") spseqs <- c('AAGCGCTG', 'CGTTTGAT', 'GTAGCACA', 'TCCAATGC')
  if(spid == "SI_GA_E12" || spid == "SI_P2_E12") spseqs <- c('ACCGGCTC', 'GAGTTAGT', 'CGTCCTAG', 'TTAAAGCA')
  if(spid == "SI_GA_F1" || spid == "SI_P2_F1") spseqs <- c('GTTGCAGC', 'TGGAATTA', 'CAATGGAG', 'ACCCTCCT')
  if(spid == "SI_GA_F2" || spid == "SI_P2_F2") spseqs <- c('TTTACATG', 'CGCGATAC', 'ACGCGGGT', 'GAATTCCA')
  if(spid == "SI_GA_F3" || spid == "SI_P2_F3") spseqs <- c('TTCAGGTG', 'ACGGACAT', 'GATCTTGA', 'CGATCACC')
  if(spid == "SI_GA_F4" || spid == "SI_P2_F4") spseqs <- c('CCCAATAG', 'GTGTCGCT', 'AGAGTCGC', 'TATCGATA')
  if(spid == "SI_GA_F5" || spid == "SI_P2_F5") spseqs <- c('GACTACGT', 'CTAGCGAG', 'TCTATATC', 'AGGCGTCA')
  if(spid == "SI_GA_F6" || spid == "SI_P2_F6") spseqs <- c('CGGAGCAC', 'GACCTATT', 'ACTTAGGA', 'TTAGCTCG')
  if(spid == "SI_GA_F7" || spid == "SI_P2_F7") spseqs <- c('CGTGCAGA', 'AACAAGAT', 'TCGCTTCG', 'GTATGCTC')
  if(spid == "SI_GA_F8" || spid == "SI_P2_F8") spseqs <- c('CATGAACA', 'TCACTCGC', 'AGCTGGAT', 'GTGACTTG')
  if(spid == "SI_GA_F9" || spid == "SI_P2_F9") spseqs <- c('CAAGCTCC', 'GTTCACTG', 'TCGTGAAA', 'AGCATGGT')
  if(spid == "SI_GA_F10" || spid == "SI_P2_F10") spseqs <- c('GCTTGGCT', 'AAACAAAC', 'CGGGCTTA', 'TTCATCGG')
  if(spid == "SI_GA_F11" || spid == "SI_P2_F11") spseqs <- c('GCGAGAGT', 'TACGTTCA', 'AGTCCCAC', 'CTATAGTG')
  if(spid == "SI_GA_F12" || spid == "SI_P2_F12") spseqs <- c('TGATGCAT', 'GCTACTGA', 'CACCTGCC', 'ATGGAATG')
  if(spid == "SI_GA_G1" || spid == "SI_P2_G1") spseqs <- c('ATGAATCT', 'GATCTCAG', 'CCAGGAGC', 'TGCTCGTA')
  if(spid == "SI_GA_G2" || spid == "SI_P2_G2") spseqs <- c('TGATTCTA', 'ACTAGGAG', 'CAGCCACT', 'GTCGATGC')
  if(spid == "SI_GA_G3" || spid == "SI_P2_G3") spseqs <- c('CCTCATTC', 'AGCATCCG', 'GTGGCAAT', 'TAATGGGA')
  if(spid == "SI_GA_G4" || spid == "SI_P2_G4") spseqs <- c('GCGATGTG', 'AGATACAA', 'TTTCCACT', 'CACGGTGC')
  if(spid == "SI_GA_G5" || spid == "SI_P2_G5") spseqs <- c('GAGCAAGA', 'TCTGTGAT', 'CGCAGTTC', 'ATATCCCG')
  if(spid == "SI_GA_G6" || spid == "SI_P2_G6") spseqs <- c('CTGACGCG', 'GGTCGTAC', 'TCCTTCTT', 'AAAGAAGA')
  if(spid == "SI_GA_G7" || spid == "SI_P2_G7") spseqs <- c('GGTATGCA', 'CTCGAAAT', 'ACACCTTC', 'TAGTGCGG')
  if(spid == "SI_GA_G8" || spid == "SI_P2_G8") spseqs <- c('TATGAGCT', 'CCGATAGC', 'ATACCCAA', 'GGCTGTTG')
  if(spid == "SI_GA_G9" || spid == "SI_P2_G9") spseqs <- c('TAGGACGT', 'ATCCCACA', 'GGAATGTC', 'CCTTGTAG')
  if(spid == "SI_GA_G10" || spid == "SI_P2_G10") spseqs <- c('TCGCCAGC', 'AATGTTAG', 'CGATAGCT', 'GTCAGCTA')
  if(spid == "SI_GA_G11" || spid == "SI_P2_G11") spseqs <- c('TTATCGTT', 'AGCAGAGC', 'CATCTCCA', 'GCGGATAG')
  if(spid == "SI_GA_G12" || spid == "SI_P2_G12") spseqs <- c('ATTCTAAG', 'CCCGATTA', 'TGGAGGCT', 'GAATCCGC')
  if(spid == "SI_GA_H1" || spid == "SI_P2_H1") spseqs <- c('GTATGTCA', 'TGTCAGAC', 'CACGTCGG', 'ACGACATT')
  if(spid == "SI_GA_H2" || spid == "SI_P2_H2") spseqs <- c('TAATGACC', 'ATGCCTTA', 'GCCGAGAT', 'CGTATCGG')
  if(spid == "SI_GA_H3" || spid == "SI_P2_H3") spseqs <- c('CCAAGATG', 'AGGCCCGA', 'TACGTGAC', 'GTTTATCT')
  if(spid == "SI_GA_H4" || spid == "SI_P2_H4") spseqs <- c('GCCATTCC', 'CAAGAATT', 'TTGCCGGA', 'AGTTGCAG')
  if(spid == "SI_GA_H5" || spid == "SI_P2_H5") spseqs <- c('CCACTACA', 'GATTCTGG', 'TGCGGCTT', 'ATGAAGAC')
  if(spid == "SI_GA_H6" || spid == "SI_P2_H6") spseqs <- c('TAGGATAA', 'CCTTTGTC', 'GTACGCGG', 'AGCACACT')
  if(spid == "SI_GA_H7" || spid == "SI_P2_H7") spseqs <- c('AGCTATCA', 'CATATAAC', 'TCAGGGTG', 'GTGCCCGT')
  if(spid == "SI_GA_H8" || spid == "SI_P2_H8") spseqs <- c('TTGTTGAT', 'GCTCAACC', 'CAAAGTGG', 'AGCGCCTA')
  if(spid == "SI_GA_H9" || spid == "SI_P2_H9") spseqs <- c('ACACTGTT', 'CAGGATGG', 'GGCTGAAC', 'TTTACCCA')
  if(spid == "SI_GA_H10" || spid == "SI_P2_H10") spseqs <- c('GTAATTGC', 'AGTCGCTT', 'CACGAGAA', 'TCGTCACG')
  if(spid == "SI_GA_H11" || spid == "SI_P2_H11") spseqs <- c('GGCGAGTA', 'ACTTCTAT', 'CAAATACG', 'TTGCGCGC')
  if(spid == "SI_GA_H12" || spid == "SI_P2_H12") spseqs <- c('GACAGCAT', 'TTTGTACA', 'AGGCCGTG', 'CCATATGC')

  dualseqs <- NA

  if(spid == "SI-TT-A1" || spid == "SI_TT_A1") dualseqs <- c('GTAACATGCG','AGTGTTACCT','AGGTAACACT')
  if(spid == "SI-TT-A2" || spid == "SI_TT_A2") dualseqs <- c('GTGGATCAAA','GCCAACCCTG','CAGGGTTGGC')
  if(spid == "SI-TT-A3" || spid == "SI_TT_A3") dualseqs <- c('CACTACGAAA','TTAGACTGAT','ATCAGTCTAA')
  if(spid == "SI-TT-A4" || spid == "SI_TT_A4") dualseqs <- c('CTCTAGCGAG','TATCTTCATC','GATGAAGATA')
  if(spid == "SI-TT-A5" || spid == "SI_TT_A5") dualseqs <- c('GTAGCCCTGT','GAGCATCTAT','ATAGATGCTC')
  if(spid == "SI-TT-A6" || spid == "SI_TT_A6") dualseqs <- c('TAACGCGTGA','CCCTAACTTC','GAAGTTAGGG')
  if(spid == "SI-TT-A7" || spid == "SI_TT_A7") dualseqs <- c('TCCCAAGGGT','TACTACCTTT','AAAGGTAGTA')
  if(spid == "SI-TT-A8" || spid == "SI_TT_A8") dualseqs <- c('CGAAGTATAC','GAACTTGGAG','CTCCAAGTTC')
  if(spid == "SI-TT-A9" || spid == "SI_TT_A9") dualseqs <- c('AAGTGGAGAG','TTCCTGTTAC','GTAACAGGAA')
  if(spid == "SI-TT-A10" || spid == "SI_TT_A10") dualseqs <- c('CGTGACATGC','ATGGTCTAAA','TTTAGACCAT')
  if(spid == "SI-TT-A11" || spid == "SI_TT_A11") dualseqs <- c('CGGAACCCAA','GATTCGAGGA','TCCTCGAATC')
  if(spid == "SI-TT-A12" || spid == "SI_TT_A12") dualseqs <- c('CACCGCACCA','GACTGTCAAT','ATTGACAGTC')
  if(spid == "SI-TT-B1" || spid == "SI_TT_B1") dualseqs <- c('ACAGTAACTA','ACAGTTCGTT','AACGAACTGT')
  if(spid == "SI-TT-B2" || spid == "SI_TT_B2") dualseqs <- c('TCTACCATTT','CGGGAGAGTC','GACTCTCCCG')
  if(spid == "SI-TT-B3" || spid == "SI_TT_B3") dualseqs <- c('CACGGTGAAT','GTTCGTCACA','TGTGACGAAC')
  if(spid == "SI-TT-B4" || spid == "SI_TT_B4") dualseqs <- c('GTAGACGAAA','CTAGTGTGGT','ACCACACTAG')
  if(spid == "SI-TT-B5" || spid == "SI_TT_B5") dualseqs <- c('TCGGCTCTAC','CCGATGGTCT','AGACCATCGG')
  if(spid == "SI-TT-B6" || spid == "SI_TT_B6") dualseqs <- c('AATGCCATGA','TACGTAATGC','GCATTACGTA')
  if(spid == "SI-TT-B7" || spid == "SI_TT_B7") dualseqs <- c('GCCTTCGGTA','CCAACGATTT','AAATCGTTGG')
  if(spid == "SI-TT-B8" || spid == "SI_TT_B8") dualseqs <- c('GCACTGAGAA','TATGCGTGAA','TTCACGCATA')
  if(spid == "SI-TT-B9" || spid == "SI_TT_B9") dualseqs <- c('TATTGAGGCA','CAGGTAAGTG','CACTTACCTG')
  if(spid == "SI-TT-B10" || spid == "SI_TT_B10") dualseqs <- c('GCCCGATGGA','AATCGTCTAG','CTAGACGATT')
  if(spid == "SI-TT-B11" || spid == "SI_TT_B11") dualseqs <- c('TCTTACTTGC','TGACCTCTAG','CTAGAGGTCA')
  if(spid == "SI-TT-B12" || spid == "SI_TT_B12") dualseqs <- c('CGTCAAGGGC','TAGGTCACTC','GAGTGACCTA')
  if(spid == "SI-TT-C1" || spid == "SI_TT_C1") dualseqs <- c('TGCGCGGTTT','CAAGGATAAA','TTTATCCTTG')
  if(spid == "SI-TT-C2" || spid == "SI_TT_C2") dualseqs <- c('CAATCCCGAC','CCGAGTAGTA','TACTACTCGG')
  if(spid == "SI-TT-C3" || spid == "SI_TT_C3") dualseqs <- c('ATGGCTTGTG','GAATGTTGTG','CACAACATTC')
  if(spid == "SI-TT-C4" || spid == "SI_TT_C4") dualseqs <- c('TTCTCGATGA','TGTCGGGCAC','GTGCCCGACA')
  if(spid == "SI-TT-C5" || spid == "SI_TT_C5") dualseqs <- c('TCCGTTGGAT','ACGTTCTCGC','GCGAGAACGT')
  if(spid == "SI-TT-C6" || spid == "SI_TT_C6") dualseqs <- c('ACGACTACCA','ACGACCCTAA','TTAGGGTCGT')
  if(spid == "SI-TT-C7" || spid == "SI_TT_C7") dualseqs <- c('CGCGCACTTA','CCTGTATTCT','AGAATACAGG')
  if(spid == "SI-TT-C8" || spid == "SI_TT_C8") dualseqs <- c('GCTACAAAGC','CACGTGCCCT','AGGGCACGTG')
  if(spid == "SI-TT-C9" || spid == "SI_TT_C9") dualseqs <- c('TATCAGCCTA','GTTTCGTCCT','AGGACGAAAC')
  if(spid == "SI-TT-C10" || spid == "SI_TT_C10") dualseqs <- c('AGAATGGTTT','GAGGGTGGGA','TCCCACCCTC')
  if(spid == "SI-TT-C11" || spid == "SI_TT_C11") dualseqs <- c('ATGGGTGAAA','CTTGGGAATT','AATTCCCAAG')
  if(spid == "SI-TT-C12" || spid == "SI_TT_C12") dualseqs <- c('TCGTCAAGAT','GCAACTCAGG','CCTGAGTTGC')
  if(spid == "SI-TT-D1" || spid == "SI_TT_D1") dualseqs <- c('TGCAATGTTC','GCTTGTCGAA','TTCGACAAGC')
  if(spid == "SI-TT-D2" || spid == "SI_TT_D2") dualseqs <- c('TTAATACGCG','CACCTCGGGT','ACCCGAGGTG')
  if(spid == "SI-TT-D3" || spid == "SI_TT_D3") dualseqs <- c('CCTTCTAGAG','AATACAACGA','TCGTTGTATT')
  if(spid == "SI-TT-D4" || spid == "SI_TT_D4") dualseqs <- c('GCAGTATAGG','TTCCGTGCAC','GTGCACGGAA')
  if(spid == "SI-TT-D5" || spid == "SI_TT_D5") dualseqs <- c('TGGTTCGGGT','GTGGCAGGAG','CTCCTGCCAC')
  if(spid == "SI-TT-D6" || spid == "SI_TT_D6") dualseqs <- c('CCCAGCTTCT','GACACCAAAC','GTTTGGTGTC')
  if(spid == "SI-TT-D7" || spid == "SI_TT_D7") dualseqs <- c('CCTGTCAGGG','AGCCCGTAAC','GTTACGGGCT')
  if(spid == "SI-TT-D8" || spid == "SI_TT_D8") dualseqs <- c('CGCTGAAATC','AGGTGTCTGC','GCAGACACCT')
  if(spid == "SI-TT-D9" || spid == "SI_TT_D9") dualseqs <- c('TGGTCCCAAG','CCTCTGGCGT','ACGCCAGAGG')
  if(spid == "SI-TT-D10" || spid == "SI_TT_D10") dualseqs <- c('ATGCGAATGG','ACAAGTGTCG','CGACACTTGT')
  if(spid == "SI-TT-D11" || spid == "SI_TT_D11") dualseqs <- c('CGAATATTCG','CTGGAAGCAA','TTGCTTCCAG')
  if(spid == "SI-TT-D12" || spid == "SI_TT_D12") dualseqs <- c('GAATTGGTTA','ACTCTAGTAG','CTACTAGAGT')
  if(spid == "SI-TT-E1" || spid == "SI_TT_E1") dualseqs <- c('TTATTCGAGG','CTGTCCTGCT','AGCAGGACAG')
  if(spid == "SI-TT-E2" || spid == "SI_TT_E2") dualseqs <- c('ATGGAGGGAG','ATAACCCATT','AATGGGTTAT')
  if(spid == "SI-TT-E3" || spid == "SI_TT_E3") dualseqs <- c('ACCAGACAAC','AGGAACTAGG','CCTAGTTCCT')
  if(spid == "SI-TT-E4" || spid == "SI_TT_E4") dualseqs <- c('AACCACGCAT','ATTCAGGTTA','TAACCTGAAT')
  if(spid == "SI-TT-E5" || spid == "SI_TT_E5") dualseqs <- c('CGCGGTAGGT','CAGGATGTTG','CAACATCCTG')
  if(spid == "SI-TT-E6" || spid == "SI_TT_E6") dualseqs <- c('TTGAGAGTCA','AACCTGGTAG','CTACCAGGTT')
  if(spid == "SI-TT-E7" || spid == "SI_TT_E7") dualseqs <- c('GTCCTTCGGC','TCATGCACAG','CTGTGCATGA')
  if(spid == "SI-TT-E8" || spid == "SI_TT_E8") dualseqs <- c('GAGCAAGGGC','ATTGACTTGG','CCAAGTCAAT')
  if(spid == "SI-TT-E9" || spid == "SI_TT_E9") dualseqs <- c('TGTCCCAACG','TCGATGTCCA','TGGACATCGA')
  if(spid == "SI-TT-E10" || spid == "SI_TT_E10") dualseqs <- c('CACAATCCCA','ATATCCACAA','TTGTGGATAT')
  if(spid == "SI-TT-E11" || spid == "SI_TT_E11") dualseqs <- c('TCCGGGACAA','GTGAATGCCA','TGGCATTCAC')
  if(spid == "SI-TT-E12" || spid == "SI_TT_E12") dualseqs <- c('CGTCCACCTG','CATTCATGAC','GTCATGAATG')
  if(spid == "SI-TT-F1" || spid == "SI_TT_F1") dualseqs <- c('AAGATTGGAT','AGCGGGATTT','AAATCCCGCT')
  if(spid == "SI-TT-F2" || spid == "SI_TT_F2") dualseqs <- c('AAGGGCCGCA','CTGATTCCTC','GAGGAATCAG')
  if(spid == "SI-TT-F3" || spid == "SI_TT_F3") dualseqs <- c('GAGAGGATAT','TTGAAATGGG','CCCATTTCAA')
  if(spid == "SI-TT-F4" || spid == "SI_TT_F4") dualseqs <- c('CCCACCACAA','ACCTCCGCTT','AAGCGGAGGT')
  if(spid == "SI-TT-F5" || spid == "SI_TT_F5") dualseqs <- c('CGGCTGGATG','TGATAAGCAC','GTGCTTATCA')
  if(spid == "SI-TT-F6" || spid == "SI_TT_F6") dualseqs <- c('TTGCCCGTGC','GCGTGAGATT','AATCTCACGC')
  if(spid == "SI-TT-F7" || spid == "SI_TT_F7") dualseqs <- c('AATGTATCCA','AATGAGCTTA','TAAGCTCATT')
  if(spid == "SI-TT-F8" || spid == "SI_TT_F8") dualseqs <- c('CTCCTTTAGA','GACATAGCTC','GAGCTATGTC')
  if(spid == "SI-TT-F9" || spid == "SI_TT_F9") dualseqs <- c('GTCCCATCAA','CGAACGTGAC','GTCACGTTCG')
  if(spid == "SI-TT-F10" || spid == "SI_TT_F10") dualseqs <- c('CCGGCAACTG','CGGTTTAACA','TGTTAAACCG')
  if(spid == "SI-TT-F11" || spid == "SI_TT_F11") dualseqs <- c('TTCACACCTT','TAGTGTACAC','GTGTACACTA')
  if(spid == "SI-TT-F12" || spid == "SI_TT_F12") dualseqs <- c('GAGACGCACG','CTATGAACAT','ATGTTCATAG')
  if(spid == "SI-TT-G1" || spid == "SI_TT_G1") dualseqs <- c('TGTAGTCATT','CTTGATCGTA','TACGATCAAG')
  if(spid == "SI-TT-G2" || spid == "SI_TT_G2") dualseqs <- c('CATGTGGGTT','GATTCCTTTA','TAAAGGAATC')
  if(spid == "SI-TT-G3" || spid == "SI_TT_G3") dualseqs <- c('ATGACGTCGC','AGGTCAGGAT','ATCCTGACCT')
  if(spid == "SI-TT-G4" || spid == "SI_TT_G4") dualseqs <- c('GCGCTTATGG','GCCTGGCTAG','CTAGCCAGGC')
  if(spid == "SI-TT-G5" || spid == "SI_TT_G5") dualseqs <- c('ATAGGGCGAG','TGCATCGAGT','ACTCGATGCA')
  if(spid == "SI-TT-G6" || spid == "SI_TT_G6") dualseqs <- c('GCGGGTAAGT','TAGCACTAAG','CTTAGTGCTA')
  if(spid == "SI-TT-G7" || spid == "SI_TT_G7") dualseqs <- c('GTTTCACGAT','TTCGGCCAAA','TTTGGCCGAA')
  if(spid == "SI-TT-G8" || spid == "SI_TT_G8") dualseqs <- c('TAAGCAACTG','CTATACTCAA','TTGAGTATAG')
  if(spid == "SI-TT-G9" || spid == "SI_TT_G9") dualseqs <- c('CCGGAGGAAG','TGCGGATGTT','AACATCCGCA')
  if(spid == "SI-TT-G10" || spid == "SI_TT_G10") dualseqs <- c('ACTTTACGTG','TGAACGCCCT','AGGGCGTTCA')
  if(spid == "SI-TT-G11" || spid == "SI_TT_G11") dualseqs <- c('GATAACCTGC','CATTAGAAAC','GTTTCTAATG')
  if(spid == "SI-TT-G12" || spid == "SI_TT_G12") dualseqs <- c('CTTGCATAAA','ATCAGGGCTT','AAGCCCTGAT')
  if(spid == "SI-TT-H1" || spid == "SI_TT_H1") dualseqs <- c('ACAATGTGAA','CGTACCGTTA','TAACGGTACG')
  if(spid == "SI-TT-H2" || spid == "SI_TT_H2") dualseqs <- c('TAGCATAGTG','CGGCTCTGTC','GACAGAGCCG')
  if(spid == "SI-TT-H3" || spid == "SI_TT_H3") dualseqs <- c('CCCGTTCTCG','GACGGATTGG','CCAATCCGTC')
  if(spid == "SI-TT-H4" || spid == "SI_TT_H4") dualseqs <- c('AGTTTCCTGG','TGCCACACAG','CTGTGTGGCA')
  if(spid == "SI-TT-H5" || spid == "SI_TT_H5") dualseqs <- c('AGCAAGAAGC','TTGTGTTTCT','AGAAACACAA')
  if(spid == "SI-TT-H6" || spid == "SI_TT_H6") dualseqs <- c('CCTATCCTCG','GAATACTAAC','GTTAGTATTC')
  if(spid == "SI-TT-H7" || spid == "SI_TT_H7") dualseqs <- c('ACCTCGAGCT','TGTGTTCGAT','ATCGAACACA')
  if(spid == "SI-TT-H8" || spid == "SI_TT_H8") dualseqs <- c('ATAAGGATAC','ATAGATAGGG','CCCTATCTAT')
  if(spid == "SI-TT-H9" || spid == "SI_TT_H9") dualseqs <- c('AGAACTTAGA','CGAGTCCTTT','AAAGGACTCG')
  if(spid == "SI-TT-H10" || spid == "SI_TT_H10") dualseqs <- c('TTATCTAGGG','AAAGGCTCTA','TAGAGCCTTT')
  if(spid == "SI-TT-H11" || spid == "SI_TT_H11") dualseqs <- c('ACAATCGATC','TGACGGAATG','CATTCCGTCA')
  if(spid == "SI-TT-H12" || spid == "SI_TT_H12") dualseqs <- c('TGATGATTCA','GTAGGAGTCG','CGACTCCTAC')

  if(spid == "SI-NN-A1" || spid == "SI_NN_A1") dualseqs <- c('GCCTTGTCAA','GATCCAATCA','TGATTGGATC')
  if(spid == "SI-NN-A2" || spid == "SI_NN_A2") dualseqs <- c('AACTTCTTTG','ATAAGCGGTA','TACCGCTTAT')
  if(spid == "SI-NN-A3" || spid == "SI_NN_A3") dualseqs <- c('TGGTTATAGA','GAGCTCATAA','TTATGAGCTC')
  if(spid == "SI-NN-A4" || spid == "SI_NN_A4") dualseqs <- c('GTAGTGCATC','ATTTGACGGT','ACCGTCAAAT')
  if(spid == "SI-NN-A5" || spid == "SI_NN_A5") dualseqs <- c('GCTTGATTTA','CGGGTGTGAC','GTCACACCCG')
  if(spid == "SI-NN-A6" || spid == "SI_NN_A6") dualseqs <- c('GAAGTTTCGC','TTTCAAAGCA','TGCTTTGAAA')
  if(spid == "SI-NN-A7" || spid == "SI_NN_A7") dualseqs <- c('GCAGTTGTTT','ACACTACTTT','AAAGTAGTGT')
  if(spid == "SI-NN-A8" || spid == "SI_NN_A8") dualseqs <- c('GCCGCAAGTA','AAAGGTCCGC','GCGGACCTTT')
  if(spid == "SI-NN-A9" || spid == "SI_NN_A9") dualseqs <- c('AAGTTGTATG','TGTACAATGC','GCATTGTACA')
  if(spid == "SI-NN-A10" || spid == "SI_NN_A10") dualseqs <- c('AGCAACCTTT','TTCAGCGCTA','TAGCGCTGAA')
  if(spid == "SI-NN-A11" || spid == "SI_NN_A11") dualseqs <- c('GACGAGGGTT','TTACTTTGAC','GTCAAAGTAA')
  if(spid == "SI-NN-A12" || spid == "SI_NN_A12") dualseqs <- c('TGAACAGTCG','ATTTCTCAGA','TCTGAGAAAT')
  if(spid == "SI-NN-B1" || spid == "SI_NN_B1") dualseqs <- c('CGAAAGGAGT','ACACCAAACA','TGTTTGGTGT')
  if(spid == "SI-NN-B2" || spid == "SI_NN_B2") dualseqs <- c('GAATGACTTG','TGAGCTCGCT','AGCGAGCTCA')
  if(spid == "SI-NN-B3" || spid == "SI_NN_B3") dualseqs <- c('GCCAGGGATT','CAAGTTTAGG','CCTAAACTTG')
  if(spid == "SI-NN-B4" || spid == "SI_NN_B4") dualseqs <- c('CTTTGTCCGC','GCTGTCCCGT','ACGGGACAGC')
  if(spid == "SI-NN-B5" || spid == "SI_NN_B5") dualseqs <- c('AGCTTGGGTG','AGCGTATAGT','ACTATACGCT')
  if(spid == "SI-NN-B6" || spid == "SI_NN_B6") dualseqs <- c('TCGCACCGGT','TAGCCTCAGG','CCTGAGGCTA')
  if(spid == "SI-NN-B7" || spid == "SI_NN_B7") dualseqs <- c('TTTAGGTAGG','ACTGAGGGAC','GTCCCTCAGT')
  if(spid == "SI-NN-B8" || spid == "SI_NN_B8") dualseqs <- c('GTTCGAGCGG','CTGTGGGTTT','AAACCCACAG')
  if(spid == "SI-NN-B9" || spid == "SI_NN_B9") dualseqs <- c('AGGGTATGGC','GAGTCCGACT','AGTCGGACTC')
  if(spid == "SI-NN-B10" || spid == "SI_NN_B10") dualseqs <- c('TACCCACTAT','TGGAACATAT','ATATGTTCCA')
  if(spid == "SI-NN-B11" || spid == "SI_NN_B11") dualseqs <- c('TTCAGGCTAC','CTGGGTATTG','CAATACCCAG')
  if(spid == "SI-NN-B12" || spid == "SI_NN_B12") dualseqs <- c('AGGAATAGAT','TGCGGTCACG','CGTGACCGCA')
  if(spid == "SI-NN-C1" || spid == "SI_NN_C1") dualseqs <- c('ACAGCGCTGT','GAGGGTCATC','GATGACCCTC')
  if(spid == "SI-NN-C2" || spid == "SI_NN_C2") dualseqs <- c('GACGTACGGA','ACCTCGCTTT','AAAGCGAGGT')
  if(spid == "SI-NN-C3" || spid == "SI_NN_C3") dualseqs <- c('CTTAGATGCA','CTATTCGACT','AGTCGAATAG')
  if(spid == "SI-NN-C4" || spid == "SI_NN_C4") dualseqs <- c('ACTCCTCAAC','ATTCACGGGA','TCCCGTGAAT')
  if(spid == "SI-NN-C5" || spid == "SI_NN_C5") dualseqs <- c('TCCATACTGT','GAGCGACTTC','GAAGTCGCTC')
  if(spid == "SI-NN-C6" || spid == "SI_NN_C6") dualseqs <- c('GCCAGAATGG','GAATTGTATC','GATACAATTC')
  if(spid == "SI-NN-C7" || spid == "SI_NN_C7") dualseqs <- c('ATTGCAAGAC','CGGTGACCAT','ATGGTCACCG')
  if(spid == "SI-NN-C8" || spid == "SI_NN_C8") dualseqs <- c('CAACATATCG','AACTAAAGGC','GCCTTTAGTT')
  if(spid == "SI-NN-C9" || spid == "SI_NN_C9") dualseqs <- c('CAGGGACCTC','AATAGCAGCA','TGCTGCTATT')
  if(spid == "SI-NN-C10" || spid == "SI_NN_C10") dualseqs <- c('ATTTGGGAAT','TCAGCCGAGT','ACTCGGCTGA')
  if(spid == "SI-NN-C11" || spid == "SI_NN_C11") dualseqs <- c('TGGATAATTG','TTTGTGATCA','TGATCACAAA')
  if(spid == "SI-NN-C12" || spid == "SI_NN_C12") dualseqs <- c('CAGATTATGA','GTGCCTGTAC','GTACAGGCAC')
  if(spid == "SI-NN-D1" || spid == "SI_NN_D1") dualseqs <- c('AATGGTAAGC','CTGTGAAGTT','AACTTCACAG')
  if(spid == "SI-NN-D2" || spid == "SI_NN_D2") dualseqs <- c('CATCCCTCGG','AGGGTAGGCG','CGCCTACCCT')
  if(spid == "SI-NN-D3" || spid == "SI_NN_D3") dualseqs <- c('CTGGTCCGTC','ACGAATAAGG','CCTTATTCGT')
  if(spid == "SI-NN-D4" || spid == "SI_NN_D4") dualseqs <- c('GTCGTAAATT','GTAGTAGGCT','AGCCTACTAC')
  if(spid == "SI-NN-D5" || spid == "SI_NN_D5") dualseqs <- c('CAACACTGAT','CAAACCAGGG','CCCTGGTTTG')
  if(spid == "SI-NN-D6" || spid == "SI_NN_D6") dualseqs <- c('CAGACTGAAT','TGCCTAACCG','CGGTTAGGCA')
  if(spid == "SI-NN-D7" || spid == "SI_NN_D7") dualseqs <- c('CGGACACGCT','TCACGATATA','TATATCGTGA')
  if(spid == "SI-NN-D8" || spid == "SI_NN_D8") dualseqs <- c('CTCGGCTCTC','TATACTTCCA','TGGAAGTATA')
  if(spid == "SI-NN-D9" || spid == "SI_NN_D9") dualseqs <- c('AAGCCTATCA','GTAGTGAACA','TGTTCACTAC')
  if(spid == "SI-NN-D10" || spid == "SI_NN_D10") dualseqs <- c('ACTGTGCCAA','TAACCGTTAT','ATAACGGTTA')
  if(spid == "SI-NN-D11" || spid == "SI_NN_D11") dualseqs <- c('CTACTCCCAT','TACGTTGCGG','CCGCAACGTA')
  if(spid == "SI-NN-D12" || spid == "SI_NN_D12") dualseqs <- c('AGACTCTAAC','GTGTCGATGT','ACATCGACAC')
  if(spid == "SI-NN-E1" || spid == "SI_NN_E1") dualseqs <- c('TGAGCCGGCA','TGCTGCATGT','ACATGCAGCA')
  if(spid == "SI-NN-E2" || spid == "SI_NN_E2") dualseqs <- c('TAGCTTGCGT','GCTGCTAAAG','CTTTAGCAGC')
  if(spid == "SI-NN-E3" || spid == "SI_NN_E3") dualseqs <- c('GTACACCGGG','AACAGTCGCG','CGCGACTGTT')
  if(spid == "SI-NN-E4" || spid == "SI_NN_E4") dualseqs <- c('CGCGTAGACG','AAAGTAGCTG','CAGCTACTTT')
  if(spid == "SI-NN-E5" || spid == "SI_NN_E5") dualseqs <- c('CCGATATATT','AACTATCCGA','TCGGATAGTT')
  if(spid == "SI-NN-E6" || spid == "SI_NN_E6") dualseqs <- c('TTGGGCGGGA','ATGTATCTGT','ACAGATACAT')
  if(spid == "SI-NN-E7" || spid == "SI_NN_E7") dualseqs <- c('GTTTATGAGG','GCCAAACAGC','GCTGTTTGGC')
  if(spid == "SI-NN-E8" || spid == "SI_NN_E8") dualseqs <- c('TTGGATACTC','CGTACTGAAG','CTTCAGTACG')
  if(spid == "SI-NN-E9" || spid == "SI_NN_E9") dualseqs <- c('GCTATCTATC','AAAGATGGAT','ATCCATCTTT')
  if(spid == "SI-NN-E10" || spid == "SI_NN_E10") dualseqs <- c('ATGTGATCGC','TGACCTACCT','AGGTAGGTCA')
  if(spid == "SI-NN-E11" || spid == "SI_NN_E11") dualseqs <- c('TCCTCACATG','AACAGATTCA','TGAATCTGTT')
  if(spid == "SI-NN-E12" || spid == "SI_NN_E12") dualseqs <- c('GCCTCCTAAT','CTCCTCCTGT','ACAGGAGGAG')
  if(spid == "SI-NN-F1" || spid == "SI_NN_F1") dualseqs <- c('CGAGGCTGAT','TCGACTTTCT','AGAAAGTCGA')
  if(spid == "SI-NN-F2" || spid == "SI_NN_F2") dualseqs <- c('CTCATGACAT','TGTTCCGCAC','GTGCGGAACA')
  if(spid == "SI-NN-F3" || spid == "SI_NN_F3") dualseqs <- c('AACGCGGCAA','GCCCGTTTAC','GTAAACGGGC')
  if(spid == "SI-NN-F4" || spid == "SI_NN_F4") dualseqs <- c('AACACCTCTC','GATTGTATGA','TCATACAATC')
  if(spid == "SI-NN-F5" || spid == "SI_NN_F5") dualseqs <- c('AAATAACGCG','ATAGAGGAGC','GCTCCTCTAT')
  if(spid == "SI-NN-F6" || spid == "SI_NN_F6") dualseqs <- c('GAAATCTTGT','TAGACGCCAC','GTGGCGTCTA')
  if(spid == "SI-NN-F7" || spid == "SI_NN_F7") dualseqs <- c('TAGATGGACT','CCAGGGATAT','ATATCCCTGG')
  if(spid == "SI-NN-F8" || spid == "SI_NN_F8") dualseqs <- c('CAATCTGTAT','TCCCATCGTT','AACGATGGGA')
  if(spid == "SI-NN-F9" || spid == "SI_NN_F9") dualseqs <- c('GCGAAAGTAT','GTGTCACAGA','TCTGTGACAC')
  if(spid == "SI-NN-F10" || spid == "SI_NN_F10") dualseqs <- c('CCCAGAGCTT','ATGCTGTAAT','ATTACAGCAT')
  if(spid == "SI-NN-F11" || spid == "SI_NN_F11") dualseqs <- c('GACTACAGGA','AGTGACAAAG','CTTTGTCACT')
  if(spid == "SI-NN-F12" || spid == "SI_NN_F12") dualseqs <- c('CAATTCATGG','ACGTAGTTCG','CGAACTACGT')
  if(spid == "SI-NN-G1" || spid == "SI_NN_G1") dualseqs <- c('TGGGAAGGGC','ACTAACGATG','CATCGTTAGT')
  if(spid == "SI-NN-G2" || spid == "SI_NN_G2") dualseqs <- c('TACTTCGCAT','AACGGTGTCG','CGACACCGTT')
  if(spid == "SI-NN-G3" || spid == "SI_NN_G3") dualseqs <- c('TAAACTGGCA','CCGACCTCTT','AAGAGGTCGG')
  if(spid == "SI-NN-G4" || spid == "SI_NN_G4") dualseqs <- c('TTGAAGAACT','CAACACCAGG','CCTGGTGTTG')
  if(spid == "SI-NN-G5" || spid == "SI_NN_G5") dualseqs <- c('TCCCTCGTCA','ATCAGGTGTG','CACACCTGAT')
  if(spid == "SI-NN-G6" || spid == "SI_NN_G6") dualseqs <- c('ACTGGCCTAA','CGCTCCCTTG','CAAGGGAGCG')
  if(spid == "SI-NN-G7" || spid == "SI_NN_G7") dualseqs <- c('TCATAATGCA','GATGAGGCGA','TCGCCTCATC')
  if(spid == "SI-NN-G8" || spid == "SI_NN_G8") dualseqs <- c('CGCCACGTTA','CTTTCATAGG','CCTATGAAAG')
  if(spid == "SI-NN-G9" || spid == "SI_NN_G9") dualseqs <- c('TGGACTAAGC','CTTAACATCG','CGATGTTAAG')
  if(spid == "SI-NN-G10" || spid == "SI_NN_G10") dualseqs <- c('AAGCCCGGCA','GAGTTTCCGT','ACGGAAACTC')
  if(spid == "SI-NN-G11" || spid == "SI_NN_G11") dualseqs <- c('ATAGTGGCGG','TACTGTTGTT','AACAACAGTA')
  if(spid == "SI-NN-G12" || spid == "SI_NN_G12") dualseqs <- c('CCAACCGGAC','GTTCTATCTA','TAGATAGAAC')
  if(spid == "SI-NN-H1" || spid == "SI_NN_H1") dualseqs <- c('TTACAGAGGG','GTTTATGGCA','TGCCATAAAC')
  if(spid == "SI-NN-H2" || spid == "SI_NN_H2") dualseqs <- c('TCCAACAACG','GTCCGGGTTT','AAACCCGGAC')
  if(spid == "SI-NN-H3" || spid == "SI_NN_H3") dualseqs <- c('AAAGCATGTC','AGATACTACT','AGTAGTATCT')
  if(spid == "SI-NN-H4" || spid == "SI_NN_H4") dualseqs <- c('AGAAGTCGTT','AGGACATTTA','TAAATGTCCT')
  if(spid == "SI-NN-H5" || spid == "SI_NN_H5") dualseqs <- c('GCTAGCGTTC','TCGCGTGGTG','CACCACGCGA')
  if(spid == "SI-NN-H6" || spid == "SI_NN_H6") dualseqs <- c('CAACTAGCTT','TCAACTAATC','GATTAGTTGA')
  if(spid == "SI-NN-H7" || spid == "SI_NN_H7") dualseqs <- c('AGGGCCAGTT','TAGGGCAAAT','ATTTGCCCTA')
  if(spid == "SI-NN-H8" || spid == "SI_NN_H8") dualseqs <- c('CTCTATGCGT','CCTCTGATGC','GCATCAGAGG')
  if(spid == "SI-NN-H9" || spid == "SI_NN_H9") dualseqs <- c('GTCCATACAA','AGCCACTCAC','GTGAGTGGCT')
  if(spid == "SI-NN-H10" || spid == "SI_NN_H10") dualseqs <- c('AGGGATGCAA','CTCATATCCT','AGGATATGAG')
  if(spid == "SI-NN-H11" || spid == "SI_NN_H11") dualseqs <- c('TTCAAGTCCT','CAGCAGCTAA','TTAGCTGCTG')
  if(spid == "SI-NN-H12" || spid == "SI_NN_H12") dualseqs <- c('CTCCAACCTA','GCACCGCATC','GATGCGGTGC')


  if(spid == "SI-NT-A1" || spid == "SI_NT_A1") dualseqs <- c('ATTTACCGCA','GACAATAAAG','CTTTATTGTC')
  if(spid == "SI-NT-A2" || spid == "SI_NT_A2") dualseqs <- c('TTGTCGTAGA','CAATGTAGCA','TGCTACATTG')
  if(spid == "SI-NT-A3" || spid == "SI_NT_A3") dualseqs <- c('AGTCCTGCGG','TGACACAAGT','ACTTGTGTCA')
  if(spid == "SI-NT-A4" || spid == "SI_NT_A4") dualseqs <- c('TTGTTCATGT','TGACAGCTGA','TCAGCTGTCA')
  if(spid == "SI-NT-A5" || spid == "SI_NT_A5") dualseqs <- c('TCAGGAAGGA','GAACGTGCTT','AAGCACGTTC')
  if(spid == "SI-NT-A6" || spid == "SI_NT_A6") dualseqs <- c('CTGTTAGAGG','CCACGCTTCG','CGAAGCGTGG')
  if(spid == "SI-NT-A7" || spid == "SI_NT_A7") dualseqs <- c('AGATGAGAAT','GTCGACGGGT','ACCCGTCGAC')
  if(spid == "SI-NT-A8" || spid == "SI_NT_A8") dualseqs <- c('CCAAAGCCGG','ACCGTGCACA','TGTGCACGGT')
  if(spid == "SI-NT-A9" || spid == "SI_NT_A9") dualseqs <- c('AGTCATAATG','AGGCTTGAAA','TTTCAAGCCT')
  if(spid == "SI-NT-A10" || spid == "SI_NT_A10") dualseqs <- c('TTCATCAGAG','TTGTCGTCTC','GAGACGACAA')
  if(spid == "SI-NT-A11" || spid == "SI_NT_A11") dualseqs <- c('GAAGCGCGAA','CAGCGAAATT','AATTTCGCTG')
  if(spid == "SI-NT-A12" || spid == "SI_NT_A12") dualseqs <- c('ATCCGCCGAA','GCTACAGAAT','ATTCTGTAGC')
  if(spid == "SI-NT-B1" || spid == "SI_NT_B1") dualseqs <- c('CTTATTGTGG','AGCTGTGGGT','ACCCACAGCT')
  if(spid == "SI-NT-B2" || spid == "SI_NT_B2") dualseqs <- c('ATTCGTTGGG','CATCAGGAGC','GCTCCTGATG')
  if(spid == "SI-NT-B3" || spid == "SI_NT_B3") dualseqs <- c('GTGGCCTCAT','TCGAAAGTGA','TCACTTTCGA')
  if(spid == "SI-NT-B4" || spid == "SI_NT_B4") dualseqs <- c('CTATGGCATC','CTCTGAGCGC','GCGCTCAGAG')
  if(spid == "SI-NT-B5" || spid == "SI_NT_B5") dualseqs <- c('AAACCACAGT','CCGCAAATGG','CCATTTGCGG')
  if(spid == "SI-NT-B6" || spid == "SI_NT_B6") dualseqs <- c('ATGTATCCAC','CAGGCTGAGG','CCTCAGCCTG')
  if(spid == "SI-NT-B7" || spid == "SI_NT_B7") dualseqs <- c('GATGAGTCTG','TATGTAACCG','CGGTTACATA')
  if(spid == "SI-NT-B8" || spid == "SI_NT_B8") dualseqs <- c('CTCACAATAA','CCGTGTTTAA','TTAAACACGG')
  if(spid == "SI-NT-B9" || spid == "SI_NT_B9") dualseqs <- c('TCTGTCGCAA','ATCCGAACTG','CAGTTCGGAT')
  if(spid == "SI-NT-B10" || spid == "SI_NT_B10") dualseqs <- c('CATCGAGAAG','GTGCATCCGC','GCGGATGCAC')
  if(spid == "SI-NT-B11" || spid == "SI_NT_B11") dualseqs <- c('ACGTATTGGG','CAATCGCAAA','TTTGCGATTG')
  if(spid == "SI-NT-B12" || spid == "SI_NT_B12") dualseqs <- c('CTTACGCGAC','CCTGTCGGAT','ATCCGACAGG')
  if(spid == "SI-NT-C1" || spid == "SI_NT_C1") dualseqs <- c('GATAGTGAAG','CGTTCGCCAG','CTGGCGAACG')
  if(spid == "SI-NT-C2" || spid == "SI_NT_C2") dualseqs <- c('CTGTGCAATG','ATGGTGCTTT','AAAGCACCAT')
  if(spid == "SI-NT-C3" || spid == "SI_NT_C3") dualseqs <- c('AAAGCTGAGC','CAGGAACGAG','CTCGTTCCTG')
  if(spid == "SI-NT-C4" || spid == "SI_NT_C4") dualseqs <- c('GTCCAAGTCG','GTCATGGCAC','GTGCCATGAC')
  if(spid == "SI-NT-C5" || spid == "SI_NT_C5") dualseqs <- c('GATTTCCATC','CTTATGGTCA','TGACCATAAG')
  if(spid == "SI-NT-C6" || spid == "SI_NT_C6") dualseqs <- c('CTAAATGGAT','AATCACATAC','GTATGTGATT')
  if(spid == "SI-NT-C7" || spid == "SI_NT_C7") dualseqs <- c('ATTTCAGTTC','GCAGCATTAA','TTAATGCTGC')
  if(spid == "SI-NT-C8" || spid == "SI_NT_C8") dualseqs <- c('TTGCGACGTC','TTAATCCACA','TGTGGATTAA')
  if(spid == "SI-NT-C9" || spid == "SI_NT_C9") dualseqs <- c('GTACTGTCCA','TTTGTTGGAA','TTCCAACAAA')
  if(spid == "SI-NT-C10" || spid == "SI_NT_C10") dualseqs <- c('AAACGGTTTA','TCTTCGTTAC','GTAACGAAGA')
  if(spid == "SI-NT-C11" || spid == "SI_NT_C11") dualseqs <- c('CGATAGTTCT','GCGATTTCCT','AGGAAATCGC')
  if(spid == "SI-NT-C12" || spid == "SI_NT_C12") dualseqs <- c('TACTTTAGCT','GAGTTATTTG','CAAATAACTC')
  if(spid == "SI-NT-D1" || spid == "SI_NT_D1") dualseqs <- c('CTGGGATTAA','AGTAAAGTTC','GAACTTTACT')
  if(spid == "SI-NT-D2" || spid == "SI_NT_D2") dualseqs <- c('TACACTATTC','ATTGCAACGT','ACGTTGCAAT')
  if(spid == "SI-NT-D3" || spid == "SI_NT_D3") dualseqs <- c('AGAGCTATTT','CTGGCACCCA','TGGGTGCCAG')
  if(spid == "SI-NT-D4" || spid == "SI_NT_D4") dualseqs <- c('AGGTCGTTAT','AGGTTATCCA','TGGATAACCT')
  if(spid == "SI-NT-D5" || spid == "SI_NT_D5") dualseqs <- c('GCTGGACAGG','TAATCTCTGT','ACAGAGATTA')
  if(spid == "SI-NT-D6" || spid == "SI_NT_D6") dualseqs <- c('ACTTAGATGG','AATGTTGAGT','ACTCAACATT')
  if(spid == "SI-NT-D7" || spid == "SI_NT_D7") dualseqs <- c('AGGCGCGAGT','TGTGTCTATA','TATAGACACA')
  if(spid == "SI-NT-D8" || spid == "SI_NT_D8") dualseqs <- c('GAGGTCGTAC','CAACTGCGGG','CCCGCAGTTG')
  if(spid == "SI-NT-D9" || spid == "SI_NT_D9") dualseqs <- c('CCCAATGAGC','AGTTTCTGAT','ATCAGAAACT')
  if(spid == "SI-NT-D10" || spid == "SI_NT_D10") dualseqs <- c('ACATTCAGGG','GTCCTGAGAG','CTCTCAGGAC')
  if(spid == "SI-NT-D11" || spid == "SI_NT_D11") dualseqs <- c('AGAAACGGTG','TCACCCAGCA','TGCTGGGTGA')
  if(spid == "SI-NT-D12" || spid == "SI_NT_D12") dualseqs <- c('AGTTGCAAGT','ATACTTCATG','CATGAAGTAT')
  if(spid == "SI-NT-E1" || spid == "SI_NT_E1") dualseqs <- c('GCCTAGAAAT','ACTACTCCGG','CCGGAGTAGT')
  if(spid == "SI-NT-E2" || spid == "SI_NT_E2") dualseqs <- c('TACAAAGATG','CCGATGACGT','ACGTCATCGG')
  if(spid == "SI-NT-E3" || spid == "SI_NT_E3") dualseqs <- c('GCAGGCTTAG','CGTCTATTGC','GCAATAGACG')
  if(spid == "SI-NT-E4" || spid == "SI_NT_E4") dualseqs <- c('CAGCTCCAAT','TAGGAGGGTG','CACCCTCCTA')
  if(spid == "SI-NT-E5" || spid == "SI_NT_E5") dualseqs <- c('TTTGGAGAAA','CAGCCCTTGA','TCAAGGGCTG')
  if(spid == "SI-NT-E6" || spid == "SI_NT_E6") dualseqs <- c('TGTCGCTTTC','CCTAAAGGGT','ACCCTTTAGG')
  if(spid == "SI-NT-E7" || spid == "SI_NT_E7") dualseqs <- c('GTGTTGCGAG','CACTTTGAGC','GCTCAAAGTG')
  if(spid == "SI-NT-E8" || spid == "SI_NT_E8") dualseqs <- c('GTCTGTTCTG','TCTGATGCTT','AAGCATCAGA')
  if(spid == "SI-NT-E9" || spid == "SI_NT_E9") dualseqs <- c('TCGCTCAATC','GCTTACGTGA','TCACGTAAGC')
  if(spid == "SI-NT-E10" || spid == "SI_NT_E10") dualseqs <- c('CGTTACTAGC','AATGGCCATT','AATGGCCATT')
  if(spid == "SI-NT-E11" || spid == "SI_NT_E11") dualseqs <- c('GTGCAGATTT','TAAAGGCGAT','ATCGCCTTTA')
  if(spid == "SI-NT-E12" || spid == "SI_NT_E12") dualseqs <- c('GTTACCGAAA','CGTTTGAATC','GATTCAAACG')
  if(spid == "SI-NT-F1" || spid == "SI_NT_F1") dualseqs <- c('CGGTATGGAA','TGCAACTGGT','ACCAGTTGCA')
  if(spid == "SI-NT-F2" || spid == "SI_NT_F2") dualseqs <- c('TCGGTTTAGT','TAAAGTGTTC','GAACACTTTA')
  if(spid == "SI-NT-F3" || spid == "SI_NT_F3") dualseqs <- c('CTTTGCTTTG','ACATTCATTC','GAATGAATGT')
  if(spid == "SI-NT-F4" || spid == "SI_NT_F4") dualseqs <- c('ATGATCGCAC','GCGGTATGTA','TACATACCGC')
  if(spid == "SI-NT-F5" || spid == "SI_NT_F5") dualseqs <- c('CGGCGTGTTA','TGAGACGCGG','CCGCGTCTCA')
  if(spid == "SI-NT-F6" || spid == "SI_NT_F6") dualseqs <- c('TCATTTCCGC','ACAGCTGTTG','CAACAGCTGT')
  if(spid == "SI-NT-F7" || spid == "SI_NT_F7") dualseqs <- c('TTGTGCCCAG','TTGCGAGTTG','CAACTCGCAA')
  if(spid == "SI-NT-F8" || spid == "SI_NT_F8") dualseqs <- c('AGCCAACGTG','TCAAAGGAAC','GTTCCTTTGA')
  if(spid == "SI-NT-F9" || spid == "SI_NT_F9") dualseqs <- c('GATCCATACT','ATCGAGAGAA','TTCTCTCGAT')
  if(spid == "SI-NT-F10" || spid == "SI_NT_F10") dualseqs <- c('TTTCCATGAA','CGGTTCTAAC','GTTAGAACCG')
  if(spid == "SI-NT-F11" || spid == "SI_NT_F11") dualseqs <- c('TCTTTATCGG','CCCAATAGCG','CGCTATTGGG')
  if(spid == "SI-NT-F12" || spid == "SI_NT_F12") dualseqs <- c('GAACCCGATG','TCTATCCGGG','CCCGGATAGA')
  if(spid == "SI-NT-G1" || spid == "SI_NT_G1") dualseqs <- c('GATGTCTGTG','CGTGCTACCG','CGGTAGCACG')
  if(spid == "SI-NT-G2" || spid == "SI_NT_G2") dualseqs <- c('TGTTAGACTA','TCATGACGAC','GTCGTCATGA')
  if(spid == "SI-NT-G3" || spid == "SI_NT_G3") dualseqs <- c('TAGAACGCTT','GTCGCAAACG','CGTTTGCGAC')
  if(spid == "SI-NT-G4" || spid == "SI_NT_G4") dualseqs <- c('AATTTGACGT','AGAAGTGAGG','CCTCACTTCT')
  if(spid == "SI-NT-G5" || spid == "SI_NT_G5") dualseqs <- c('GAGTGGCCAC','GATGCACAGT','ACTGTGCATC')
  if(spid == "SI-NT-G6" || spid == "SI_NT_G6") dualseqs <- c('ATCAGTTACG','TACAATCTCT','AGAGATTGTA')
  if(spid == "SI-NT-G7" || spid == "SI_NT_G7") dualseqs <- c('TGTAAGCTTT','CGGACTAGTC','GACTAGTCCG')
  if(spid == "SI-NT-G8" || spid == "SI_NT_G8") dualseqs <- c('GCTTCGGTCT','CGCGGGTTAG','CTAACCCGCG')
  if(spid == "SI-NT-G9" || spid == "SI_NT_G9") dualseqs <- c('AGTCTAAGAC','CTGAAGTGAA','TTCACTTCAG')
  if(spid == "SI-NT-G10" || spid == "SI_NT_G10") dualseqs <- c('TGAAACATTC','CCTCCTGCCT','AGGCAGGAGG')
  if(spid == "SI-NT-G11" || spid == "SI_NT_G11") dualseqs <- c('CCTCACGAAA','TGCCCTGTGC','GCACAGGGCA')
  if(spid == "SI-NT-G12" || spid == "SI_NT_G12") dualseqs <- c('CTACGGGCTT','AGGCGTCCCT','AGGGACGCCT')
  if(spid == "SI-NT-H1" || spid == "SI_NT_H1") dualseqs <- c('GCGGCGTAAA','CACGCGATCA','TGATCGCGTG')
  if(spid == "SI-NT-H2" || spid == "SI_NT_H2") dualseqs <- c('TCTCCTTCGG','TGTCCGTCGC','GCGACGGACA')
  if(spid == "SI-NT-H3" || spid == "SI_NT_H3") dualseqs <- c('CCTTACCCAT','TCCCGGCAAC','GTTGCCGGGA')
  if(spid == "SI-NT-H4" || spid == "SI_NT_H4") dualseqs <- c('AAGGAACATC','TATCTGTGGG','CCCACAGATA')
  if(spid == "SI-NT-H5" || spid == "SI_NT_H5") dualseqs <- c('GTGGGAACTT','GCACTTACAG','CTGTAAGTGC')
  if(spid == "SI-NT-H6" || spid == "SI_NT_H6") dualseqs <- c('ACCGCACCAC','TCGGATTATA','TATAATCCGA')
  if(spid == "SI-NT-H7" || spid == "SI_NT_H7") dualseqs <- c('ACCTTTATCT','CGAGTGCCAA','TTGGCACTCG')
  if(spid == "SI-NT-H8" || spid == "SI_NT_H8") dualseqs <- c('AGTAGCCCGT','TTCGGGACCT','AGGTCCCGAA')
  if(spid == "SI-NT-H9" || spid == "SI_NT_H9") dualseqs <- c('AGATAGCATA','CATTTCCGGA','TCCGGAAATG')
  if(spid == "SI-NT-H10" || spid == "SI_NT_H10") dualseqs <- c('TGGCGTTAAA','TGTTAAGATG','CATCTTAACA')
  if(spid == "SI-NT-H11" || spid == "SI_NT_H11") dualseqs <- c('TCAGGCGAAA','TCTCTGGAAG','CTTCCAGAGA')
  if(spid == "SI-NT-H12" || spid == "SI_NT_H12") dualseqs <- c('AAGACATAGC','ATGTGGACGT','ACGTCCACAT')



  if(any(is.na(spseqs)) && !any(is.na(dualseqs))){
    #for(i in 1:10)cat("WARNING: ONLY #1 and #3 index sequences were used!\n")
    #return(c(paste0(dualseqs[1], dualseqs[3])))
    return(list(A=paste0(dualseqs[1], dualseqs[2]), B=paste0(dualseqs[1], dualseqs[3])))
  }else{
    if(!any(is.na(spseqs))) return(as.list(spseqs)) else return(NA)
  }
}

.rstest <- function(r, coef) r * (1 + 1/r)^(1 + coef)

.averaging_transform <- function(r, nr){
    d <- c(1, r[ 2:length(r) ] - r[1:(length(r)-1)])
    dr <- c( 0.5 * (d[2:length(d)] + d[1:(length(d)-1)]),d[ length(d) ])
       nr/dr
}


.do.EXACT.DEBUG <- FALSE 
#.do.EXACT.DEBUG <- TRUE 
.simple.Good.Turing.Freq<-function( raw.freq ){
  n_zero <- sum(raw.freq == 0)
  times <- table(raw.freq[raw.freq>0])
  obs <- sort(as.numeric(names(times)))
  times <- times[as.character(obs)]

  nobs <- length(obs)
  if(nobs < .min_mySGT_input_size){
    cat("Note: not enough cells in the data for performing cell rescuing.\n")
    return(NA)
  }else{
      if(nobs != length(times)) stop("The oservation array doesn't match the frequency array.")
      total_observed <- sum(obs * times)
      tval <- matrix(0, ncol=2, nrow=nobs)
      ks <- c(obs[2:nobs], 2*obs[nobs] - obs[nobs-1])
      tval[,1] <- log(obs)
      tval[,2] <- log( .averaging_transform(obs,times))
      meanx <- mean(tval[,1])
      meany <- mean(tval[,2])
      slope <- sum( (tval[,1]-meanx) * (tval[,2]-meany) ) / sum((tval[,1]-meanx) ^2)
      intercept <- meany - slope * meanx
  
      obs.in.next <- (obs+1) %in% obs
      SD <- ( 1+(1:nobs) ) / times *(c(times[2:nobs], 0)* (1+c(times[2:nobs],0) /times))^.5
      SD [!obs.in.next] <- 1
  
      GT <- (obs+1)/obs * c(times[2:nobs],0)/times
      GT [!obs.in.next] <- 0
      y <- .rstest(obs,slope)
      LGT <- y / obs
  
      xy.sim <- ( abs(GT-LGT) * (1:nobs) / SD ) > 1.65
      min.no.turing <- min(which(!xy.sim))
      r <- GT
      if(any(!xy.sim))r[min.no.turing:nobs] <- LGT[min.no.turing:nobs]
      p_zero <- times[1] / total_observed
      rs <- (1-p_zero) * obs * r / sum(r*times*obs/total_observed)
      total_rs <- sum(rs * times)
      puniq <- (1-p_zero) * rs / total_rs
      pres <- rep(p_zero / n_zero, length(raw.freq))
      pres [raw.freq>0] <- puniq[match( raw.freq[raw.freq>0], obs )]
      ret <- list(p0=p_zero, p=pres)

      if(.do.EXACT.DEBUG){
        print("DEBUG_EXACT")
        skf <- "/tmp/del4-YangLiao-GoodTuring-Pr-vals.txt"
        if(file.exists(skf))file.remove(skf)
        sink(skf)
        for(rr in pres){
          cat(sprintf("%.20g\n",rr))
        }
        sink()
      }

      ret
  }
}

.min_mySGT_input_size <- 5
.smoothed <- function(i,intercept,slope) 2.718281828^(intercept + slope * log(i))

# Simple Good Turing
.mySGT <- function(obs.per.spe){
    obs.tab <- table(obs.per.spe[obs.per.spe>0])
    obs <- sort( as.numeric(names(obs.tab)))
    obs.tab <- obs.tab[ as.character(obs) ]
    sgtr <- .mySGTsorted(as.numeric(names(obs.tab)), obs.tab)
    res <- obs.per.spe
    res[obs.per.spe!=0] <- sgtr$p[match(as.character(obs.per.spe[obs.per.spe!=0]), names(obs.tab))]
    n_zero <- sum(obs.per.spe==0)
    res[obs.per.spe==0] <- sgtr$p0/n_zero
    res
}

.mySGTsorted<-function( obs, times ){
    if(any(obs != sort(obs)))stop("Observations have to be sorted.")
    nobs <- length(obs)
    if(nobs < .min_mySGT_input_size) stop("Not enough element in the observation array.")
    if(nobs != length(times)) stop("The oservation array doesn't match the frequency array.")
    total_observed <- sum(obs * times)
    p_zero <- 0
    if(1 %in% obs) p_zero <- times[which(1==obs)[1]] / total_observed
    tval <- matrix(0, ncol=2, nrow=nobs)
    ks <- c(obs[2:nobs], 2*obs[nobs] - obs[nobs-1])
    tval[,1] <- log(obs)
    tval[,2] <- log(2*times / (ks - c(0, obs[1:(nobs-1)])))
    meanX <- mean(tval[,1])
    meanY <- mean(tval[,2])
    slope <- sum( (tval[,1]-meanX) * (tval[,2]-meanY) ) / sum((tval[,1]-meanX) ^2)
    intercept <- meanY - slope * meanX

    y <- (1+obs) * .smoothed(1+obs, intercept, slope ) / .smoothed(obs, intercept, slope)
    x <- (1+obs) * c((times[2:nobs] / times[1:(nobs-1)]), y[nobs])
    xy.sim <- abs(x-y) <= 1.96*( (obs+1)^2 * c(times[2:nobs], 0)/ times^2 * (1+ c(times[2:nobs], 0) / times ))^0.5
    obs.in.next <- (obs+1) %in% obs
    min.inv <- min(which( xy.sim | !obs.in.next ))
    r<-x
    if(min.inv>0)r[min.inv:nobs] <- y[min.inv:nobs]
    list(p0=p_zero, p=(1-p_zero) * r / sum(r*times))
}


.cellCounts_try_cellbarcode <- function( input.directory, sample.sheet, cell.barcode.list, nreads.testing, input.mode, result.prefix.fname){ # the three parameters can only be one string, not strings!
    if(is.null(sample.sheet)) sample.sheet<-"."
    cmd <- paste0(c(input.directory, sample.sheet, cell.barcode.list, as.character(nreads.testing), input.mode, result.prefix.fname), collapse=.R_param_splitor)
    rvs <- as.integer(rep(0,5))
    C_args <- .C("R_try_cell_barcode_wrapper",nargs=as.integer(6),argv=as.character(cmd),retv=rvs ,PACKAGE="Rsubread")
    return_val <- ifelse(C_args$retv[1]==0,"FINISHED","ERROR")
    tested_reads <- C_args$retv[2]
    good_sample <- C_args$retv[3]
    good_cell <- C_args$retv[4]
    if(return_val=="ERROR"){
        return(NA)
    }
    return(c(tested_reads, good_sample, good_cell))
}

.dataURL <- function(uri){
    sprintf("http://shilab-bioinformatics.github.io/cellCounts/Barcodes/%s",uri)
}

.get.illumina.dev <- function(lns){
  for(lnn in lns){
    if(grepl("<ApplicationName>", lnn) && grepl("</ApplicationName>", lnn))return(
      ifelse(grepl("HiSeq", lnn),"HiSeq",
      ifelse(grepl("MiSeq", lnn),"MiSeq",
      ifelse(grepl("iSeq", lnn),"iSeq",
      ifelse(grepl("NextSeq", lnn),"NextSeq",
      ifelse(grepl("NovaSeq", lnn),"NovaSeq","Unsupported"))))))
  }
  return(NA)
}
.get.illumina.ver <- function(lns){
  for(lnn in lns){
    if(grepl("<ApplicationVersion>", lnn) && grepl("</ApplicationVersion>", lnn)) {
      spns <- unlist(strsplit(lnn, "Version>"))[2]
      spns <- unlist(strsplit(spns, "<"))[1]
      return(as.numeric(unlist(strsplit(spns,"[.]"))))
    }
  }
  return(NA)
}

# It only returns T or F when PETurnaround happens exactly once and IndexRead2 happens exactly once.
# Or it returns NA. 
.get.novaseq.i2.rounded <- function(lns){
  peround.no <- NA
  lnnno <- 1
  for(lnn in lns){
    if(grepl("PETurnaround", lnn) || grepl("PairedEndTurnaround", lnn)){
      if(!is.na(peround.no))return(NA)
      peround.no <- lnnno
    }
    lnnno <- 1+lnnno
  }
  if(is.na(peround.no)) return(NA) # no "PE turnaaround" at all 

  lnnno <- 1
  ret <- NA
  for(lnn in lns){
    if(grepl("IndexRead2", lnn)){
      if(!is.na(ret))return(NA)
      if(F)cat("REV_DEBUG NovaSeq-New Idx2 line",lnnno," ; Rev line", peround.no,".\n")

      ret <- ( lnnno > peround.no ) # if IndexRead2 happend before PEturned, then I2 is stright. 
           # If PEturned is before IndexRead2, then I2 is reversed.
           # If not both IndexRead2 and PEturned were found, it is not right.
    }
    lnnno <- 1+lnnno
  }
  return(ret)
}

.get.novaseq.i2.BP14.used <- function(lns){
  looking <- F
  ret <- F
  for(lnn in lns){
    if(grepl("<ChemistryStep", lnn) && grepl('Description="Index', lnn)) looking <- T
    if(grepl("</ChemistryStep>", lnn)) looking <- F
    if(looking && grepl('ReagentName="BP14"', lnn))ret <- T
  }
  return(ret)
}

.get.illumina.flowcell <- function(lns){
  for(lnn in lns){
    if(grepl("<Flowcell>", lnn) && grepl("</Flowcell>", lnn)) {
      spns <- unlist(strsplit(lnn, "Flowcell>"))[2]
      spns <- unlist(strsplit(spns, "<"))[1]
      return(spns)
    } 
  }
  return(NA)
}

.find.DS.in.path <- function(d){
  d # assume that the dir is here.
}

.find.dual.index.I2.reversed <- function(raw.dir, verbose=F){
  raw.dir <- .find.DS.in.path(raw.dir)
  run.param.file <- paste0(raw.dir,"/RunParameters.xml")
  if(!file.exists(run.param.file))stop("No run parameter file is found in the raw dataset.")
  run.param.txt <- readLines(run.param.file ,warn=F)
  illumina.dev.name <- .get.illumina.dev(run.param.txt)
  illumina.dev.ver <- .get.illumina.ver(run.param.txt)
  if(is.na(illumina.dev.name))stop("No Illumina device info is available in the run parameter file.")

  if(illumina.dev.name %in% c("HiSeq")) {
    if(any(is.na(illumina.dev.ver)))stop("No Illumina version info is available in the run parameter file.")
    is.Rev.I2 <-(illumina.dev.ver[1] >2)

    if(verbose)cat("REV_DEBUG HiSeq had new version",illumina.dev.ver," and Rev I2 =",is.Rev.I2,".\n") 
  }else if(illumina.dev.name %in% c("MiSeq"))
    is.Rev.I2 <- F
  else if(illumina.dev.name %in% c("NextSeq","iSeq"))
    is.Rev.I2 <- T
  else if(illumina.dev.name %in% c("NovaSeq")){
    run.info.file <- paste0(raw.dir,"/RunInfo.xml")
    if(!file.exists(run.info.file))stop("No run info file is found in the raw dataset.")
    run.info.txt <- readLines(run.info.file,,warn =F)
    flowcell.id <- .get.illumina.flowcell(run.info.txt)
    if(is.na(flowcell.id))stop("No flowcell id was found in run info file.")
    recipe.new.ver <- (illumina.dev.ver[1] >1) || ( illumina.dev.ver[1] ==1 && illumina.dev.ver[2] >7)
    resp.files <- list.files(paste(raw.dir,"Recipe",sep="/"), pattern="[.]xml$", full.names=T)
    resp.file <- NA
    for(testi in 1:3){ # the last round: any file is good. 
      for(resp.file in resp.files){
        if(testi==1 && grepl(paste0("/",flowcell.id,".xml"), resp.file)) break
        if(testi==2 && grepl(flowcell.id, resp.file)) break
      }
    }
    if(is.na(resp.file))stop("No recipe file was found for this dataset.")
    recipeOne.txt <- readLines(resp.file, warn =F)
    if(recipe.new.ver) is.Rev.I2 <- .get.novaseq.i2.rounded(recipeOne.txt)
    else is.Rev.I2 <- .get.novaseq.i2.BP14.used(recipeOne.txt)
    if(is.na(is.Rev.I2)) stop("The recipe file has a unexpected format.") 
    if(verbose)cat("REV_DEBUG NovaSeq had new version = ",recipe.new.ver," and recipe file = ",resp.file,". Rev I2 = ",is.Rev.I2,"\n")
  }else stop("Wrong dev name was detected.")
  if(verbose)cat("REV_DEBUG Sample had device = ",illumina.dev.name,illumina.dev.ver,".\n")
  return(is.Rev.I2)
}

.reads.for.find.barcode <- 10000
.find_best_CellBC_and_DualIdx <- function( input.directory, result.prefix.fname, sample.sheet=NULL, input.mode="bcl", A_and_B.dual.index.list=NULL, cell.bc.sup.rate=0.6){
    barcode.database.file <- path.expand("~/.Rsubread/cellCounts/known_barcode_sets.txt")
    if(!file.exists(barcode.database.file)){
        dir.create("~/.Rsubread/cellCounts", recursive=TRUE)
        rr <- download.file(.dataURL("known_barcode_sets.txt"), barcode.database.file)
        if(rr!=0)stop("ERROR: the barcode database cannot be retrieved from the Internet. You may still run cellCounts by specifying a local barcode list file to the `cell.barcode.list` option.")
    }
    bcb.sets <- read.delim(barcode.database.file, stringsAsFactors=F, header=T)
    cat(sprintf("Found %d known cell barcode sets.\n", nrow(bcb.sets)))
    max.cell.good <- -1
    for(libf in bcb.sets$File){
        listfile <- path.expand(paste0("~/.Rsubread/cellCounts/",libf))
        if(!file.exists(listfile)){
            rr <- download.file(.dataURL(libf), listfile)
            if(rr!=0)stop("ERROR: the barcode list cannot be retrieved from the Internet. You may still run cellCounts by specifying a local barcode list file to the `cell.barcode.list` option.")
        }
        cat(sprintf("Testing the cell barcodes in %s.\n", libf))
        barcode_res <- .cellCounts_try_cellbarcode(input.directory[1], sample.sheet[1], listfile, .reads.for.find.barcode, input.mode, result.prefix.fname)
        if(length(barcode_res)<3)stop("ERROR: the input sample cannot be processed.")
	tested.all.reads <- barcode_res[1]
	dual.index.verAB <- NA
	if("bcl" == input.mode && F==any(is.null(A_and_B.dual.index.list))){
		idx.supp.tab.fn <- paste0(result.prefix.fname,".idx_verAB_sup")
		idx.supp.tab <- read.delim(idx.supp.tab.fn, header=T, stringsAsFactors=F)
		Asupp <- sum( idx.supp.tab$nSupp[ idx.supp.tab$IndexStr %in% A_and_B.dual.index.list$A ] )/tested.all.reads
		Bsupp <- sum( idx.supp.tab$nSupp[ idx.supp.tab$IndexStr %in% A_and_B.dual.index.list$B ] )/tested.all.reads
		if(Asupp > Bsupp * 2) dual.index.verAB <- "A" 
		if(Asupp * 2 < Bsupp) dual.index.verAB <- "B" 
	}

        sample.good.rate <- barcode_res[2]/tested.all.reads
        cell.good.rate <- barcode_res[3]/tested.all.reads
        max.cell.good <- max(max.cell.good, cell.good.rate)

        cat(sprintf("Cell barcode supporting rate : %.1f%%.\n", cell.good.rate*100.))

        # sample index isn't tested anymore
        # if(input.mode=="bcl" && sample.good.rate < 0.5)cat(sprintf("WARNING: there are only %.1f%% reads having known sample indices. Please check if the sample sheet is correct.\n", sample.good.rate*100.))
        if(cell.good.rate > cell.bc.sup.rate){
            meta.data.verAB <- NA
            if(!any(is.null(A_and_B.dual.index.list))){
               metadata.I2Reversed <- .find.dual.index.I2.reversed(input.directory[1]) 
               meta.data.verAB <- ifelse(metadata.I2Reversed,"B","A")
            }

            if(cell.bc.sup.rate>0)cat(sprintf("Found cell-barcode list '%s' for the input data: supported by %.1f%% reads. \n", libf, cell.good.rate*100.))

            if(F)if(!identical(dual.index.verAB, meta.data.verAB))stop("The dual index workflow versions of A/B inferred from reads and from dataset meta-data are inconsistant!")
            if(F)if(!any(is.null(A_and_B.dual.index.list)))cat(sprintf("The dual index version is likely %s by scanning the reads. The dual index version is likely %s by examining the meta-data in the dataset.\n", dual.index.verAB, meta.data.verAB))
            return(list(cell.barcode=listfile, dual.index=dual.index.verAB, meta=meta.data.verAB))
        }
    }
    stop(sprintf("ERROR: no known cell barcode set was found for the data set. The highest percentage of cell-barcode matched reads is %.1f%%\n", max.cell.good*100.))
}

.read.sparse.mat.by.genes <- function (fn, genes){
  mtxrows <- read.delim(paste0(fn,".spmtx"), skip=2, header=F, sep=' ')
  coln <- read.delim(paste0(fn, ".BCtab"), stringsAsFactors=F, header=F)$V1
  rown <- read.delim(paste0(fn, ".GENEtab"), stringsAsFactors=F, header=F)$V1
  out.gene.idx <- match(rown ,genes )
  gene.ranks <- out.gene.idx[as.numeric(mtxrows[,1])]
  cell.ranks <- as.numeric(mtxrows[,2])
  ret <- Matrix::sparseMatrix(i=gene.ranks, j=cell.ranks , x=as.numeric(mtxrows[,3]))
  rownames(ret) <- genes 
  colnames(ret) <- coln 
  ret
}
.read.sparse.mat <- function (fn){
  #cat("Loading matrix from",fn,"\n")
  mtx <- Matrix::readMM(paste0(fn, ".spmtx"))
  if(file.size(paste0(fn, ".BCtab"))>0){
    coln <- read.delim(paste0(fn, ".BCtab"), stringsAsFactors=F, header=F)$V1
    colnames(mtx) <- coln
  }
  if(file.size(paste0(fn, ".GENEtab"))>0){
    rown <- read.delim(paste0(fn, ".GENEtab"), stringsAsFactors=F, header=F)$V1
    rownames(mtx) <- rown
  }
  mtx
}

.use.DEBUG.data <- NA
# .use.DEBUG.i <- 1

.get.multi.nomial <- function(n, size, prob){
  if(.do.EXACT.DEBUG){
    .use.DEBUG.i <- 1
    ret <- read.table(paste0("/tmp/del4-YangLiao-multi-nomial-SIZE",size,"-",.use.DEBUG.i,".txt"), header=F)
    ret <- t(ret)
   #.use.DEBUG.i <<-  .use.DEBUG.i+1
   #print(ret[1:5,1:5])
    ret
  }else{
    rmultinom(n, size, prob )
  }
}

.simu.multinomial <- function(candi.mat, gene.profile.freq , times=10000){
  bcsizes <- sort(unique( colSums(candi.mat) ))
  ret.nUMI.LLH.tab <- list()
  N10000.LLH <- NA
  Old_bs_one <- NA
  log_E_GTE <- log(gene.profile.freq)

  if(.do.EXACT.DEBUG){
    tff<-"/tmp/del4-YangLiao-for-multi-nomial-steps.txt"
    if(file.exists(tff))file.remove(tff)
    sink(tff)
    for(bcsize_one in bcsizes){
      UMI_step_diff <- NA
      if(!any(is.na(Old_bs_one))) UMI_step_diff <- bcsize_one - Old_bs_one
      st1 <- NA
      if(is.na(Old_bs_one)) {
        st1 <- bcsize_one
      }else if(UMI_step_diff >= 1000){
        st1 <- UMI_step_diff
      }
    
      if(!is.na(st1))cat(st1,"\n")
      Old_bs_one <- bcsize_one
    }
    sink()
    system("python /usr/local/work/liao/subread/scripts/Cellranger-replicate/CrepPY-multi-nomial.py")
  }

  Old_bs_one <- NA
  N1000.FstLLH <- c()

  if(.do.EXACT.DEBUG) M50.gene.ids <- read.table("/tmp/del4-YangLiao-50M-gene-nos.txt", header=F)$V1
  all.steps.len <- 0

  for(bcsize_one in bcsizes){
    UMI_step_diff <- NA
    if(!is.na(Old_bs_one)) UMI_step_diff <- bcsize_one - Old_bs_one

    if(is.na(Old_bs_one)){
    }else if(UMI_step_diff >= 1000){
    }else{
      step_len <- bcsize_one - Old_bs_one
      all.steps.len <- step_len + all.steps.len
    }
    Old_bs_one <- bcsize_one
  }

  Old_bs_one <- NA
  M50.in.loop.K <- 0
  for(bcsize_one in bcsizes){
    UMI_step_diff <- NA
    if(!any(is.na(Old_bs_one))) UMI_step_diff <- bcsize_one - Old_bs_one
  
    if(any(is.na(N10000.LLH))){
      N10000 <- .get.multi.nomial(n=times, size=bcsize_one, prob=gene.profile.freq )
      #print("======== N10000 and PROF DIM =======")
      #print(dim(N10000))
      #print(length(gene.profile.freq))
      N10000.LLH <- apply(N10000, 2, function(x) dmultinom(x, prob=gene.profile.freq, log =T ))
    }else if(UMI_step_diff >= 1000){
      UMI_step_diff_N10000 <- .get.multi.nomial(n=times, size=UMI_step_diff, prob=gene.profile.freq )
      N10000 <- N10000 + UMI_step_diff_N10000
      N10000.LLH <- apply(N10000, 2, function(x) dmultinom(x, prob=gene.profile.freq, log =T ))
    }else{
      step_len <- bcsize_one - Old_bs_one
      for(curi in (Old_bs_one+1):bcsize_one){
        if(.do.EXACT.DEBUG){
          UMI_step_indices_N10000 <- M50.gene.ids[1+M50.in.loop.K + (0:9999) * all.steps.len ]
          if(curi == 588){
            tff<-"/tmp/del4-YangLiao-DEBUG-588-10KJ.txt"
            if(file.exists(tff))file.remove(tff)
            sink(tff)
            for(pi in 1:10000){
                cat(pi," ", N10000[UMI_step_indices_N10000[pi],pi],"\n")
            }
            sink()
          }
          M50.in.loop.K <- 1+M50.in.loop.K
        }else{
          UMI_step_indices_N10000 <- sample(1:nrow(candi.mat), size=times, prob=gene.profile.freq, replace=T)
        }
        for(idi in 1:times){
          N10000[ UMI_step_indices_N10000[idi] ,idi ] <- N10000[ UMI_step_indices_N10000[idi] ,idi ]+1
        }
        UMI_step_values_N10000 <- rep(0, times)
        for(idi in 1:times){
          UMI_step_values_N10000[idi] <- N10000[UMI_step_indices_N10000[idi] ,idi ]
        }
        #print(UMI_step_values_N10000)
        N10000.LLH <- N10000.LLH + log_E_GTE[ UMI_step_indices_N10000 ] + log((curi) / UMI_step_values_N10000)

        if(.do.EXACT.DEBUG && curi == 588)for(uii in 1:30){
            tff<-"/tmp/del4-YangLiao-DEBUG-1-30-E_GTE.txt"
            if(file.exists(tff))file.remove(tff)
            sink(tff)
            for(i in 1:30){
                cat(sprintf("%.5g %.5g %.5g\n", N10000.LLH[i], log_E_GTE[ UMI_step_indices_N10000 [i]],  log((curi) / UMI_step_values_N10000[i])))
            }
            sink()
        }
      }
    }
  
    ret.nUMI.LLH.tab[[ bcsize_one ]] <- N10000.LLH
    N1000.FstLLH <- c(  N1000.FstLLH, N10000.LLH[1] )
    Old_bs_one <- bcsize_one
  }
  if(.do.EXACT.DEBUG){
    tff<-"/tmp/del4-YangLiao-10K-LLH-from-R.txt"
    if(file.exists(tff))file.remove(tff)
    sink(tff)
    for(flh in N1000.FstLLH){
      cat(sprintf("%.6g\n", flh))
    }
    sink()
  }
  ret.nUMI.LLH.tab
}

.is.no.candBC <- function(fn){
  info <- file.info(fn)
  return(info$size < 2)
}

.cellCounts.rescue <- function( BAM.name, FC.gene.ids, sample.no ){
  fname <- sprintf("%s.scRNA.%03d", BAM.name, sample.no)
  nozero.anywhere.genes <- c()
  if(file.size(paste0(fname,".no0Genes"))>0) nozero.anywhere.genes <- read.delim(
     paste0(fname,".no0Genes"), stringsAsFactors=F, header=F)$V1 else return(NA)

  ambient.accumulate <- read.delim(paste0(fname,".AmbSum"), stringsAsFactors=F)
  ambient.accumulate <- ambient.accumulate[ match(FC.gene.ids , ambient.accumulate$GeneID), ]
  ambient.accumulate$UMIs[is.na(ambient.accumulate$UMIs)] <- 0
  ambient.accumulate <- ambient.accumulate$UMIs
  names(ambient.accumulate) <- FC.gene.ids 

  ambient.accumulate <- ambient.accumulate[ names(ambient.accumulate) %in%  nozero.anywhere.genes]

  resc.bc.fn <- paste0(fname,".RescCand")
  #print(summary(ambient.accumulate))
  rstfq <- .simple.Good.Turing.Freq(ambient.accumulate)
  if(any(is.na(rstfq)) || .is.no.candBC(paste0(resc.bc.fn,".BCtab"))){
    return(NA)
  }else{
    gte <- rstfq$p
    # This function returns "times" log-likelihoods.
  
    rescue.candidates <- as.matrix(.read.sparse.mat(resc.bc.fn))
    rescue.candidates <- rescue.candidates[ match(names(ambient.accumulate), rownames(rescue.candidates)), ]
    rownames(rescue.candidates) <- names(ambient.accumulate)
    rescue.candidates [is.na(rescue.candidates )] <- 0
    # Compute observed log-likelihood of barcodes being generated from ambient RNA
    # Compute the multinomial log PMF for many barcodes -- log-likelihoods
    # Only use the "non-zero anywhere" genes.
    log.like.cands <- apply(rescue.candidates, 2, function(x) dmultinom(x, prob=gte, log =T ))
  
    # Simulate log likelihoods
    # This step is to build like 10000 sets of N_GENES vectors from the multinomial distribution of "gte"
    # See what are their log-likelihoods against "gte" -- most should be very small.
  
    simu.pvalues <- .simu.multinomial( rescue.candidates, gte )
  
    # Compute p-values : the p-value is the chance of a barcode is actually from ambient RNA (ie smaller the p-value, more likely this barcode is for a real cell)
    actual.pvalues <- rep(0, ncol(rescue.candidates) )
    names(actual.pvalues) <- colnames(rescue.candidates)
    for(candi in names(log.like.cands)){
      cand_umis <- sum(rescue.candidates[,candi])
      cand.simu.pvs <- simu.pvalues[[ cand_umis ]]
      cand.actual.pv <- log.like.cands[candi]
      actual.pvalues[candi] <- (1+sum(cand.simu.pvs < cand.actual.pv))/(length(cand.simu.pvs)+1)
    }
  
    # p-value => FDR
    actual.FDR <- p.adjust(actual.pvalues, method='BH')
  
    if(.do.EXACT.DEBUG){
      tff<-"/tmp/del4-YangLiao-final-FDR.txt"
      if(file.exists(tff))file.remove(tff)
      sink(tff)
      for(candi in names(log.like.cands)) cat(sprintf("%s %.10g %.10g\n", candi, actual.pvalues[candi], actual.FDR[candi]))
      sink()
    }
    # select cells that has FDR < cutoff
    FDR.Cutoff <- 0.01
    head(actual.FDR)
    Rescured.Barcodes <- names(actual.FDR)[actual.FDR <= FDR.Cutoff]
    head(Rescured.Barcodes)
    rescue.candidates[,Rescured.Barcodes, drop=FALSE]
  }
}

.match.exons <- function(annot.tab, counts){
  annot.str <- paste(annot.tab$GeneID, annot.tab$Chr, annot.tab$Start,
    annot.tab$End, ifelse(annot.tab$Strand == "+", "P","N"), sep=":fc@R@Spl:")
  ret <- matrix(0, ncol=ncol(counts), nrow=nrow(annot.tab))
  colnames(ret) <- colnames(counts)
  rownames(ret) <- annot.str
  ret[ rownames(counts),] <- counts
  ret
}

.load.one.scSample <- function( BAM.name, FC.gene.ids, sample.no, use.meta.features, annot.tab, umi.cutoff){
  set.seed(0)
  fname <- sprintf("%s.scRNA.%03d", BAM.name, sample.no)
  cat("Perform cell rescuing for sample",sample.no,"...\n")
  highconf <- as.matrix(.read.sparse.mat(paste0(fname,".HighConf")))
  raw.fname <- paste0(fname,".RawOut.spmtx")
  if(file.exists(raw.fname)){
    rawout <- .read.sparse.mat.by.genes(paste0(fname,".RawOut"), FC.gene.ids)
  }else rawout <- NULL
  rescued <- NA
  if(is.null(umi.cutoff)) rescued <- .cellCounts.rescue(BAM.name, FC.gene.ids, sample.no)

  if(use.meta.features){
    if(!any(is.na(rescued))) rescued <- rescued[rowSums(rescued)>0,]
    ncolRescued <- 0
    if(any(is.na(rescued))){
      ret <- matrix(0,ncol=ncol(highconf), nrow=length(FC.gene.ids))
      colnames(ret) <- colnames(highconf)
    }else{
      ret <- matrix(0,ncol=ncol(highconf)+ncol(rescued), nrow=length(FC.gene.ids))
      colnames(ret) <- c( colnames(highconf), colnames(rescued) )
    }
    rownames(ret) <- FC.gene.ids 
    ret[rownames(highconf), colnames(highconf) ] <- highconf
    if(!any(is.na(rescued)))ret[rownames(rescued), colnames(rescued) ] <- rescued

    retc<- list(Counts=ret, HighConfidneceCell=colnames(ret) %in% colnames(highconf))
    if(!is.null(rawout)) retc[["ExcludedCells"]] <- rawout[,!( colnames(rawout) %in% colnames(ret) )]
  }else{
    fcmat <- .match.exons(annot.tab,highconf)
    rownames(fcmat)<-NULL
    retc<- list(Counts=fcmat, HighConfidneceCell=rep(T, ncol(highconf)))
    if(!is.null(rawout))retc[["ExcludedCells"]] <- rawout[,!( colnames(rawout) %in% colnames(fcmat) )]
  }
  return(retc)
}

.load.all.scSamples <- function( BAM.name, FC.gene.ids, use.meta.features, annot.tab, umi.cutoff){
  sum.tab <- read.delim(paste0(BAM.name,".scRNA.SampleTable"), stringsAsFactors=F)
  ret <- list()
  for(roiw in 1:nrow(sum.tab)){
    #sname <- as.character(sum.tab$SampleName[roiw])
    sid <- sum.tab$Index[roiw]
    count.tab <- .load.one.scSample(BAM.name, FC.gene.ids, sid, use.meta.features, annot.tab, umi.cutoff)
    ret[[sprintf("Sample.%d",sid)]] <- count.tab
  }
  ret[["Sample.Table"]] <- sum.tab

  ret
}

.del.temp.files  <- function(pfx){
  if(nchar(pfx)<16) stop("Prefix should be longer.")
  flist <- dir(".", "^[.]Rsubread", all.files=TRUE)
  to.delete <- flist[grepl(pfx, flist)]
  for(df in to.delete){
    if(grepl(pfx, df)){
      file.remove(df)
#cat ("Goinng to remove",df,"\n")
    }else{
      stop("Wrong selection of files to delete")
    }
  }
}

.extract.sample.table.cols <- function(rdir, smr, input.mode="bcl", umi.cutoff=NULL){
  total.cells <- c()
  hiconf.cells <- c()
  res.cells <- c()
  umis <- c()
  umi.statistics <- data.frame(MinUMI=NULL, MedianUMI=NULL, MaxUMI=NULL, MeanUMI=NULL,stringsAsFactors=F)[,0]
  for(spi in 1:nrow(smr[["Sample.Table"]])){
    samplename <- as.character(smr[["Sample.Table"]]$SampleName[spi])
    sampleno <- sprintf("Sample.%d", spi)
    total.cells <- c(total.cells,length(smr[[sampleno]][["HighConfidneceCell"]]))
    hiconf.cells <- c(hiconf.cells,sum(smr[[sampleno]][["HighConfidneceCell"]]))
    res.cells <- c(res.cells, sum(!(smr[[sampleno]][["HighConfidneceCell"]])))
    cell.umis <- colSums(smr[[sampleno]][["Counts"]])
    umis <- c(umis,sum(cell.umis))
    if(length(cell.umis)==0){
       umi.statistics <- rbind(umi.statistics, list(MinUMI=NA, MedianUMI=NA, MaxUMI=NA, MeanUMI=NA))
    }else umi.statistics <- rbind(umi.statistics, list(MinUMI=min(cell.umis), MedianUMI=median(cell.umis), MaxUMI=max(cell.umis), MeanUMI=mean(cell.umis)))
  }
  ret <- NULL
  if(is.null(umi.cutoff)){
    if(input.mode=="fastq" || input.mode=="bam")
      ret <- cbind( SampleName=as.character(smr[["Sample.Table"]]$SampleName), TotalCells=total.cells, HighConfidenceCells=hiconf.cells, RescuedCells=res.cells, TotalUMI=umis, umi.statistics, smr[["Sample.Table"]][,c("TotalReads","MappedReads","AssignedReads")],stringsAsFactors=F )
    else
      ret <- cbind( SampleName=as.character(smr[["Sample.Table"]]$SampleName), InputDirectory=rep(rdir, nrow(smr[["Sample.Table"]])), TotalCells=total.cells, HighConfidenceCells=hiconf.cells, RescuedCells=res.cells, TotalUMI=umis, umi.statistics, smr[["Sample.Table"]][,c("TotalReads","MappedReads","AssignedReads")],stringsAsFactors=F )
  }else{
    if(input.mode=="fastq" || input.mode=="bam")
      ret <- cbind( SampleName=as.character(smr[["Sample.Table"]]$SampleName), TotalCells=total.cells, TotalUMI=umis, umi.statistics, smr[["Sample.Table"]][,c("TotalReads","MappedReads","AssignedReads")], stringsAsFactors=F)
    else
      ret <- cbind( SampleName=as.character(smr[["Sample.Table"]]$SampleName), InputDirectory=rep(rdir, nrow(smr[["Sample.Table"]])), TotalCells=total.cells, TotalUMI=umis, umi.statistics, smr[["Sample.Table"]][,c("TotalReads","MappedReads","AssignedReads")], stringsAsFactors=F)
  }
}

.scan.fastq.dir <- function(dirname){
  ddf <- list.files(dirname , recursive=TRUE)
  ddf <- ddf[grepl("L[0-9][0-9][1-9]_R1_[0-9][0-9][1-9].fastq.gz$",ddf) &(!grepl("Undetermined_S",ddf)) &!grepl("/fork0/", ddf)]
  sample.sheet <- data.frame(stringsAsFactors=F)
  for(df1 in sort(ddf)){
    df1 <- file.path(dirname,df1)
    r1_part <- substr(df1, nchar(df1)-12, 9999)
    r1_pref <- substr(df1, 1, nchar(df1)-15)
    df2 <- paste0(r1_pref, "R2", r1_part)
    sample.name <- unlist(strsplit(df2, "\\/"))
    sample.name0<- sample.name
    sample.name <- sample.name[length(sample.name)]
    if(substr(sample.name, nchar(sample.name)-22, nchar(sample.name)-22)=='S') sample.name <- substr(sample.name, 1, nchar(sample.name)-24)
    else if(substr(sample.name, nchar(sample.name)-23, nchar(sample.name)-23)=='S') sample.name <- substr(sample.name, 1, nchar(sample.name)-25)
    else stop(paste("ERROR: Unable to parse the file name,",sample.name))

    if(substr(sample.name,1,1)=="_") sample.name <- substr(sample.name,2,999)
    if(substr(sample.name,1,1)=="_") sample.name <- substr(sample.name,2,999)
    #if(substr(sample.name,1,1)!="S")stop(sprintf("Unable to parse the FASTQ file name : '%s'", sample.name0))

    sample.sheet <- rbind(sample.sheet, data.frame( SampleName=as.character(sample.name), BarcodeUMIFile=df1, ReadFile=df2, stringsAsFactors=F))
  }
  if(nrow(sample.sheet) < 1) stop(paste0("ERROR: no valid FASTQ files were found in directory '",dirname,"'."))
  sample.sheet
}

.SCRNA_FASTA_SPLIT1 <- "|Rsd:cCounts:mFQs|"
.SCRNA_FASTA_SPLIT2 <- "|Rsd:cCounts:1mFQ|"

.validate.sample.sheet <- function(sheet, input.mode){
  if(any(is.na(sheet)) || is.null(sheet)) stop("A sample sheet must be provided.")
  if(input.mode == "BCL"){
    if(nrow(sheet)<1) stop("The sample sheet cannot be empty.")
    if(!("Lane" %in% colnames(sheet) && "IndexSetName" %in% colnames(sheet) && "SampleName" %in% colnames(sheet) && "InputDirectory" %in% colnames(sheet)))
      stop("The sample sheet must contain four columns with column headers named InputDirectory, Lane, SampleName and IndexSetName.")
    files.to.test <- sheet[, "InputDirectory"]
    for(f in files.to.test)
      if(!dir.exists(f))stop(paste0("ERROR: input directory '",f,"' does not exist."))
  }else if(input.mode == "FASTQ"){
    if(nrow(sheet)<1) stop("The sample sheet cannot be empty")
    if(!("BarcodeUMIFile"  %in% colnames(sheet) && "ReadFile"  %in% colnames(sheet) && "SampleName"  %in% colnames(sheet) ))
      stop("The sample sheet must contain three columns with column headers named BarcodeUMIFile, ReadFile and SampleName.")
    files.to.test <-  c(sheet[,"BarcodeUMIFile"], sheet[,"ReadFile"])
    for(f in files.to.test)
      if(!file.exists(f))stop(paste0("ERROR: fastq file '",f,"' does not exist."))
  } # The "FASTQ-dir" mode should always be correct unless no FASTQ files are found. The error message is given in the dir-scan function.
  return(sheet)
}

cellCounts <- function( index, sample, input.mode = "BCL", cell.barcode = NULL, nsubreads = 15, minVotes = 1, maxMismatches = 10, minMappedLength = 1, annot.inbuilt = "mm39", annot.ext = NULL, isGTFAnnotationFile = FALSE, GTF.featureType = "exon", GTF.attrType = "gene_id", useMetaFeatures = TRUE, detectJunctions = FALSE, umi.cutoff = NULL, nthreads = 10, nBestLocations = 1, uniqueMapping = FALSE, reportExcludedBarcodes = FALSE, barcoding.mode="Chromium", cell.level.junctions=NULL, cell.cluster.map=NULL, enableSoftClipping = TRUE){
  if(F)if(!(grepl("[/]chr1$", index)||file.exists("~/PubDB/welcome.bash"))){
     stop("The devel version is not for general use. Please install the released version.")
     return(NULL)
  }
  maxDiffToTopVotes=2
  onlyDetectBarcode=F
  has.error <- FALSE
  maxMismatchBases <- maxMismatches
  minVotesPerRead <- minVotes
  subreadsPerRead <- nsubreads
  unique.mapping <- uniqueMapping

  index <- .check_and_NormPath(index, mustWork=F, opt="index name")
  index.file.1 <- paste0(index, ".00.b.array")
  if(!file.exists(index.file.1))stop(sprintf("Error: index '%s' is not found.", index))
  if(!is.null(umi.cutoff)){
    umi.cutoff <- as.numeric(umi.cutoff)
    if(umi.cutoff < 0.0) stop("UMI cutoff must be a positive number.")
  }

  sample.info.idx <- .validate.sample.sheet(sample, input.mode)
  fc <- list()

  temp.file.prefix <- file.path(".",paste(".Rsubread_cCounts_Tmp_for_Pid_",Sys.getpid(),"_Rproc",sep=""))
  raw.fc.annot <- NA
  df.sample.info <- data.frame(stringsAsFactors=F)
  cc.sample.sheet.path <- paste0(temp.file.prefix,".samplesheet")

  annlist <- .get.annotation.file(annot.inbuilt, annot.ext, isGTFAnnotationFile)
  ann <- annlist$ann
  annot.screen.output <- annlist$screen
  delete.annot.file <- annlist$delete
  readAssignmentFile <- NULL
 
  if(input.mode=="FASTQ" || input.mode == "FASTQ-dir"){
    if(input.mode == "FASTQ-dir") sample.info.idx <- .scan.fastq.dir(sample)
    #print(sample.info.idx)
    if(!("BarcodeUMIFile" %in%  colnames(sample.info.idx) && "ReadFile" %in%  colnames(sample.info.idx) )) stop("You need to provide BC+UMI and Genomic sequence files")
    combined.fastq.names <- ""
    for(rowi in 1:nrow(sample.info.idx)){
      df1 <- as.character(sample.info.idx[rowi,"BarcodeUMIFile"])
      df2 <- as.character(sample.info.idx[rowi,"ReadFile"])
      R1.file.name <- .check_and_NormPath(df1, mustWork=TRUE, "The barcode FASTQ file in sample.info.idx")
      R2.file.name <- .check_and_NormPath(df2, mustWork=TRUE, "The genomic read FASTQ file in sample.info.idx")
      combined.fastq.names <- paste0( combined.fastq.names,.SCRNA_FASTA_SPLIT1, R1.file.name, .SCRNA_FASTA_SPLIT2,".",.SCRNA_FASTA_SPLIT2, R2.file.name)
    }

    combined.fastq.names <- substr(combined.fastq.names, nchar(.SCRNA_FASTA_SPLIT1)+1, 9999999)
    if(is.null(cell.barcode)){
      guess.cellbc.and.idx <- .find_best_CellBC_and_DualIdx(combined.fastq.names, temp.file.prefix, "N/A", input.mode="fastq", cell.bc.sup.rate=ifelse(is.null(cell.barcode),.6,-1))
      cell.barcode <- guess.cellbc.and.idx$cell.barcode
    }else{
      cell.barcode <- .check_and_NormPath(cell.barcode, mustWork=T, opt="cell.barcode")
    }

    if(onlyDetectBarcode){
      cat("Barcode is",cell.barcode,"\n")
      return(NA)
    }

     .index.names.to.sheet.FASTQ.mode(sample.info.idx, cc.sample.sheet.path)
    opt <- c("--inputMode","FASTQ","--cellBarcodeFile", cell.barcode,"--reportExcludedBarcodes",as.numeric(reportExcludedBarcodes),"--dataset", combined.fastq.names, "--sampleSheetFile", cc.sample.sheet.path, "--index", index, "--annotation", ann, "--geneIdColumn", GTF.attrType, "--annotationType", GTF.featureType, "--threads", nthreads, "--output", temp.file.prefix, "--maxMismatch", maxMismatchBases, "--minVotesPerRead", minVotesPerRead, "--subreadsPerRead", subreadsPerRead, "--reportedAlignmentsPerRead", nBestLocations, "--maxDiffToTopVotes", maxDiffToTopVotes, "--minMappedLength", minMappedLength, "--umiCutoff",  ifelse(is.null(umi.cutoff), -999, umi.cutoff))
    if(detectJunctions)opt <- c(opt, "--junctionDetection")
    if(enableSoftClipping) opt <- c(opt, "--enableSoftClipping")
    if(isGTFAnnotationFile)opt <- c(opt, "--isGTFannotation")
    if(!unique.mapping)opt <- c(opt, "--reportMultiMappingReads")
    if(barcoding.mode=="VisiumHD") opt <- c(opt, "--VisiumHD_barcode")
    if(!is.null(cell.level.junctions)) opt <- c(opt, "--cluster_junctions", cell.level.junctions)
    if(!is.null(cell.cluster.map)) opt <- c(opt, "--cluster_map", cell.cluster.map)
    env.readAssignmentFile <- Sys.getenv("CELLCOUNTS_DETAIL_OUT_FILENAME")
    if(!identical(env.readAssignmentFile, "")) opt <- c(opt, "--readAssignmentFile", env.readAssignmentFile)
 

    cmd <- paste(opt,collapse=.R_param_splitor)
    n <- length(unlist(strsplit(cmd,.R_param_splitor)))
    C_args <- .C("R_cellCounts",as.integer(n),as.character(cmd),PACKAGE="Rsubread")
 
    annot.file <- paste0(temp.file.prefix,".Annot")
    if(file.exists(annot.file)){
      bam.for.FC <- c()
      raw.fc.annot<-read.delim(annot.file, header=T, stringsAsFactors=F)
      some.results <- .load.all.scSamples(temp.file.prefix, as.character(raw.fc.annot$GeneID), useMetaFeatures, raw.fc.annot, umi.cutoff)

      fc[["counts"]] <- list()
      if(reportExcludedBarcodes)fc[["counts.excluded.barcodes"]] <- list()
      for(spi in 1:nrow(some.results[["Sample.Table"]])){
        samplename <- as.character(some.results[["Sample.Table"]][["SampleName"]][spi])
        fc[["counts"]][[samplename]] <- some.results[[sprintf("Sample.%d", spi)]][["Counts"]] # only one sample.
        if(reportExcludedBarcodes)fc[["counts.excluded.barcodes"]][[samplename]] <- some.results[[sprintf("Sample.%d", spi)]][["ExcludedCells"]] # only one sample.
        if(is.null(umi.cutoff))fc[["cell.confidence"]][[samplename]] <- some.results[[sprintf("Sample.%d", spi)]][["HighConfidneceCell"]]
      }
      df.sample.info <- .extract.sample.table.cols(NA,some.results,input.mode="fastq", umi.cutoff=umi.cutoff)
    } else has.error <- T
  }else if(input.mode=="BCL"){
    sample.info.idx$SampleName <- as.character(sample.info.idx$SampleName)
    if('IndexSetName' %in% colnames(sample.info.idx))sample.info.idx$IndexSetName <- as.character(sample.info.idx$IndexSetName)

    dirs <- unique( sample.info.idx$InputDirectory )
    fc[["counts"]] <- list()
    if(reportExcludedBarcodes)fc[["counts.excluded.barcodes"]] <- list()
  
    for(dirname in dirs) .check_and_NormPath(dirname, mustWork=TRUE, "InputDirectory in sample.info.idx") # check files before the slow mapping/counting step.

    dirno <- 1
    for(dirname in dirs){
      if(has.error) break
      unique.samples <- unique( as.character(sample.info.idx$SampleName[ sample.info.idx$InputDirectory == dirname ] ))
  
      dual.index.ABlist <- .index.names.to.sheet.raw.dir.mode(dirname, sample.info.idx, cc.sample.sheet.path)
      guess.cellbc.and.idx <- .find_best_CellBC_and_DualIdx(dirname, temp.file.prefix, cc.sample.sheet.path, A_and_B.dual.index.list=dual.index.ABlist, cell.bc.sup.rate=ifelse(is.null(cell.barcode),.6,-1))
      if(is.null(cell.barcode)){
        cell.barcode <- guess.cellbc.and.idx$cell.barcode
      }else{
        cell.barcode <- .check_and_NormPath(cell.barcode, mustWork=T, opt="cell.barcode")
      }
      
      if(onlyDetectBarcode){
        cat("Barcode is",cell.barcode,"\n")
        return(NA)
      }
  
      full_dirname <- .check_and_NormPath(dirname, mustWork=TRUE, "InputDirectory in sample.info.idx")
      is_dual_index <- .index.names.to.sheet.raw.dir.mode(dirname, sample.info.idx, cc.sample.sheet.path, which.dual.index=guess.cellbc.and.idx$dual.index)
      is_dual_index <- (F==any(is.null(is_dual_index)))
      generate.scRNA.BAM <- TRUE

      opt <- c("--cellBarcodeFile", cell.barcode,"--reportExcludedBarcodes",as.numeric(reportExcludedBarcodes),"--dataset", dirname, "--sampleSheetFile", cc.sample.sheet.path, "--index", index, "--annotation", ann, "--geneIdColumn", GTF.attrType, "--annotationType", GTF.featureType, "--threads", nthreads, "--output", temp.file.prefix, "--maxMismatch", maxMismatchBases, "--minVotesPerRead", minVotesPerRead, "--subreadsPerRead", subreadsPerRead, "--maxDiffToTopVotes",maxDiffToTopVotes, "--minMappedLength", minMappedLength, "--umiCutoff", ifelse(is.null(umi.cutoff), -999, umi.cutoff))
      if(isGTFAnnotationFile)opt <- c(opt, "--isGTFannotation")
      if(!unique.mapping)opt <- c(opt, "--reportMultiMappingReads")
      if(detectJunctions)opt <- c(opt, "--junctionDetection")
      if(enableSoftClipping) opt <- c(opt, "--enableSoftClipping")
      if(barcoding.mode=="VisiumHD") opt <- c(opt, "--VisiumHD_barcode")
      if(!is.null(cell.level.junctions)) opt <- c(opt, "--cluster_junctions", cell.level.junctions)
      if(!is.null(cell.cluster.map)) opt <- c(opt, "--cluster_map", cell.cluster.map)

      cmd <- paste(opt,collapse=.R_param_splitor)
      n <- length(unlist(strsplit(cmd,.R_param_splitor)))
      #print(cmd)
      C_args <- .C("R_cellCounts",as.integer(n),as.character(cmd),PACKAGE="Rsubread")

      annot.file <- paste0(temp.file.prefix,".Annot")
      dirno <- dirno +1
      if(file.exists(annot.file)){
        if(any(is.na(raw.fc.annot))) raw.fc.annot<-read.delim(annot.file, header=T, stringsAsFactors=F)
        some.results <- .load.all.scSamples(temp.file.prefix, as.character(raw.fc.annot$GeneID), useMetaFeatures, raw.fc.annot, umi.cutoff)
        for(spi in 1:nrow(some.results[["Sample.Table"]])){
          samplename <- as.character(some.results[["Sample.Table"]][["SampleName"]][spi])
          fc[["counts"]][[samplename]] <- some.results[[sprintf("Sample.%d", spi)]][["Counts"]] # only one sample.
          if(reportExcludedBarcodes)fc[["counts.excluded.barcodes"]][[samplename]] <- some.results[[sprintf("Sample.%d", spi)]][["ExcludedCells"]] # only one sample.
          if(is.null(umi.cutoff))fc[["cell.confidence"]][[samplename]] <- some.results[[sprintf("Sample.%d", spi)]][["HighConfidneceCell"]]
        }
        stt <- .extract.sample.table.cols(full_dirname,some.results, umi.cutoff=umi.cutoff)
        df.sample.info <- rbind(df.sample.info, stt)
      } else has.error <-T
    }
  } else if(input.mode == "BAM"){
    unique.samples <- unique(as.character(sample.info.idx$SampleName))
    if(is.null(cell.barcode)){
      guess.cellbc.and.idx <- .find_best_CellBC_and_DualIdx(sample$BAMFile, temp.file.prefix, "N/A", input.mode="bam", cell.bc.sup.rate=ifelse(is.null(cell.barcode),.6,-1))
      cell.barcode <- guess.cellbc.and.idx$cell.barcode
    }else{
      cell.barcode <- .check_and_NormPath(cell.barcode, mustWork=T, opt="cell.barcode")
    }

    unique.samples <- unique(as.character(sample.info.idx$SampleName))
    for(this.sample in unique.samples){
      if(has.error) break
      .index.names.to.sheet.BAM.mode(data.frame(BAMFile="COMBINED.INPUT",SampleName=as.character(this.sample),stringsAsFactors=F), cc.sample.sheet.path)
      BAM.names <- paste(sample.info.idx$BAMFile[ as.character(sample.info.idx$SampleName) == this.sample ], collapse=.SCRNA_FASTA_SPLIT1)
      generate.scRNA.BAM <- TRUE

      opt <- c("--inputMode","BAM","--cellBarcodeFile", cell.barcode, "--reportExcludedBarcodes",as.numeric(reportExcludedBarcodes),"--dataset", BAM.names, "--sampleSheetFile", cc.sample.sheet.path, "--index", index, "--annotation", ann, "--geneIdColumn", GTF.attrType, "--annotationType", GTF.featureType, "--threads", nthreads, "--output", temp.file.prefix, "--maxMismatch", maxMismatchBases, "--minVotesPerRead", minVotesPerRead, "--subreadsPerRead", subreadsPerRead, "--maxDiffToTopVotes",maxDiffToTopVotes, "--minMappedLength", minMappedLength, "--umiCutoff", ifelse(is.null(umi.cutoff), -999, umi.cutoff))
      if(isGTFAnnotationFile)opt <- c(opt, "--isGTFannotation")
      if(!unique.mapping)opt <- c(opt, "--reportMultiMappingReads")
      if(detectJunctions)opt <- c(opt, "--junctionDetection")
      if(enableSoftClipping) opt <- c(opt, "--enableSoftClipping")
      if(barcoding.mode=="VisiumHD")  c(opt, "--VisiumHD_barcode")

      cmd <- paste(opt,collapse=.R_param_splitor)
      n <- length(unlist(strsplit(cmd,.R_param_splitor)))
      #print(cmd)
      C_args <- .C("R_cellCounts",as.integer(n),as.character(cmd),PACKAGE="Rsubread")

      annot.file <- paste0(temp.file.prefix,".Annot")
      if(file.exists(annot.file)){
        fc[["counts"]] <- list()
        if(reportExcludedBarcodes)fc[["counts.excluded.barcodes"]] <- list()

        raw.fc.annot<-read.delim(annot.file, header=T, stringsAsFactors=F)
        some.results <- .load.all.scSamples(temp.file.prefix, as.character(raw.fc.annot$GeneID), useMetaFeatures, raw.fc.annot, umi.cutoff)
        for(spi in 1:nrow(some.results[["Sample.Table"]])){
          samplename <- as.character(some.results[["Sample.Table"]][["SampleName"]][spi])
          fc[["counts"]][[samplename]] <- some.results[[sprintf("Sample.%d", spi)]][["Counts"]] # only one sample.
          if(reportExcludedBarcodes)fc[["counts.excluded.barcodes"]][[samplename]] <- some.results[[sprintf("Sample.%d", spi)]][["ExcludedCells"]] # only one sample.
          if(is.null(umi.cutoff))fc[["cell.confidence"]][[samplename]] <- some.results[[sprintf("Sample.%d", spi)]][["HighConfidneceCell"]]
        }
        df.sample.info <- rbind(df.sample.info,.extract.sample.table.cols(NA,some.results, input.mode="bam", umi.cutoff=umi.cutoff))
      }else has.error<-T
    }
  }
  if(detectJunctions){
    fc[["junction.counts"]] <- read.delim(paste0(temp.file.prefix,".jcounts"), sep="\t")
    ncoln <- ncol(fc[["junction.counts"]]) - length(some.results[["Sample.Table"]][["SampleName"]])*2 +1
    for(spi in some.results[["Sample.Table"]][["SampleName"]]){
        colnames(fc[["junction.counts"]])[ncoln] <- paste0("Supporting_Reads_", spi)
        colnames(fc[["junction.counts"]])[ncoln +1] <- paste0("Nonsupporting_Reads_", spi)
        ncoln <- ncoln+2
    }
  }
  if(F&&grepl("scRNA-sample-human-COPD-non_small.BAMs",getwd())) warning("NOT DELETING TEMP FILES !!!!") else  .del.temp.files(substr(temp.file.prefix,4,99)) 

  fc[["annotation"]] <- raw.fc.annot
  fc[["sample.info"]] <- df.sample.info
  if(has.error) { 
    cat("No results were generated.\n\n")
    return(NULL)
  } else {
    cat("\nThe cellCounts program has finished successfully.\n\n")
    return(fc)
  }
}

.R_param_splitor <- "\027"
.R_flist_splitor <- "\026"
.filepath_maximum_len <- 990L

.stop_quietly <- function() {
  opt <- options(show.error.messages = FALSE)
  on.exit(options(opt))
  stop()
}

.is.64bit.system <- function(){
    if(grepl("[-_]64",Sys.info()[["machine"]]))return(TRUE)
    if(grepl("aarch64",Sys.info()[["machine"]]))return(TRUE)
    if(grepl("arm64",Sys.info()[["machine"]]))return(TRUE)
    
    return(FALSE)
}

.check_string_param <- function(argu, opt=NULL){
  if(!is.null(argu)){
    if(any(grepl(.R_param_splitor,  argu))){
      stop(paste0("Error: the argument for ",opt," contains the internal splitor of featureCounts (\\027). The \\027 character is unallowd in this parameter."))
    }
  }
}

.check_and_NormPath<- function(files, mustWork=F, opt=NULL){
  if(any(is.na(files)) || any(is.null(files)) || any(class(files) != "character")){
    if( is.null(opt) ){
      if(any(is.na(files)) || any(is.null(files))){
        stop("Error: the file name is NA or NULL.")
      }else{
        stop(paste0("Error: the file name must be a character vector. The current input is ",class(files)))
      }
    }else{
      if(any(is.na(files)) || any(is.null(files))){
        stop(paste0("Error: the argument to '",opt,"' is NA or NULL."))
      }else{
        stop(paste0("Error: the argument to '",opt,"' must be a character vector. The current input is ",class(files)))
      }
    }
  }
  rv <- normalizePath(files, mustWork = mustWork)
  if(any(grepl(.R_param_splitor, rv))){
    stop(paste0("Error: the file path to '",opt,"' contains the internal splitor of featureCounts (\\027). The \\027 character is unallowd in the file names or in the paths."))
  }

  if(any(grepl("\t", rv))){
    stop(paste0("Error: the file path to '",opt,"' contains <TAB> character(s). The TAB character is unallowd in the file names or in the paths."))
  }

  if(any(grepl(.R_flist_splitor, rv))){
    stop(paste0("Error: the file path to '",opt,"' contains the internal splitor of featureCounts (\\026). The \\026 character is unallowd in the file names or in the paths."))
  }

  if(any(nchar(rv)>=.filepath_maximum_len)){
    errv <- rv[ nchar(rv)>=.filepath_maximum_len ]
    stop(paste0("Error: the file name and path of ",opt," is longer than ",.filepath_maximum_len," bytes. Beaware that all the file names are normalized to include the full path to the original file. The value is '", errv[1],"'"))
  }
  return(rv)
}

.flatten.and.numeric <- function(logicarr){
    paste0(as.numeric(logicarr),collapse="")
}

.get.annotation.file <- function(annot.inbuilt, annot.ext, isGTFAnnotationFile){
    delete.annot.file <- FALSE
    annot.screen.output <- 'R data.frame'
    if(is.null(annot.ext)){
      switch(tolower(as.character(annot.inbuilt)),
        mm9={
          ann <- system.file("annot","mm9_RefSeq_exon.txt",package="Rsubread")
          annot.screen.output <- 'inbuilt (mm9)'
          cat("NCBI RefSeq annotation for mm9 (build 37.2) is used.\n")
        },
        mm10={
          ann <- system.file("annot","mm10_RefSeq_exon.txt",package="Rsubread")
          annot.screen.output <- 'inbuilt (mm10)'
          cat("NCBI RefSeq annotation for mm10 (build 38.1) is used.\n")
         },
        mm39={
          ann <- system.file("annot","mm39_RefSeq_exon.txt.gz",package="Rsubread")
          annot.screen.output <- 'inbuilt (mm39)'
          cat("NCBI RefSeq annotation for mm39 (build 39) is used.\n")
         },
        hg19={
          ann <- system.file("annot","hg19_RefSeq_exon.txt",package="Rsubread")
          annot.screen.output <- 'inbuilt (hg19)'
          cat("NCBI RefSeq annotation for hg19 (build 37.2) is used.\n")
           },
        hg38={
          ann <- system.file("annot","hg38_RefSeq_exon.txt",package="Rsubread")
          annot.screen.output <- 'inbuilt (hg38)'
          cat("NCBI RefSeq annotation for hg38 (build 38.2) is used.\n")
           },
           {
        stop("In-built annotation for ", annot.inbuilt, " is not available.\n")
           }
      ) # end switch
    }
    else{
      if(is.character(annot.ext)){
        annot.ext <- .check_and_NormPath(annot.ext, mustWork=T, opt="external annotation")
        ann <- annot.ext
        annot.screen.output <- paste0(basename(ann), " (", ifelse(isGTFAnnotationFile, "GTF", "SAF"), ")");
      }
      else{
        annot_df <- as.data.frame(annot.ext,stringsAsFactors=FALSE)
        if(sum(c("geneid","chr","start","end", "strand") %in% tolower(colnames(annot_df))) != 5)
          stop("One or more required columns are missing in the provided annotation data. Please refer to help page for annotation format.\n")
        colnames(annot_df) <- tolower(colnames(annot_df))
        annot_df <- data.frame(geneid=annot_df$geneid,chr=annot_df$chr,start=annot_df$start,end=annot_df$end,strand=annot_df$strand,stringsAsFactors=FALSE)
        annot_df$chr <- as.character(annot_df$chr)
        fout_annot <- file.path(".",paste(".Rsubread_UserProvidedAnnotation_pid",Sys.getpid(),sep=""))
        oldScipen <- options(scipen=999)
        write.table(x=annot_df,file=fout_annot,sep="\t",row.names=FALSE,quote=FALSE)
        options(oldScipen)
        ann <- fout_annot
        delete.annot.file <- TRUE
      }
    }
    return(list(ann=ann, screen=annot.screen.output, delete=delete.annot.file))
}


featureCounts <- function(files,annot.inbuilt="mm39",annot.ext=NULL,isGTFAnnotationFile=FALSE,GTF.featureType="exon",GTF.attrType="gene_id",GTF.attrType.extra=NULL,chrAliases=NULL,useMetaFeatures=TRUE,allowMultiOverlap=FALSE,minOverlap=1,fracOverlap=0,fracOverlapFeature=0,largestOverlap=FALSE,nonOverlap=NULL,nonOverlapFeature=NULL,readShiftType="upstream",readShiftSize=0,readExtension5=0,readExtension3=0,read2pos=NULL,countMultiMappingReads=TRUE,fraction=FALSE,isLongRead=FALSE,minMQS=0,splitOnly=FALSE,nonSplitOnly=FALSE,primaryOnly=FALSE,ignoreDup=FALSE,strandSpecific=0,juncCounts=FALSE,genome=NULL,isPairedEnd=FALSE,countReadPairs=TRUE,requireBothEndsMapped=FALSE,checkFragLength=FALSE,minFragLength=50,maxFragLength=600,countChimericFragments=TRUE,autosort=TRUE,nthreads=1,byReadGroup=FALSE,reportReads=NULL,reportReadsPath=NULL,tmpDir=".",verbose=FALSE)
{
    delete.annot.file <- FALSE
    if(!.is.64bit.system()) warning("your system seems to be 32-bit. Rsubread supports 32-bit systems to a limited level only.\nWe recommend that Rsubread be run on 64-bit systems to avoid any possible problems.\n\n",call.=FALSE)

    extra.params <- .retrieve.tmp.parameters()
    sampleSheet <- NULL
    generate.scRNA.BAM <- TRUE
    cellBarcodeList <- NULL
    umi.cutoff <- NULL
    BAM_is_ScRNA_Fastq <- FALSE
    BAM_is_ScRNA_BAM <- FALSE
    BAM_is_Rerun_Persample <- FALSE
    Is_Dual_Index <- FALSE
    BAM_file_no <- 0

    if("sampleSheet" %in% names(extra.params)) sampleSheet <- extra.params[["sampleSheet"]]
    if("generate.scRNA.BAM" %in% names(extra.params)) generate.scRNA.BAM <- extra.params[["generate.scRNA.BAM"]]
    if("cellBarcodeList" %in% names(extra.params)) cellBarcodeList <- extra.params[["cellBarcodeList"]]
    if("BAM_is_ScRNA_Fastq" %in% names(extra.params)) BAM_is_ScRNA_Fastq <- extra.params[["BAM_is_ScRNA_Fastq"]]
    if("BAM_is_ScRNA_BAM" %in% names(extra.params)) BAM_is_ScRNA_BAM <- extra.params[["BAM_is_ScRNA_BAM"]]
    if("BAM_is_Rerun_Persample" %in% names(extra.params)) BAM_is_Rerun_Persample <- extra.params[["BAM_is_Rerun_Persample"]]
    if("umi.cutoff" %in% names(extra.params)) umi.cutoff <- extra.params[["umi.cutoff"]]
    if("Is_Dual_Index" %in% names(extra.params)) Is_Dual_Index <- extra.params[["Is_Dual_Index"]]
    if("BAM_file_no" %in% names(extra.params)) BAM_file_no <- extra.params[["BAM_file_no"]]

    .check_string_param(annot.inbuilt, "annot.inbuilt")
    .check_string_param(GTF.featureType, "GTF.featureType")
    .check_string_param(GTF.attrType, "GTF.attrType")
    .check_string_param(GTF.attrType.extra, "GTF.attrType.extra")
    .check_string_param(readShiftType, "readShiftType")
    .check_string_param(sampleSheet, "sampleSheet")
    .check_string_param(cellBarcodeList, "cellBarcodeList")

    if(length(countReadPairs)>1){
        if(length(countReadPairs) != length(files))stop("The argumet for countReadPairs is a vector, but it has a different length to the files vector.")
        if(length(isPairedEnd)>1 && length(countReadPairs)!=length(isPairedEnd))stop("The argumets for countReadPairs and isPairedEnd are both vectors, but they have different lengths.")
    }
    if(length(isPairedEnd)>1){
        if(length(isPairedEnd) != length(files))stop("The argumet for isPairedEnd is a vector, but it has a different length to the files vector.")
        countReadPairs <- ifelse( isPairedEnd, countReadPairs, F )
    }else{
        if(!isPairedEnd) countReadPairs <- F
    }

    if(length(GTF.featureType)>1) GTF.featureType<-paste(GTF.featureType, collapse=",")
    out.base.names <- basename(files)
    if(any(duplicated(out.base.names))){
      out.col.names <- files
    }else{
      out.col.names <- out.base.names
    }
    #out.col.names <-gsub("[[:punct:]]+", ".", out.col.names)
    #out.col.names <-gsub(" ", ".", out.col.names)

    if(!is.character(files)) stop("files must be a character vector of file paths")
    files <- .check_and_NormPath(files, mustWork=T, opt="files")
    if(!is.null(annot.ext) && is.character(annot.ext)) annot.ext <- .check_and_NormPath(annot.ext, mustWork=T, opt="annot.ext")
    if(!is.null(chrAliases))chrAliases <- .check_and_NormPath(chrAliases, mustWork=T, opt="chrAliases")
    if(!is.null(genome)) genome <- .check_and_NormPath(genome, mustWork=T, opt="genome")
    if(!is.null(cellBarcodeList)) cellBarcodeList <- .check_and_NormPath(cellBarcodeList, mustWork=T, opt="cellBarcodeList")
    if(!is.null(sampleSheet)) sampleSheet <- .check_and_NormPath(sampleSheet, mustWork=T, opt="sampleSheet")
    if(!is.null(reportReadsPath)){
        reportReadsPath <- .check_and_NormPath(reportReadsPath, mustWork=T, opt="reportReadsPath")
    }else reportReadsPath <- ' '
    strandSpecific<-as.character(strandSpecific)
    strandSpecific<-paste(strandSpecific, collapse=".")
    strandSpecific<-gsub(",", ".", strandSpecific)

    annlist <- .get.annotation.file(annot.inbuilt, annot.ext, isGTFAnnotationFile)
    ann <- annlist$ann
    annot.screen.output <- annlist$screen
    delete.annot.file <- annlist$delete

    if(readShiftSize < 0){
        stop("The value of the readShiftSize parameter should not be negative.")
    }

    readShiftType <- match.arg(readShiftType, c("upstream","downstream","left","right"))

    if(readExtension5 < 0){
        stop("The value of the readExtension5 parameter should not be negative.")
    }
    if(readExtension3 < 0){
        stop("The value of the readExtension3 parameter should not be negative.")
    }

    fout <- file.path(".",paste(".Rsubread_featureCounts_pid",Sys.getpid(),sep=""))

    files_C <- paste(files,collapse=.R_flist_splitor)
    
    if(nchar(files_C) == 0) stop("No read files provided!")

    genome_C <- genome
    if(is.null(genome))
      genome_C <- " "
    
    chrAliases_C <- chrAliases
    if(is.null(chrAliases))
      chrAliases_C <- " "

    read2pos_C <- read2pos
    if(is.null(read2pos)) read2pos_C <- 0

    split_C <- 0
    if(splitOnly) split_C <- 1
    if(nonSplitOnly) split_C <- 2

    PE_orientation <- "fr"
    
    if(is.null(reportReads)) {
        reportReads_C <- 0
    } else if(reportReads == "CORE") {
        reportReads_C <- 10
    } else if(reportReads == "SAM") {
        reportReads_C <- 50
    } else if(reportReads == "BAM") {
        reportReads_C <- 500
    } else
        stop("Invalid value was provided for reportReads parameter.")

    do_detection_calls <- FALSE
    max_missing_bases_in_read <- -1
    max_missing_bases_in_feature <- -1
    GTF.attrType.extra_str <- " "
    if(!is.null(nonOverlap)) max_missing_bases_in_read <- nonOverlap
    if(!is.null(nonOverlapFeature)) max_missing_bases_in_feature <- nonOverlapFeature
    if(!is.null(GTF.attrType.extra))GTF.attrType.extra_str <- paste(GTF.attrType.extra, collapse="\t")
    if(is.null(sampleSheet)) sampleSheet<-' '
    if(is.null(cellBarcodeList)) cellBarcodeList<-' '
      

    maxMOp <- 65536
    #print(.flatten.and.numeric(countReadPairs))
    #print(.flatten.and.numeric(isPairedEnd))
    cmd <- paste("readSummary",ann,files_C,fout,.flatten.and.numeric(countReadPairs),minFragLength,maxFragLength,0,as.numeric(allowMultiOverlap),as.numeric(useMetaFeatures),nthreads,as.numeric(isGTFAnnotationFile),strandSpecific,reportReads_C,as.numeric(requireBothEndsMapped),as.numeric(!countChimericFragments),as.numeric(checkFragLength),GTF.featureType,GTF.attrType,minMQS,as.numeric(countMultiMappingReads),chrAliases_C," ",as.numeric(FALSE),14,readExtension5,readExtension3,minOverlap,split_C,read2pos_C," ",as.numeric(ignoreDup),as.numeric(!autosort),as.numeric(fraction),as.numeric(largestOverlap),PE_orientation,as.numeric(juncCounts),genome_C,maxMOp,0,as.numeric(fracOverlap),as.character(tmpDir),"0",as.numeric(byReadGroup),as.numeric(isLongRead),as.numeric(verbose),as.numeric(fracOverlapFeature), as.numeric(do_detection_calls), as.numeric(max_missing_bases_in_read), as.numeric(max_missing_bases_in_feature), as.numeric(primaryOnly), reportReadsPath, GTF.attrType.extra_str, annot.screen.output, readShiftType,readShiftSize, sampleSheet, cellBarcodeList ,.flatten.and.numeric(isPairedEnd), as.numeric(generate.scRNA.BAM), ifelse(BAM_is_ScRNA_Fastq, 4, ifelse(BAM_is_ScRNA_BAM, 5,3)), as.numeric(BAM_is_Rerun_Persample), ifelse(is.null(umi.cutoff), -1, umi.cutoff),ifelse(Is_Dual_Index,"Dual-Index","Single-Index"),as.numeric(BAM_file_no),sep=.R_param_splitor)
    #print(cmd)
    n <- length(unlist(strsplit(cmd, .R_param_splitor )))
    C_args <- .C("R_readSummary_wrapper",as.integer(n),as.character(cmd),PACKAGE="Rsubread")

    if(file.exists(fout)){
        add_attr_numb <- 0
        if(!is.null(GTF.attrType.extra)) add_attr_numb <- length(GTF.attrType.extra)

        x <- read.delim(fout,stringsAsFactors=FALSE, sep="\t")
        colnames(x)[1:6] <- c("GeneID","Chr","Start","End","Strand","Length")
        colnames(x)[(7 + add_attr_numb ): (add_attr_numb + 6+length(out.col.names)) ] <- out.col.names
        x_summary <- read.delim(paste(fout,".summary",sep=""), stringsAsFactors=FALSE, sep="\t")
        colnames(x_summary)[2:ncol(x_summary)] <- out.col.names

        if(juncCounts){
            x_jcounts <- read.delim(paste(fout,".jcounts",sep=""), stringsAsFactors=FALSE, sep="\t")
            colnames(x_jcounts)[-(1:14)]  <- out.col.names
        }

        file.remove(fout)
        file.remove(paste(fout,".summary",sep=""))

        if(juncCounts)
            file.remove(paste(fout,".jcounts",sep=""))
        
        if(delete.annot.file) 
          file.remove(ann)

        if(ncol(x) <= (6 + add_attr_numb)){
          cat("No count data were generated.\n")
          .stop_quietly()
        }
        
        y <- as.matrix(x[,-c(1:(6 + add_attr_numb))])
        colnames(y) <- colnames(x)[-c(1:(6 + add_attr_numb))]
        rownames(y) <- x$GeneID

        if(juncCounts)
            z <- list(counts=y,counts_junction=x_jcounts,annotation=x[,1:(6 + add_attr_numb)],targets=out.col.names,stat=x_summary)
        else
            z <- list(counts=y,annotation=x[,1:(6 + add_attr_numb)],targets=out.col.names,stat=x_summary)    
        z    
    }else{
        cat("No counts were generated.\n")
        .stop_quietly()
    }
}

sublong <- function(index, readFiles, outputFiles, outputFormat="BAM" , nthreads=1) {
    .check_string_param(outputFormat,"outputFormat")
	readFiles <- .check_and_NormPath(as.character(readFiles), mustWork=T, opt="readFiles")
	outputFiles <- .check_and_NormPath(as.character(outputFiles), mustWork=F , opt="outputFiles")

	if(length(readFiles) != length(outputFiles))
		stop("The number of input file names is different from the number of output file names.")

	if(!all(file.exists(readFiles)))
		stop("One or more input files cannot be found.")

	if(!all(file.exists(dirname(outputFiles))))
		stop("Invalid path was found in output file name(s).")

	for(i in 1:length(readFiles)){
		opt <- paste("-i",index,sep=.R_param_splitor)
		if(tolower(outputFormat) == "sam")
			opt <- paste(opt,"--SAMoutput",sep=.R_param_splitor)
		opt <- paste(opt,"-r",readFiles[i],"-T",nthreads,"-o",outputFiles[i],sep=.R_param_splitor)
	
		cmd <- paste("Rsublong",opt,sep=.R_param_splitor)
		n <- length(unlist(strsplit(cmd,.R_param_splitor)))
		C_args <- .C("R_sublong_wrapper",as.integer(n),as.character(cmd),PACKAGE="Rsubread")
	}
}

atgcContent <- function(filename, basewise=FALSE)
{
	  filename <- .check_and_NormPath(filename, mustWork=T, opt="filename")
	  sequence_file <- paste("./.Rsubread_atgcContent_sequence_pid",Sys.getpid(),sep="")
	  perc_file <- paste("./.Rsubread_atgcContent_percentage_pid",Sys.getpid(),sep="")
	  .C("retrieve_sequence", as.character(filename), as.character(sequence_file), PACKAGE="Rsubread")
	  .C("atgcContent", as.character(sequence_file), as.character(perc_file), as.integer(basewise))
	  data <- as.matrix(read.csv(perc_file, header=T))
	  file.remove(sequence_file)
	  file.remove(perc_file)
	  if (basewise){
		percentage <- data
		percentage <- as.matrix(percentage[-1,])
		percentage <- as.matrix(t(percentage))
		colnames(percentage) <- 1:ncol(percentage)
		return(percentage)
	  } 
	  else 
	  {
		return(data)
	  }
}

processExons <- function(filename = "human_seq_gene.md", species="hg")
{
    .check_string_param(species,'species')
	if (species == "mm"){
			filename <- "mouse_seq_gene.md"
	}
		
	if (file.exists(filename) == FALSE){

		print("Souce file specified doesn't exist!")

	} 

	else 

	{
		x <- read.delim(filename, stringsAsFactors=FALSE)
		if (species == "hg"){
			y <- x[x$group_label=="GRCh37.p2-Primary Assembly" | x$group_label=="GRCh37.p2-non-nuclear", ]
		} else {
			if (species == "mm"){
				y <- x[x$group_label=="MGSCv37-C57BL/6J",]
			}
		}
		y <- y[y$feature_type=="CDS" | y$feature_type=="UTR",]
		y <- y[,c("chromosome","chr_start","chr_stop","chr_orient","feature_id")]

		if (species == "hg"){
			chr_max <- 22
		} else {
			chr_max <- 19
		}
		for(i in 1:chr_max){
			index <- y$chromosome %in% i
			y$chromosome[index] <- rep(paste("chr",i,sep=""),sum(index))
		}
		
		index <- y$chromosome %in% "X"
		y$chromosome[index] <- rep("chrX",sum(index))
		index <- y$chromosome %in% "Y"
		y$chromosome[index] <- rep("chrY",sum(index))


		###NT <- unique(y$chromosome[grep("NT_",y$chromosome)])
		###for(i in NT){
		###	index <- y$chromosome %in% i
		###	i1 <- unlist(strsplit(i,"|",fixed=TRUE))
		###	i1 <- i1[2]
		###	y$chromosome[index] <- rep(i1,sum(index))
		###}
		z <- y[substr(y$chromosome,1,3) == "chr",]
		z$feature_id <- substring(z$feature_id, 8, 1000000L)
		
		### sort utr and cds according to their chromosome and chr_start 
		
		sort.z <- z[order(z$chromosome, z$chr_start),]
		
		### specify file header according to species
		if (species == "mm"){
			header <- "mm9_"
		} else {
			header <- "hg19" 
		}
		utr_cds_file <- paste(header, "utr_cds.txt", sep="")
		exon_file <- paste(header,"exon.txt",sep="")
		gene_file <- paste(header,"gene.txt",sep="")
		ir_file <- paste(header,"integenic_region.txt",sep="")

		if (length(unique(z$feature_id)) > 1000000){
			print("The input file contains too many genes.\n")
		} else {
			write.table(sort.z,file=utr_cds_file, quote=FALSE,sep="\t",row.names=FALSE, col.names=FALSE)
			
			.C("processExons", as.character(utr_cds_file), as.character(exon_file), as.character(gene_file), PACKAGE="Rsubread")
			
			gene <- read.delim(gene_file, stringsAsFactors=FALSE)
			colnames(gene) <- c("entrezid","chromosome", "chr_start","chr_stop")
			sort.gene <- gene[order(gene$chromosome, gene$chr_start),]
			file.remove(gene_file)
			write.table(sort.gene,file=gene_file, quote=FALSE,sep="\t",row.names=FALSE, col.names=FALSE)
			
			exon <- read.delim(exon_file, stringsAsFactors=FALSE)
			colnames(exon) <- c("entrezid","chromosome", "chr_start","chr_stop")
			sort.exon <- exon[order(exon$chromosome, exon$chr_start),]
			file.remove(exon_file)
			write.table(sort.exon,file=exon_file, quote=FALSE,sep="\t",row.names=FALSE, col.names=FALSE)
			
			.C("generate_ir_file", as.character(gene_file), as.character(ir_file), PACKAGE="Rsubread")
			
			file.remove(gene_file)
			file.remove(utr_cds_file)
		}
	
	}
	
	NULL

}

detectionCallAnnotation <- function(species="hg", binsize=2000) {
	if (species=="hg"){
		exonfile <- "hg19_exon.txt"
		irfile <- "hg19_integenic_region.txt"
	}
	if (species == "mm"){
		exonfile <- "mm9_exon.txt"
		irfile <- "mm9_integenic_region.txt"
	}
	
	if ((file.exists(exonfile) == FALSE) || (file.exists(irfile) == FALSE)){

		print("Source files specified doesn't exist!")

	} 

	else 

	{
	
		.C("detectionCallAnnotation", as.character(exonfile), as.character(irfile), as.character(species), as.integer(binsize), PACKAGE="Rsubread")
	
	}
	
	NULL

}

detectionCall <- function(dataset, species="hg", plot=FALSE)
{
	
	dataset <- .check_and_NormPath(dataset, mustWork=T, opt="dataset")
	if (file.exists(dataset) == FALSE) {
		stop("File for the given dataset doesn't exist!\n")
	} 
	if (species == "mm"){
		exon_file <- system.file("annot","mm9_NCBI_exon_GC.txt",package="Rsubread")
        if(exon_file == ""){
            ret_df <- download.file("http://bioinf.wehi.edu.au/software/Rsubread/mm9_NCBI_exon_GC.txt",file.path(system.file("annot",package="Rsubread"),"mm9_NCBI_exon_GC.txt"))
            if(ret_df != 0)
                stop("Failed to download file http://bioinf.wehi.edu.au/software/Rsubread/mm9_NCBI_exon_GC.txt")
            exon_file <- system.file("annot","mm9_NCBI_exon_GC.txt",package="Rsubread")
        }
        
		ir_file <- system.file("annot","mm9_NCBI_binned_integenic_region_GC.txt",package="Rsubread")
        if(ir_file == ""){
            ret_df <- download.file("http://bioinf.wehi.edu.au/software/Rsubread/mm9_NCBI_binned_integenic_region_GC.txt",file.path(system.file("annot",package="Rsubread"),"mm9_NCBI_binned_integenic_region_GC.txt"))
            if(ret_df != 0)
                stop("Failed to download file http://bioinf.wehi.edu.au/software/Rsubread/mm9_NCBI_binned_integenic_region_GC.txt")
            ir_file <- system.file("annot","mm9_NCBI_binned_integenic_region_GC.txt",package="Rsubread")
        }

	} 
	
	if(species == "hg"){
		exon_file <- system.file("annot","hg19_NCBI_exon_GC.txt",package="Rsubread")
        if(exon_file == ""){
            ret_df <- download.file("http://bioinf.wehi.edu.au/software/Rsubread/hg19_NCBI_exon_GC.txt",file.path(system.file("annot",package="Rsubread"),"hg19_NCBI_exon_GC.txt"))
            if(ret_df != 0)
                stop("Failed to download file http://bioinf.wehi.edu.au/software/Rsubread/hg19_NCBI_exon_GC.txt")
            exon_file <- system.file("annot","hg19_NCBI_exon_GC.txt",package="Rsubread")
        }
        
		ir_file <- system.file("annot","hg19_NCBI_binned_integenic_region_GC.txt",package="Rsubread")
        if(ir_file == ""){
            ret_df <- download.file("http://bioinf.wehi.edu.au/software/Rsubread/hg19_NCBI_binned_integenic_region_GC.txt",file.path(system.file("annot",package="Rsubread"),"hg19_NCBI_binned_integenic_region_GC.txt"))
            if(ret_df != 0)
                stop("Failed to download file http://bioinf.wehi.edu.au/software/Rsubread/hg19_NCBI_binned_integenic_region_GC.txt")
            ir_file <- system.file("annot","hg19_NCBI_binned_integenic_region_GC.txt",package="Rsubread")
        }

	}

	temp_header <- 	"."

	temp_header <- paste(temp_header,paste("/.Rsubread_pid",Sys.getpid(),sep=""), sep="")
	
	temp_header <- paste(temp_header, "_", sep="")
	
	temp_header <- paste(temp_header, dataset,sep="")
	
	##temp_header <- dataset
	
	
	.C("detectionCall", as.character(dataset), as.character(exon_file), as.character(ir_file), as.character(temp_header), PACKAGE="Rsubread")
	
	##########################################################
	### After processing SAM file and Annotation file in C####
	###  The result will be processed here for statistics ####
	##########################################################

	### ALL CHROMOSOMES
	chrs <- c("chr1", "chr10", "chr11","chr12", "chr13","chr14","chr15","chr16", "chr17","chr18","chr19", "chr2","chr20","chr21","chr22","chr3","chr4", "chr5","chr6", "chr7", "chr8","chr9", "chrX","chrY")


	bg_file <- paste(temp_header, "_mapping_binned_integenic_region_GC.txt", sep="")
	signal_file <- paste(temp_header, "_mapping_exon_GC.txt", sep="")

	if ((file.exists(bg_file) == FALSE) || (file.exists(signal_file) == FALSE)) {

		print("Mapping results for this dataset are not available.\n")
		
	} else {

		######################################################
		########## INTEGENIC REGION EXPRESSION DATA ########## 
		######################################################

		bg <- read.delim(bg_file, header=TRUE)
		
		bg$percent <- bg$gcnum / (bg$chr_stop - bg$chr_start + 1 - bg$nnum)
		
		bg$sqrtnreads <- sqrt(bg$nreads)
		
		lowessfit <- lowess(x=bg$percent, y=bg$sqrtnreads)
		
		lowessfun <- approxfun(x=lowessfit$x, y=lowessfit$y)

		##########################################
		########## GENE EXPRESSION DATA ########## 
		##########################################

		exon <- read.delim(signal_file, header=TRUE)
		exon <- exon[exon$chr %in% chrs, ]
		exon$length <- exon$chr_stop - exon$chr_start + 1
		
		# filter out exons which are covered by other exons
		exon <- exon[exon$nnum + exon$gcnum + exon$atnum >= 0.9*exon$length, ]
		
		# group data into gene level
		gene_id <- sort(unique(exon$entrezid))
		
		gene_nreads <- tapply(exon$nreads, factor(exon$entrezid), sum)
		
		gene_length <- tapply(exon$length, factor(exon$entrezid), sum)
		
		gene_gcnum <- tapply(exon$gcnum, factor(exon$entrezid), sum)
		gene_nnum <- tapply(exon$nnum, factor(exon$entrezid), sum)
		
		gene_percent <- gene_gcnum / (gene_length - gene_nnum)

		gene <- cbind(matrix(gene_id), matrix(gene_length),matrix(gene_percent), matrix(gene_nreads))
		gene <- as.data.frame(gene)
		
		colnames(gene) <- c("entrezid", "length","GC","nreads")

		### For each gene, get the read intensity of same GC content, then calculate its p_values

		# predict the background intensity of a gene using previously fitted lowess function
		# and translate it back from sqrt scale to normal scale
		gene$background <- (lowessfun(gene$GC))^2
		
		gene$background[is.na(gene$background)] <- 0
		
		# calculate the expected nreads under null hypothesis for each gene
		gene$expected_nreads <- gene$background*gene$length / 2000
		
		gene$p_value <- ppois(gene$nreads, gene$expected_nreads, lower.tail=FALSE) + runif(nrow(gene))*dpois(gene$nreads, gene$expected_nreads)
	
		###########################################################
		########## DENSITY PLOT OF P_VALUE FOR EACH GENE ########## 
		###########################################################

		if (plot){
			plot_output_file <- paste(dataset, "_p_value_density_plot.pdf", sep="")
			pdf(plot_output_file)
			plot(density(gene$p_value), xlab = "p_value", ylab = "density", main="Density Plot of P_values for Each Gene(Binsize=2000)", col=1)
			dev.off()
		}


		##############################################
		########## CLEAN UP AND DATA EXPORT ########## 
		##############################################
		
		unlink(bg_file)
		unlink(signal_file)
		return(gene)
		
	}
}

getInBuiltAnnotation <- function(annotation="mm39")
{
     .check_string_param(annotation,"annotation")

	 switch(tolower(as.character(annotation)),
	    mm9={
	      ann <- system.file("annot","mm9_RefSeq_exon.txt",package="Rsubread")
	      message("NCBI RefSeq annotation for mm9 (build 37.2).")
		},
	    mm10={
	      ann <- system.file("annot","mm10_RefSeq_exon.txt",package="Rsubread")
	      message("NCBI RefSeq annotation for mm10 (build 38.1).")
		 },
	    mm39={
	      ann <- system.file("annot","mm39_RefSeq_exon.txt.gz",package="Rsubread")
	      message("NCBI RefSeq annotation for mm39 (build 39).")
		 },
	    hg19={
	      ann <- system.file("annot","hg19_RefSeq_exon.txt",package="Rsubread")
	      message("NCBI RefSeq annotation for hg19 (build 37.2).")
	       },
	    hg38={
	      ann <- system.file("annot","hg38_RefSeq_exon.txt",package="Rsubread")
	      message("NCBI RefSeq annotation for hg38 (build 38.2).")
	       },
	       {
		stop("In-built annotation for ", annotation, " is not available.\n")
	       }
	  ) # end switch
	  
	  x <- read.delim(ann, sep="\t", quote="", colClasses=c("character","character","integer","integer","character"), comment.char="")
	  x
}

promoterRegions <- function(annotation="mm39", upstream=3000L, downstream=2000L)
#	Create a SAF data.frame of genewise promoter regions
#	Gordon Smyth
#	Created 24 April 2017. Last modified 24 April 2022.
{
#	annotation can be a SAF format data.frame or can be the name of a genome with built-in annotation
	if(is.character(annotation)) {
	    .check_string_param(annotation,'annotation')
		annotation <- getInBuiltAnnotation(annotation)
	} else {
		if(!is.data.frame(annotation)) stop("annotation should be character string or data.frame")
		if(!all(c("GeneID", "Chr", "Start", "End", "Strand") %in% names(annotation))) stop("annotation data.frame is not in SAF format")
	}

#	Remove unassembled contigs
#	N <- grep("^N",annotation$Chr)
#	if(length(N)) annotation <- annotation[-N,]

#	Check upstream and downstream limits
	upstream <- max(upstream[1],0L)
	upstream <- as.integer(min(.Machine$integer.max %/% 2L,upstream))
	downstream <- max(downstream[1],0L)
	downstream <- as.integer(pmin(.Machine$integer.max %/% 2L,downstream))

#	Combine Chr and GeneID
	annotation$ChrGeneID <- paste(annotation$Chr,annotation$GeneID,sep=".")

#	Get start of each gene
	o <- order(annotation$ChrGeneID,annotation$Start)
	anno.start <- annotation[o,]
	isdup <- duplicated(anno.start$ChrGeneID)
	exon.first <- which(!isdup)
	anno.start <- anno.start[exon.first,]

#	Get end of each gene
	o <- order(annotation$ChrGeneID,annotation$End)
	anno.end <- annotation[o,]
	exon.last <- c(exon.first[-1]-1L,nrow(annotation))
	anno.end <- anno.end[exon.last,]

#	Assemble start and end into one data.frame
	ann.gene <- anno.start
	ann.gene$End <- anno.end$End

#	Compute promoter region for + strand
	prom.start <- pmax(ann.gene$Start-upstream,1L)
	prom.end <- pmin(ann.gene$Start+downstream,ann.gene$End)

#	Compute promoter region for - strand
	neg <- ann.gene$Strand=="-"
	prom.start[neg] <- pmax(ann.gene$End[neg]-downstream,ann.gene$Start[neg])
	prom.end[neg] <- ann.gene$End[neg]+upstream

#	Output
	ann.gene$Start <- prom.start
	ann.gene$End <- prom.end
	ann.gene$ChrGeneID <- NULL
	o <- order(ann.gene$Chr,ann.gene$Start)
	ann.gene[o,]
}

sam2bed <- function(samfile,bedfile,readlen)
{
    .check_string_param(readlen,"readlen")
	samfile <- .check_and_NormPath(samfile, mustWork=T, opt="samfile")
	bedfile <- .check_and_NormPath(bedfile, mustWork=F, opt="bedfile")
	opt <- paste("-n",readlen,samfile,bedfile,sep=.R_param_splitor)
	cmd <- paste("sam2bed",opt,sep=.R_param_splitor)
	n <- length(unlist(strsplit(cmd,.R_param_splitor)))
	C_args <- .C("R_sam2bed_wrapper",as.integer(n),as.character(cmd),PACKAGE="Rsubread")
}

.simFragments <- function(transcript.lengths, transcript.expressions=NULL, library.size=1000000L, fragment.length.min=100L, fragment.length.max=500L, fragment.length.mean=180, fragment.length.sd=40)
#  Randomly generate fragment lengths and starting positions for RNA-seq simulation.
#  Assume gamma distribution for fragment lengths.
#  Gordon Smyth
#  Created 13 March 2019. Last modified 15 March 2019.
{
# Default to equal expression levels 
  if(is.null(transcript.expressions)) transcript.expressions <- rep_len(1,length(transcript.lengths))

# To conserve memory, use integers
  transcript.lengths <- as.integer(transcript.lengths)
  fragment.length.min <- as.integer(fragment.length.min)
  fragment.length.max <- as.integer(fragment.length.max)

# First generate number of fragments from each transcript

# We will assume that any transcript with length >= fragment.length.min has a chance of being sequenced
  effective.transcript.lengths <- pmax(transcript.lengths - fragment.length.min + 1L, 0L)  
  prob <- effective.transcript.lengths * transcript.expressions
  prob <- prob / sum(prob)

# Randomly allocate total number of fragments (library size) to transcripts
  n.fragments <- drop(rmultinom(1L, size=library.size, prob=prob))

# Parameter values for gamma distribution
  alpha <- ( fragment.length.mean / fragment.length.sd )^2
  beta <- fragment.length.mean / alpha

# Probability distribution of fragment lengths
  frag.len <- seq.int(fragment.length.min,fragment.length.max)
  frag.len.p <- dgamma(frag.len,shape=alpha,scale=beta,log=TRUE)
  frag.len.p <- exp(frag.len.p - mean(frag.len.p))
  frag.len.n <- length(frag.len)

# Expand out transcript.lengths to library.size
  out <- matrix(0L,library.size,3)
  colnames(out) <- c("Transcript","FragmentLength","StartPosition")
  ntranscripts <- length(transcript.lengths)
  out[,"Transcript"] <- rep.int(seq_len(ntranscripts), n.fragments)
  TraLen <- rep.int(transcript.lengths, n.fragments)

# Randomly assign fragment lengths
  out[,"FragmentLength"] <- sample.int(frag.len.n, size=library.size, replace=TRUE, prob=frag.len.p)
  out[,"FragmentLength"] <- frag.len[out[,"FragmentLength"]]
# Rerun for short transcripts
  i <- which(out[,"FragmentLength"] > TraLen)
  if(length(i)) {
    FragLenShort <- TraLenShort <- TraLen[i]
    WhichFragMax <- max(TraLenShort) - fragment.length.min + 1L
    for (j in seq_len(WhichFragMax)) {
      k <- which(TraLenShort == frag.len[j])
      n <- length(k)
      if(n) FragLenShort[k] <- sample.int(j, size=n, replace=TRUE, prob=frag.len.p[1:j])
    }
    out[i,"FragmentLength"] <- frag.len[FragLenShort]
  }

# Generate start position
  out[,"StartPosition"] <- 1L + as.integer( runif(library.size) * (TraLen - out[,"FragmentLength"]) + 0.5 )

  list(n.fragments=n.fragments, read.positions=out)
}

simReads <- function(transcript.file, expression.levels, output.prefix, library.size=1e5, read.length=75L, truth.in.read.names=FALSE, simulate.sequencing.error=TRUE, quality.reference=NULL, paired.end=FALSE, fragment.length.min=100L, fragment.length.max=500L, fragment.length.mean=180, fragment.length.sd=40, simplify.transcript.names=FALSE, strandSpecific=0)
# Simulate transcript reads and write FASTQ files
{
# Check expression.levels
  if(anyNA(expression.levels)) expression.levels[ is.na(expression.levels) ] <- 0
  if(min(expression.levels) < 0) stop("Negative expression values are not allowed.")
  if(max(expression.levels) == 0) stop("The specified transcript expression levels are all zero.")

# Check library.size
  if(!is.integer(library.size)) library.size <- as.integer(library.size+0.5)
  if(library.size < 1L) stop("At least one read should be generated.")
  if(library.size > 100L*1000L*1000L) stop("The current version cannot generate more than 100 million reads/fragments in a single run")

# Check read length
  if(!is.integer(read.length)) read.length <- as.integer(read.length+0.5)
  if(read.length < 1L || read.length > 250L) stop("The read length must be between 1 and 250.")

# Check fragment lengths
  if(fragment.length.min < read.length) stop("The minimum fragment length cannot be lower than the output read length.")
  if(fragment.length.min > fragment.length.max) stop("Maximum fragment length must be greater than or equal to the minimum fragment length.")
  if(fragment.length.mean < 1) stop("Mean fragment length must be >= 1")

# Check transcript.file
  transcript.file <- .check_and_NormPath(transcript.file, mustWork=TRUE, opt="transcript.file")
  output.prefix <- .check_and_NormPath(output.prefix, mustWork=FALSE, opt="output.prefix")
  fasta.meta <- scanFasta(transcript.file, simplify.transcript.names, quiet=TRUE)
  if(!identical(length(expression.levels),nrow(fasta.meta))) stop("Number of expression levels does not match the number of transcripts in the input fasta file.")

# Check strandSpecific value
  if(!strandSpecific %in% c(0,1,2))stop("The value of strandSpecific must be 0, 1 or 2.")

  if(simulate.sequencing.error){
    if(is.null(quality.reference)){
      if(read.length==75) quality.reference <- system.file("qualf","ref-quality-strings-20k-75bp-ERR1_59-SRR3649332.txt",package="Rsubread")
      if(read.length==100) quality.reference <- system.file("qualf","ref-quality-strings-20k-100bp-ERR2_70-SRR3045231.txt",package="Rsubread")
      if(is.null(quality.reference)) stop("To simulate sequencing errors in reads that are neither 100-bp nor 75-bp long, you need to provide a file containing reference quality strings of the same length as the output reads.")
    }else{
      quality.reference <- .check_and_NormPath(quality.reference,  mustWork=TRUE, opt="quality.reference")
    }
  }else{
    quality.reference <- NULL
  }

  sf <- .simFragments(fasta.meta$Length, expression.levels, library.size, fragment.length.min, fragment.length.max, fragment.length.mean, fragment.length.sd )
  C_args <- .C("R_genSimReads_at_poses", transcript.file, output.prefix, as.character(quality.reference), fasta.meta$TranscriptID, sf$read.positions[,'Transcript'], sf$read.positions[,'StartPosition'], sf$read.positions[,'FragmentLength'], as.integer(read.length), as.integer(library.size), nrow(fasta.meta), as.integer(simplify.transcript.names), as.integer(truth.in.read.names), as.integer(paired.end), as.integer(strandSpecific), PACKAGE="Rsubread")
  data.frame(fasta.meta[,1:2], NReads=sf$n.fragments)
}

scanFasta <- function(transcript.file, simplify.transcript.names=FALSE, quiet=FALSE){
  fout_sum <- file.path(".",paste(".Rsubread_sumfile_pid",Sys.getpid(),sep=""))
  transcript.file <- .check_and_NormPath(transcript.file, mustWork=T, opt="transcript.file")
  cmd <- paste("RscanFasta","--summarizeFasta","--transcriptFasta",transcript.file,"--outputPrefix", fout_sum, sep=.R_param_splitor)
  if(quiet) cmd<-paste(cmd, "--quiet", sep=.R_param_splitor)
  if(simplify.transcript.names) cmd<-paste(cmd, "--simpleTranscriptId", sep=.R_param_splitor)

  n <- length(unlist(strsplit(cmd,.R_param_splitor)))
  C_args <- .C("R_generate_random_RNAseq_reads",as.integer(n), as.character(cmd),PACKAGE="Rsubread")

  fout_sum <-paste0(fout_sum,".faSummary")
  summ <- read.delim(fout_sum, stringsAsFactors=FALSE, header=T)
  file.remove(fout_sum)
  summ
}

%\VignetteIndexEntry{Rsubread Vignette}
%\VignetteDepends{}
%\VignetteKeywords{Read mapping}
%\VignettePackage{Rsubread}
\documentclass[12pt]{article}

\usepackage{hyperref}

\newcommand{\R}[1]{{\texttt{#1}}}
\newcommand{\C}[1]{{\texttt{#1}}}

\textwidth=6.2in
\textheight=8.5in
\oddsidemargin=0.2in
\evensidemargin=0.2in
\headheight=0in
\headsep=0in

\begin{document}
\title{Rsubread package: high-performance read alignment, quantification and mutation discovery}
\author{Wei Shi}
\date{21 November 2022}
\maketitle

\section{Introduction}
This vignette provides a brief description to the Rsubread package.
For more details, please refer to the Users Guide which can brought up in your R session via the following commands: \\

\noindent\R{> library(Rsubread)}\\
\R{> RsubreadUsersGuide()}\\

The Rsubread package provides facilities for processing short and long reads generated from the sequencing technologies.
These facilities include quality assessment, read alignment, read summarization, exon-exon junction detection, absolute expression calling and SNP discovery.

The Subread aligner (\R{align} function) is a highly efficient and accurate aligner for mapping genomic DNA and RNA sequencing reads.
It adopts a novel mapping paradigm called ``seed-and-vote".
Under this paradigm, a number of 16mers (called seeds or subreads) are extracted from each read and they were mapped to the reference genome to vote for the mapping location of the read.
Read mapping performed under this paradigm has been found to be more efficient and accurate than that carried out under the conventional ``seed-and-extend" paradigm (Liao et al. 2013).

Another aligner included in Rsubread is the Subjunc aligner (\R{subjunc} function).
It was also developed under the ``seed-and-vote" paradigm, but different from the Subread aligner it performs full alignment for exon spanning reads and reports exon-exon junctions in addition to the read mapping results.
The Subread aligner is recommended for gene-level expression analysis.
For other types of RNA-seq analyses such as alternative splicing analysis, the Subjunc aligner should be used.

An important step in processing next-gen sequencing data is to assign mapped reads to genomic features such as genes, exons and genomic windows.
This package includes a general-purpose read summarization function \R{featureCounts} that takes mapped reads as input and assigns them to genomic features.
In-built annotations are provided for users convenience.

Different from microarray technologies, the next-gen sequencing technologies do not provide Present/Absent calls for genomic features such as genes.
We have developed an algorithm to use the background noise measured from the RNA-seq data to call absolutely expressed genes.
The function \R{detectionCall} returns a detection p value for each gene from the read mapping results.

We have also developed a new SNP calling algorithm which is being implemented in function \R{exactSNPs}.
Our results showed that it compared favorably to competing methods, but was an order of magnitude faster.

This package also includes some other useful functions such as quality assessment (\R{qualityScores}, \R{atgcContent}), duplicate read removal (\R{removeDupReads}) and mapping percentage calculation (\R{propmapped}).

\section{Read alignment}
An index needs to be built first and then alignments can be carried out.
Building the index is an one-off operation.
The generated index can be re-used in subsequent read alignments.\\

{\noindent\bf Step 1: Index building \\}

The Rsubread package includes a dummy reference sequence that was generated by concatenating 900 100bp reads that were taken from a pilot dataset generated from the SEquencing Quality Control (SEQC) project.
We further extracted 100 reads from the same dataset and combine them with the 900 reads to make a read dataset for mapping.
Below is the command for building an index for the reference sequence:

\begin{scriptsize}
<<>>=
library(Rsubread)
ref <- system.file("extdata","reference.fa",package="Rsubread")
buildindex(basename="reference_index",reference=ref)
@
\end{scriptsize}

The generated index files were saved to the current working directory.
Rsubread creates a hash table for indexing the reference genome. 
Keys in the hash table are the 16bp sequences and hash values are their corresponding chromosomal locations. 
Color space index can be built by setting the \R{colorsapce} argument to \R{TRUE}.\\

A unique feature of Rsubread is that it allows users to control the computer memory usage in read mapping process.
Users can do this by tuning the amount of memory (in MB) to be used in read mapping.\\

{\noindent\bf Step 2: read mapping\\}

After the index was successfully built, we map the read dataset (including 1,000 reads) to the reference sequence:

\begin{scriptsize}
<<>>=
reads <- system.file("extdata","reads.txt.gz",package="Rsubread")
align.stat <- align(index="reference_index",readfile1=reads,output_file="alignResults.BAM",phredOffset=64)
@
\end{scriptsize}

Map paired-end reads:

\begin{scriptsize}
<<>>=
reads1 <- system.file("extdata","reads1.txt.gz",package="Rsubread")
reads2 <- system.file("extdata","reads2.txt.gz",package="Rsubread")
align.stat2 <- align(index="reference_index",readfile1=reads1,readfile2=reads2,
output_file="alignResultsPE.BAM",phredOffset=64)
@
\end{scriptsize}

\section{Counting mapped reads for genomic features}

The \R{featureCounts} function is a general-purpose read summarization function that assigns mapped reads (RNA-seq or gDNA-seq reads) to genomic features such as genes, exons, promoters, gene bodies and genomic windows.

This function takes as input a set of files that contain read mapping results and an annotation file that includes genomic features.
It automatically detects the format of input read files (supported formats include SAM and BAM).
Input reads can be name-sorted or location-sorted.
Users do not need to resort the reads before feeding them to \R{featureCounts}.

In-built NCBI RefSeq gene annotations for genomes mm9, mm10, hg19 and hg38 are provided for convenience.
These annotations include chromosomal coordinates of exons of each gene.
When these annotations are used for summarization, only reads overlapping with exons will be counted by \R{featureCounts}.
Users can use {\texttt{getInBuiltAnnotation}} function to retrieve these annotations.

Below gives the example code of assigning reads and fragments, generated in the last section, to two artificial genes.
Assign single end reads to genes:

\begin{scriptsize}
<<>>=
ann <- data.frame(
GeneID=c("gene1","gene1","gene2","gene2"),
Chr="chr_dummy",
Start=c(100,1000,3000,5000),
End=c(500,1800,4000,5500),
Strand=c("+","+","-","-"),
stringsAsFactors=FALSE)
ann
fc_SE <- featureCounts("alignResults.BAM",annot.ext=ann)
fc_SE
@
\end{scriptsize}

Assign fragments (read pairs) to the two genes:

\begin{scriptsize}
<<>>=
fc_PE <- featureCounts("alignResultsPE.BAM",annot.ext=ann,isPairedEnd=TRUE)
fc_PE
@
\end{scriptsize}
\section{Quantifying 10x scRNA-seq data}

The \R{cellCounts} function can be used to quantify the scRNA-seq data generated by the 10x Genomics Chromium platform. It employs the seed-and-vote strategy to align reads to a reference genome, collapses reads to UMIs (Unique Molecular Identifiers) and then assigns UMIs to genes based on the \R{featureCounts} program. \R{cellCounts} starts with processing raw reads and finishes with outputting a UMI count matrix and also other information. It is able to take both BCL and FASTQ format reads as input. When input format is BCL, \R{cellCounts} directly processes reads from the raw data files instead of converting them into FASTQ reads before processing. \R{cellCounts} supports barcode correction and whitelisting. It utilizes a barcode whitelist, a list of barcode sequences included in the Chromium assay kit that can be freely downloaded from 10x Genomics website, to detect valid barcodes from experimental data. When matching cell barcodes observed in a 10x dataset against the barcode whitelist, \R{cellCounts} allows for one base mismatch to account for sequencing errors so as to detect more valid cell barcodes. After obtaining UMI counts for each gene in each cell, \R{cellCounts} uses the EmptyDrops algorithm to call valid cell barcodes. \R{cellCounts} reports both high-confidence and rescued cells. The rescued cells have low total UMI count but are found to have a gene expression profile that is distinct from that of ambient RNAs. Below is an example of using \R{cellCounts} to quantify a very small 10x scRNA-seq dataset.

\begin{scriptsize}
<<>>=
if(grepl("linux", R.version$os) && grepl("x86_64", R.version$arch)) {
  md5.zip <- "ffd5036b36e25e9b61efc412e71820dd"
  URL <- "https://shilab-bioinformatics.github.io/cellCounts-Example/cellCounts-Example.zip"
  temp.file <- tempfile()
  temp.dir <- tempdir()
  downloaded <- tryCatch({
      download.file(URL, destfile = temp.file)
      tools::md5sum(temp.file) %in% md5.zip
    },
    error = function(cond){
      return(FALSE)
    }
  )
  if(!downloaded) cat("Unable to download the file.\n") 
} else downloaded <- FALSE

if(downloaded){
  unzip(temp.file, exdir=paste0(temp.dir,"/cellCounts-Example"))
  library(Rsubread)
  buildindex(paste0(temp.dir,"/chr1"), 
    paste0(temp.dir,"/cellCounts-Example/hg38_chr1.fa.gz"))
}
@
<<>>=
if(downloaded){
  sample.sheet <- data.frame(
    BarcodeUMIFile = paste0(temp.dir,"/cellCounts-Example/reads_R1.fastq.gz"), 
    ReadFile = paste0(temp.dir,"/cellCounts-Example/reads_R2.fastq.gz"),
    SampleName="Example", stringsAsFactors=FALSE
  )
  counts <- cellCounts(paste0(temp.dir,"/chr1"), sample.sheet,  nthreads=1,
    input.mode="FASTQ", annot.inbuilt="hg38")
}
@
<<>>=
if(downloaded) print(counts$sample.info)
@
<<>>=
if(downloaded) print(dim(counts$counts$Example))
@
\end{scriptsize}

\section{Finding exon junctions}

The RNA-seq technology provides a unique opportunity to identify the alternative splicing events that occur during the gene transcription process.
The \R{subjunc} function can be used to detect exon-exon junctions.
It first extracts a number of subreads (16mers) from each read, maps them to the reference genome and identifies the two best mapping locations for each read (representing potential locations of exons spanned by the read).
Then, it builds a junction table including all putative junctions.
Finally, it carries out a verification step to remove false positives in junction detection by realigning all the reads. 
The donor (`GT') and receptor sites(`AG'), are required to be present when calling exon-exon junctions. 
Output of this function includes the discovered exon-exon junctions and also read mapping results.

\section{Base quality scores}

Quality scores give the probabilities of read bases being incorrectly called, which is useful for examining the quality of sequencing data.
The \R{qualityScores} function can be used to quickly retrieve and display the quality score data extracted from a read file.

\begin{scriptsize}
<<>>=
  x <- qualityScores(filename=reads,offset=64,nreads=1000)
  x[1:10,1:10]
@
\end{scriptsize}

\section{GC content}

The \R{atgcContent} function returns fractions of A, T, G and C bases at each base location of reads or in the entire dataset.

%\begin{scriptsize}
%<<>>=
%## Fraction of A,T,G and C bases in all the reads
%x <- atgcContent(filename=reads)
%x
%## Fraction of A,T,G and C bases at each read location
%xb <- atgcContent(filename=reads,basewise=TRUE)
%xb[,1:5]
%@
%\end{scriptsize}

\section{Mapping percentage}

Function \R{propmapped} returns the proportion of mapped reads included in a SAM/BAM file.
For paired end reads, it can return the proportion of mapped fragments (ie. read pairs).

\begin{scriptsize}
<<>>=
propmapped("alignResults.BAM")
@
\end{scriptsize}

\section{Citation}
Yang Liao, Gordon K Smyth and Wei Shi (2013). The Subread aligner: fast, accurate and scalable read mapping by seed-and-vote. Nucleic Acids Research, 41(10):e108.\\

\noindent{Yang Liao, Gordon K Smyth and Wei Shi (2014). featureCounts: an efficient general purpose program for assigning sequence reads to genomic features. Bioinformatics, 30(7):923-30}

\section{Authors}
Wei Shi and Yang Liao \\
Bioinformatics Division \\
The Walter and Eliza Hall Institute of Medical Research \\
1G Royal Parade, Parkville, Victoria 3052 \\
Australia \\

\section{Contact}

Please post to the Bioconductor Support site (\url{https://support.bioconductor.org/}) if you have any questions or suggestions.

\end{document}

\name{flattenGTF}
\alias{flattenGTF}
\title{Flatten Features in GTF or GFF Annotation Files}
\description{Convert a GTF/GFF annotation to SAF format and flatten overlapping features.}
\usage{
flattenGTF(

    # basic input/output options
    GTFfile,
    GTF.featureType = "exon",
    GTF.attrType = "gene_id",

    # the option specifying the merging algorithm
    method = "merge")
}
\arguments{
  \item{GTFfile}{ a character string giving the name of a GTF file as input.}
  \item{GTF.featureType}{ a character string giving the feature type used to select rows in a GTF annotation. \code{"exon"} by default. Feature types can be found in the third column of a GTF annotation.}
  \item{GTF.attrType}{ a character string giving the attribute type in a GTF annotation which will be used to group features. \code{"gene_id"} by default. Attributes can be found in the ninth column of a GTF annotation.}
  \item{method}{ a character string specifying the method for how to flatten the GTF file. The method can be either \code{"merge"} or \code{"chop"}. \code{"merge"} by default. See the \code{details} section for more information.}
}

\details{
This function locates features in a GTF annotation via \code{GTF.featureType} and then groups them into meta-features via \code{GTF.attrType}.

When \code{method="merge"}, the overlapping features found in a meta-feature will be merged to form a single continuous feature encompassing all the overlapping features.
If \code{method="chop"}, overlapping features will be chopped into multiple non-overlapping bins.
Here is an example to illustrate the differences between the two methods.
Say there are three exons belonging to the same gene and the coordinates of these exons are [100, 200], [150, 500] and [250, 400].
When running on \code{"merge"} mode, a single exon will be returned for this gene and the coordinates of this exon are [100, 500], representing the union of the three original exons.
When running on \code{"chop"} mode, five non-overlapping bins will be returned, including [100, 149], [150, 200], [201, 249], [250, 400] and [401, 500].
Intervals of these bins are determined by start and end coordinates of the three original exons (100, 150, 200, 250, 400 and 500).

Output of this function is a SAF format annotation which can be fed to \code{\link{featureCounts}} function for read counting.
Description to SAF format annotation can also be found in \code{\link{featureCounts}}.

}
\value{
A \code{data.frame} including a SAF format annotation in which features included in each meta-feature are all distinct.
}
\author{Yang Liao and Wei Shi}
\seealso{\code{\link{featureCounts}}}
%\examples{}

\name{buildindex}
\alias{buildindex}
\title{Build Index for a Reference Genome}
\description{An index needs to be built before read mapping can be performed. This function creates a hash table index for the reference genome, which can then be used by Subread and Subjunc aligners for read alignment.}
\usage{
buildindex(

    # basic input/output options
    basename,
    reference,

    # options for the details of the index
    gappedIndex = FALSE,
    indexSplit = FALSE,
    memory = 8000,
    TH_subread = 100,
    colorspace = FALSE)
}
\arguments{
  \item{basename}{ a character string giving the basename of created index files.}
  \item{reference}{ a character string giving the name of a FASTA or gzipped FASTA file containing the sequences of all chromosomes and contigs.}
  \item{gappedIndex}{ logical indicating whether a gapped index or a full index should be built. A gapped index contains 16mers (subreads) that are extracted every three bases from a reference genome, whereas a full index contains subreads extracted from every chromosomal location of a genome. The index provides a hash table mapping the sequences of all subreads to their corresponding chromosomal locations. Default value is \code{FALSE} (i.e., a full index is built). }
  \item{indexSplit}{ logical indicating whether the index can be split into multiple blocks. The block size is determined by the value of \code{memory}. \code{FALSE} by default (ie. a single-block index is generated). }
  \item{memory}{ a numeric value specifying the amount of memory (in megabytes) used for storing the index during read mapping. 8000 MB by default. Note that this option is ignored when \code{indexSplit} is \code{FALSE}. }
  \item{TH_subread}{ a numeric value specifying the threshold for removing highly repetitive subreads (16bp mers). 100 by default. Subreads will be excluded from the index if they occur more than threshold number of times in the genome.}
  \item{colorspace}{ logical specifying the mode of the index. If \code{TRUE}, a color space index will be built. Otherwise, a base space index will be built.}
}
\details{
This function generates a hash-table index for a reference genome, in which keys are subreads (16mers) and values are their chromosomal locations in the reference genome.
The built index can then be used by Subread (\code{\link{align}}) and \code{\link{subjunc}} aligners to map reads (Liao et al. 2019; Liao et al. 2013).
Index building is an one-off operation.

Highly repetitive subreads (or uninformative subreads) are excluded from the hash table so as to reduce mapping ambiguity.
\code{TH_subread} specifies the maximal number of times a subread is allowed to occur in the reference genome to be included in hash table.

Maximum mapping speed can be achieved by building a full index for the reference genome.
By default \code{buildindex} builds a full index.
Building a gapped index will significantly reduce the memory use, at a modest cost to read mapping time.
It is recommended to use a gapped index on a personal computer due to the limited amount of computer memory available.
Memory use can be further reduced by splitting an index to multiple blocks.
The amount of memory to be used in read mapping is determined at the index building stage.

To build a full index for human/mouse genome, \code{buildindex} function requires 15GB memory.
When using a full index to map reads to human/mouse genome, \code{\link{align}} and \code{\link{subjunc}} requires 17.8GB memory.
To build a gapped index for human/mouse genome, \code{buildindex} function only requires 5.7GB memory.
When using a gapped index to map reads to human/mouse genome, \code{\link{align}} requires 8.2GB memory and \code{\link{subjunc}} requires 8.8GB memory.

Sequences of reference genomes can be downloaded from public databases.
For instance, primary assembly of human genome GRCh38/hg38 or mouse genome GRCm38/mm10 can be downloaded from the GENCODE database via the following links:

\url{ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_human/release_28/GRCh38.primary_assembly.genome.fa.gz}

\url{ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_mouse/release_M18/GRCm38.primary_assembly.genome.fa.gz}
}
\value{
No value is produced but index files are written to the current working directory.
}
\references{
Yang Liao, Gordon K Smyth and Wei Shi (2019).
The R package Rsubread is easier, faster, cheaper and better for alignment and quantification of RNA sequencing reads.
\emph{Nucleic Acids Research}, 47(8):e47.
\url{http://www.ncbi.nlm.nih.gov/pubmed/30783653}

Yang Liao, Gordon K Smyth and Wei Shi (2013).
The Subread aligner: fast, accurate and scalable read mapping by seed-and-vote.
\emph{Nucleic Acids Research}, 41(10):e108.
\url{http://www.ncbi.nlm.nih.gov/pubmed/23558742}
}
\author{Wei Shi and Yang Liao}
%\note{}
\seealso{\code{\link{align}}}
\examples{
# Build an index for the artifical sequence included in file 'reference.fa'
ref <- system.file("extdata","reference.fa",package="Rsubread")
buildindex(basename="./reference_index",reference=ref)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{atgcContent}
\alias{atgcContent}
\title{Calculate Percentages of Nucleotides in Reads}
\description{Calculate percentages of nucleotides A, T, G and C in the input FASTQ or FASTQ file.  }
\usage{
atgcContent(

    filename,
    basewise = FALSE)
}
\arguments{
  \item{filename}{ a character string giving the name of input FASTQ/FASTA file}
  \item{basewise}{ logical specifying how the percentages are calculated. If \code{TRUE}, nucleotide percentages will be calculated for each base position in the read across all the reads. By default, percentages are calculated for the entire dataset.}
}
\details{
Sequencing reads could contain letter "N" besides "A", "T", "G" and "C".
Percentage of "N" in the read dataset is calcuated as well.

The \code{basewise} calculation is useful for examining the GC bias towards the base position in the read.
By default, the percentages of nucleotides in the entire dataset will be reported.
}

\value{ 
A named vector containing percentages for each nucleotide type if \code{basewise} is \code{FALSE}.
Otherwise, a data matrix containing nucleotide percentages for each base position of the reads. 
}
%\references{}
\author{Zhiyin Dai and Wei Shi}
%\note{}
%\seealso{}
%\examples{}
% Add one or more standard keywords, see file 'KEYWORDS' in the 
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{detectionCall}
\alias{detectionCall}
\title{Determine Detection P Values for Each Gene in an RNA-seq Dataset}
\description{Use GC content adjusted background read counts to determine the detection p values for each gene}

\usage{
detectionCall(

    dataset,
    species = "hg",
    plot = FALSE)
}
\arguments{
  \item{dataset}{ a character string giving the filename of a SAM format file, which is the output of read alignment.}
  \item{species}{ a character string specifing the species. Options are \code{hg} and \code{mm}.} 
  \item{plot}{ logical indicating whether a density plot of detection p values will be generated.}
}

\value{A data frame which includes detection p values and annotation information for each gene.}

%\references{}
\author{Zhiyin Dai and Wei Shi}
%\note{}
%\seealso{}
% Add one or more standard keywords, see file 'KEYWORDS' in the 
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{removeDupReads}
\alias{removeDupReads}
\title{Remove Sequencing Reads Mapped to Identical Locations}
\description{Remove reads which are mapped to identical locations, using mapping location of the first base of each read.}
\usage{
removeDupReads(

    # basic input/output options
    inputFile,
    threshold = 50,
    outputFile,
    outputFormat = "BAM")
}
\arguments{
  \item{inputFile}{ a character string giving the name of a SAM or BAM format input file.}
  \item{threshold}{ a numeric value giving the threshold for removing duplicated reads, 50 by default. Reads will be removed if they are found to be duplicated equal to or more than \code{threshold} times.}
  \item{outputFile}{ a character string giving the base name of output files.}
  \item{outputFormat}{ a character string giving the format of the output file. \code{BAM} and \code{SAM} are accepted. \code{BAM} by default.}
}
\details{
This function uses the mapping location of first base of each read to find duplicated reads.
Reads are removed if they are duplicated more than \code{threshold} number of times.
}
\value{
This function generates a BAM or SAM file including the remaining reads after duplicate removal.
}
\author{Yang Liao and Wei Shi}

\name{align}
\alias{align}
\alias{subjunc}
\title{Align Sequence Reads to a Reference Genome via Seed-and-Vote}
\description{The \code{align} function can align both DNA and RNA sequencing reads. \code{Subjunc} is an RNA-seq aligner and it reports full alignment of each read (\code{align} reports partial alignment for exon spanning reads).}
\usage{
align(

    # index for reference sequences
    index,
    
    # input reads and output
    readfile1,
    readfile2 = NULL,
    type = "rna",
    input_format = "gzFASTQ",
    output_format = "BAM",
    output_file = paste(readfile1,"subread",output_format,sep="."),
    
    # offset value added to Phred quality scores of read bases
    phredOffset = 33,
    
    # thresholds for mapping
    nsubreads = 10,
    TH1 = 3,
    TH2 = 1,
    maxMismatches = 3,
    
    # unique mapping and multi-mapping
    unique = FALSE,
    nBestLocations = 1,
    
    # indel detection
    indels = 5,
    complexIndels = FALSE,
    
    # read trimming
    nTrim5 = 0,
    nTrim3 = 0,
    
    # distance and orientation of paired end reads
    minFragLength = 50,
    maxFragLength = 600,
    PE_orientation = "fr",
    
    # number of CPU threads
    nthreads = 1,
    
    # read group
    readGroupID = NULL,
    readGroup = NULL,
    
    # read order
    keepReadOrder = FALSE,
    sortReadsByCoordinates = FALSE,
    
    # color space reads
    color2base = FALSE,
    
    # dynamic programming
    DP_GapOpenPenalty = -1,
    DP_GapExtPenalty = 0,
    DP_MismatchPenalty = 0,
    DP_MatchScore = 2,
    
    # detect structural variants
    detectSV = FALSE,
    
    # gene annotation
    useAnnotation = FALSE,
    annot.inbuilt = "mm39",
    annot.ext = NULL,
    isGTF = FALSE,
    GTF.featureType = "exon",
    GTF.attrType = "gene_id",
    chrAliases = NULL)
    
subjunc(

    # index for reference sequences
    index,
    
    # input reads and output
    readfile1,
    readfile2 = NULL,
    input_format = "gzFASTQ",
    output_format = "BAM",
    output_file = paste(readfile1,"subjunc",output_format,sep = "."),
    
    # offset value added to Phred quality scores of read bases
    phredOffset = 33,
    
    # thresholds for mapping
    nsubreads = 14,
    TH1 = 1,
    TH2 = 1,
    maxMismatches = 3,
    
    # unique mapping and multi-mapping
    unique = FALSE,
    nBestLocations = 1,
    
    # indel detection
    indels = 5,
    complexIndels = FALSE,
    
    # read trimming
    nTrim5 = 0,
    nTrim3 = 0,
    
    # distance and orientation of paired end reads
    minFragLength = 50,
    maxFragLength = 600,
    PE_orientation = "fr",
    
    # number of CPU threads
    nthreads = 1,
    
    # read group
    readGroupID = NULL,
    readGroup = NULL,
    
    # read order
    keepReadOrder = FALSE,
    sortReadsByCoordinates = FALSE,
    
    # color space reads
    color2base = FALSE,
    
    # dynamic programming
    DP_GapOpenPenalty = -1,
    DP_GapExtPenalty = 0,
    DP_MismatchPenalty = 0,
    DP_MatchScore = 2,
    
    # detect all junctions including gene fusions
    reportAllJunctions = FALSE,
    
    # gene annotation
    useAnnotation = FALSE,
    annot.inbuilt = "mm39",
    annot.ext = NULL,
    isGTF = FALSE,
    GTF.featureType = "exon",
    GTF.attrType = "gene_id",
    chrAliases = NULL)
}
\arguments{
  \item{index}{ character string giving the basename of index file. Index files should be located in the current directory.}
  \item{readfile1}{ a character vector including names of files that include sequence reads to be aligned. For paired-end reads, this gives the list of files including first reads in each library. File format is FASTQ/FASTA by default. See \code{input_format} option for more supported formats.}
  \item{readfile2}{ a character vector giving names of files that include second reads in paired-end read data. Files included in \code{readfile2} should be in the same order as their mate files included in \code{readfile1} .\code{NULL} by default.}
  \item{type}{ a character string or an integer giving the type of sequencing data. Possible values include \code{rna} (or \code{0}; RNA-seq data) and \code{dna} (or \code{1}; genomic DNA-seq data such as WGS, WES, ChIP-seq data etc.). Character strings are case insensitive.}
  \item{input_format}{ character string specifying format of read input files. \code{gzFASTQ} by default (this also includes FASTQ, FASTA, gzipped FASTQ and gzipped FASTA formats). Other supported formats include \code{SAM} and \code{BAM}. Character values are case insensitive.}
  \item{output_format}{ character string specifying format of output file. \code{BAM} by default. Acceptable formats include \code{SAM} and \code{BAM}.}
  \item{output_file}{ a character vector specifying names of output files. By default, names of output files are set as the file names provided in \code{readfile1} added with an suffix string.}
  \item{phredOffset}{ numeric value added to base-calling Phred scores to make quality scores (represented as ASCII letters). Possible values include \code{33} and \code{64}. By default, \code{33} is used.}
  \item{nsubreads}{ numeric value giving the number of subreads extracted from each read.}
  \item{TH1}{ numeric value giving the consensus threshold for reporting a hit. This is the threshold for the first reads if paired-end read data are provided.}
  \item{TH2}{ numeric value giving the consensus threhold for the second reads in paired-end data.}
  \item{maxMismatches}{ numeric value giving the maximum number of mis-matched bases allowed in the alignment. \code{3} by default. Mis-matches found in soft-clipped bases are not counted.}
  \item{unique}{ logical indicating if only uniquely mapped reads should be reported. A uniquely mapped read has one single mapping location that has less mis-matched bases than any other candidate locations. By default, multi-mapping reads will be reported in addition to uniquely mapped reads. Number of alignments reported for each multi-mapping read is determined by the \code{nBestLocations} parameter.}
  \item{nBestLocations}{ numeric value specifying the maximal number of equally-best mapping locations that will be reported for a multi-mapping read. 1 by default. The allowed value is between 1 to 16 (inclusive). In the mapping output, `NH' tag is used to indicate how many alignments are reported for the read and `HI' tag is used for numbering the alignments reported for the same read. This argument is only applicable when \code{unique} option is set to \code{FALSE}.}
  \item{indels}{ numeric value giving the maximum number of insertions/deletions allowed during the mapping. \code{5} by default.}
  \item{complexIndels}{ logical indicating if complex indels will be detected. If \code{TRUE}, the program will try to detect multiple short indels that occurs concurrently in a small genomic region (indels could be as close as 1bp apart).}
  \item{nTrim5}{ numeric value giving the number of bases trimmed off from 5' end of each read. \code{0} by default.}
  \item{nTrim3}{ numeric value giving the number of bases trimmed off from 3' end of each read. \code{0} by default.}
  \item{minFragLength}{ numeric value giving the minimum fragment length. 50 by default.}
  \item{maxFragLength}{ numeric value giving the maximum fragment length. 600 by default.}
  \item{PE_orientation}{ character string giving the orientation of the two reads from the same pair. It has three possible values including \code{fr}, \code{ff} and \code{rf}. Letter \code{f} denotes the forward strand and letter \code{r} the reverse strand. \code{fr} by default (ie. the first read in the pair is on the forward strand and the second read on the reverse strand).}
  \item{nthreads}{ numeric value giving the number of threads used for mapping. \code{1} by default.}
  \item{readGroupID}{ a character string giving the read group ID. The specified string is added to the read group header field and also be added to each read in the mapping output. \code{NULL} by default.}
  \item{readGroup}{ a character string in the format of \code{tag:value}. This string will be added to the read group (RG) header in the mapping output. \code{NULL} by default.}
  \item{keepReadOrder}{ logical indicating if the order of reads in the BAM output is kept the same as that in the input file. (Reads from the same pair are always placed next to each other regardless of this option).}
  \item{sortReadsByCoordinates}{ logical indicating if reads will be sorted by their mapping locations in the mapping output. This option is applicable for BAM output only. A BAI index file will also be generated for each BAM file so the generated BAM files can be directly loaded into a genome browser such as IGB or IGV. \code{FALSE} by default.}
  \item{color2base}{ logical. If \code{TRUE}, color-space read bases will be converted to base-space bases in the mapping output. Note that the mapping itself will still be performed at color-space. \code{FALSE} by default.}
  \item{DP_GapOpenPenalty}{ a numeric value giving the penalty for opening a gap when using the Smith-Waterman dynamic programming algorithm to detect insertions and deletions. The Smith-Waterman algorithm is only applied for those reads which are found to contain insertions or deletions. \code{-1} by default.}
  \item{DP_GapExtPenalty}{ a numeric value giving the penalty for extending the gap, used by the Smith-Waterman algorithm. \code{0} by default.}
  \item{DP_MismatchPenalty}{ a numeric value giving the penalty for mismatches, used by the Smith-Waterman algorithm. \code{0} by default.}
  \item{DP_MatchScore}{ a numeric value giving the score for matches used by the Smith-Waterman algorithm. \code{2} by default.}
  \item{detectSV}{ logical indicating if structural variants (SVs) will be detected during read mapping. See below for more details.}
  \item{reportAllJunctions}{ logical indicating if all discovered junctions will be reported. This includes exon-exon junctions and also gene fusions. Presence of donor/receptor sites is not required when \code{reportAllJunctions} is \code{TRUE}. This option should only be used for RNA-seq data.}
  \item{useAnnotation}{ logical indicating if gene annotation information will be used in the mapping. \code{FALSE} by default.}
  \item{annot.inbuilt}{ a character string specifying an inbuilt annotation used for read summarization. It has five possible values \code{"mm39"}, \code{"mm10"}, \code{"mm9"}, \code{"hg38"} and \code{"hg19"}, corresponding to the NCBI RefSeq annotations for genomes `mm39`, `mm10', `mm9', `hg38' and `hg19', respectively. \code{"mm39"} by default. See \code{\link{featureCounts}} function for more details on the inbuilt annotations.}
  \item{annot.ext}{ A character string giving name of a user-provided annotation file or a data frame including user-provided annotation data. If the annotation is in GTF format, it can only be provided as a file. If it is in SAF format, it can be provided as a file or a data frame. The provided annotation file can be a uncompressed or gzip compressed file. If an annotation is provided via \code{annot.ext}, the \code{annot.inbuilt} parameter will be ignored. See \code{\link{featureCounts}} function for more details about this parameter.}
  \item{isGTF}{ logical indicating if the annotation provided via the \code{annot.ext} argument is in GTF format or not. \code{FALSE} by default. This option is only applicable when \code{annot.ext} is not \code{NULL}.}
  \item{GTF.featureType}{ a character string denoting the type of features that will be extracted from a GTF annotation. \code{"exon"} by default. This argument is only applicable when \code{isGTF} is \code{TRUE}.}
  \item{GTF.attrType}{ a character string denoting the type of attributes in a GTF annotation that will be used to group features. \code{"gene_id"} by default. The grouped features are called meta-features. For instance, a feature can be an exon and several exons can be grouped into a gene (meta-feature). This argument is only applicable when \code{isGTF} is \code{TRUE}.}
  \item{chrAliases}{ a character string providing the name of a comma-delimited text file that includes aliases of chromosome names. This file should contain two columns. First column contains names of chromosomes included in the SAF or GTF annotation and second column contains corresponding names of chromosomes in the reference genome. No column headers should be provided. Also note that chromosome names are case sensitive. This file can be used to match chromosome names between the annotation and the reference genome.}
}
\details{
\code{align} and \code{subjunc} are R versions of programs in the Subread suite of programs (\url{http://subread.sourceforge.net}) that implement fast, accurate sequence read alignment based on the "seed-and-vote" mapping paradigm (Liao et al. 2013; Liao et al. 2019).
\code{align} is the R version of the command-line program \code{subread-align} and \code{subjunc} is the R version of the command-line program \code{subjunc}.

\code{align} is a general-purpose aligner that can be used to align both genomic DNA-seq reads and RNA-seq reads.
\code{subjunc} is designed for mapping RNA-seq reads only.
The main difference between \code{subjunc} and \code{align} for RNA-seq alignment is that \code{subjunc} reports discovered exon-exon junctions and it also performs full alignments for every read including exon-spanning reads.
\code{align} instead reports the largest mappable regions for each read and soft-clips the remainder of the read.
\code{subjunc} requires the presence of donor and receptor sites when calling exon-exon junctions.
It can detect up to four junction locations in a junction read.

\code{align} and \code{subjunc} can be run with either a full index or a gapped index (see \code{\link{buildindex}} for more details).
Maximum mapping speed is achieved when the full index is used.
With a full index built for human/mouse genome, \code{align} maps ~14 million reads per minute with 10 threads.
\code{subjunc} is slightly slower than \code{align}.
Both \code{align} and \code{subjunc} require 17.8GB of memory for mapping.
With a gapped index built for human/mouse genome, \code{align} maps ~9 million reads per minute with 10 threads.
\code{align} requires 8.2GB of memory for mapping and \code{subjunc} requires 8.8GB of memory.

The \code{detectSV} argument of \code{align} can be used to detect structural variants (SVs) in genomic DNA sequencing data.
The \code{reportAllJunctions} argument of \code{subjunc} function can be used for the detection of SVs in RNA-seq data, as well as the detection of non-canonical junctions that do not have the canonical donor/receptor sites.
For each library, breakpoints detected from SV events are saved to a file with suffix name `.breakpoints.txt', which includes chromosomal coordinates of SV breakpoints and numbers of supporting reads.
The BAM/SAM output includes extra fields to describe the complete alignments of breakpoint-containing reads.
For a breakpoint-containing read, mapping of its major sequence segment is described in the main fields of BAM/SAM output whereas mapping of its minor sequence segment, which does not map along with the major segment due to the presence of a breakpoint, is described in the extra fields including 'CC'(Chr), 'CP'(Position),'CG'(CIGAR) and 'CT'(strand).
Note that each breakpoint-containing read occupies only one row in the BAM/SAM output.
}
\value{
For each library, mapping results including both aligned and unaligned reads are saved to a file.
Indels discovered during mapping are saved to a VCF format file (\code{.indel.vcf}).
\code{subjunc} also outputs a BED format file that contains list of discovered exon-exon junctions (\code{.junction.bed}).
If \code{detectSV} or \code{reportAllJunctions} options are set to \code{TRUE}, structural variants discovered during read mapping will be reported and saved to a file (\code{.breakpoints.txt}), which includes chromosomal coordinates of breakpoints and number of supporting reads for each breakpoint.

Other than outputting data to files, \code{align} and \code{subjunc} also return a \code{data.frame} that includes mapping statistics for each library, such as total number of reads, number of mapped reads, number of uniquely mapped reads, number of indels and number of junctions (\code{subjunc} only).
}
\references{
Yang Liao, Gordon K Smyth and Wei Shi (2019).
The R package Rsubread is easier, faster, cheaper and better for alignment and quantification of RNA sequencing reads.
\emph{Nucleic Acids Research}, 47(8):e47.
\url{http://www.ncbi.nlm.nih.gov/pubmed/30783653}

Yang Liao, Gordon K Smyth and Wei Shi (2013).
The Subread aligner: fast, accurate and scalable read mapping by seed-and-vote.
\emph{Nucleic Acids Research}, 41(10):e108.
\url{http://www.ncbi.nlm.nih.gov/pubmed/23558742}
}
\author{Wei Shi and Yang Liao}
%\note{}
\seealso{
\code{\link{buildindex}}
}
\examples{
# Build an index for the artificial sequence included in file 'reference.fa'.
ref <- system.file("extdata","reference.fa",package="Rsubread")

buildindex(basename="./reference_index",reference=ref)

# align a sample read dataset ('reads.txt') to the sample reference
reads <- system.file("extdata","reads.txt.gz",package="Rsubread")

align.stat <- align(index = "./reference_index", readfile1 = reads,
output_file = "./Rsubread_alignment.BAM", phredOffset = 64)

align.stat
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{}

\name{processExons}
\alias{processExons}
\title{Obtain Chromosomal Coordiates of Each Exon Using NCBI Annotation}
\description{This is for internal use. It converts the NCBI exon annotations into data files for use in the \code{detectionCall} function.}
\usage{
processExons(

    filename = "human_seq_gene.md",
    species = "hg")
}
\arguments{
  \item{filename}{ a character string giving the name of input .md file (NCBI annotation file)}
  \item{species}{ a character string specifying the species}
}
\details{
This is an internal function and should not be called by users directly.

It processes annotation of genes in human genome GRCh37/hg19 or mouse genome GRCm37/mm9.
The annotation is available for download from the following links (these annotations include chromosomal coordinates of UTR and CDS regions of genes):

\url{ftp://ftp.ncbi.nlm.nih.gov/genomes/H_sapiens/ARCHIVE/BUILD.37.2/mapview/seq_gene.md.gz}

\url{ftp://ftp.ncbi.nlm.nih.gov/genomes/M_musculus/ARCHIVE/BUILD.37.2/mapview/seq_gene.md.gz}

This function finds the chromosomal coordinates of intergenic regions (regions between neighbouring genes) and then outputs them to a file.
It also outputs to a file chromosomal coordinates of exons of genes by concatenating UTRs with CDSs and merging overlapping CDSs within each gene.
The generated annotation files will then be used by \code{\link{detectionCallAnnotation}} function to produce annotation data required by \code{\link{detectionCall}} function.
}
\value{ 
Two annotation files are written to the current working directory. This function returns a \code{NULL} object.
}
%\references{}
\author{Zhiyin Dai and Wei Shi}
%\note{}
%\seealso{}
% Add one or more standard keywords, see file 'KEYWORDS' in the 
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{sublong}
\alias{sublong}
\title{Align Long Sequence Reads to a Reference Genome via Seed-and-Vote}
\description{This function aligns DNA-seq reads, generated by long-read sequencing technologies such as Nanopore and PacBio sequencers, to a reference genome.}
\usage{
sublong(

    # basic input/output options
    index,
    readFiles,
    outputFiles,
    outputFormat = "BAM",
    nthreads = 1)
}
\arguments{
	\item{index}{ a character vector giving the basename of index files. Index files should be located in the current directory. The provided index should be a full index and also it should have only one block. See \code{buildindex} for index building options.}
	\item{readFiles}{ a character vector giving the names of input files that contain long sequence reads. FASTQ and gzipped FASTQ formats are both accepted.}
	\item{outputFiles}{ a character vector specifying the names of output files that contain read mapping results.}
	\item{outputFormat}{ a character string specifying the format of output files. \code{BAM} by default. Acceptable formats include \code{SAM} and \code{BAM}. }
	\item{nthreads}{ an integer giving the number of threads used for mapping. \code{1} by default. Note that when more than one thread is used, the order of reads might be changed in the output.}
}
\details{
\code{sublong} is designed for the mapping of long reads.
It performs full alignment of reads by performing seed-and-vote mapping followed by a bounded dynamic programming procedure.
\code{sublong} is able to map reads as long as millions of bases.

\code{sublong} is extremely fast.
It takes less than 10 minutes to complete the mapping of more than 100,000 long reads generated from Nanopore MinION ultra-long sequencing protocol.

The number of CIGAR operations (eg. insertion and deletion) reported for a long read may exceed the limit on the total number of operations allowed in a CIGAR string (up to 65,535 operations in a CIGAR string in BAM output and up to 99,900 operations in a CIGAR string in SAM output).
If this limited is exceeded, the read will be soft clipped.
}
\author{Yang Liao and Wei Shi}
\examples{
ref <- system.file("extdata","reference.fa",package="Rsubread")
buildindex(basename="./full_index",reference=ref,gappedIndex=FALSE, indexSplit=FALSE)
reads <- system.file("extdata","longreads.txt.gz",package="Rsubread")
sublong("./full_index",reads,"./Long_alignment.BAM",nthreads=4)
}

\name{promoterRegions}
\alias{promoterRegions}
\title{Generate Annotation for Promoter Regions of Genes}
\description{Create a SAF data-frame of genewise promoter regions.}
\usage{
promoterRegions(

    annotation = "mm39",
    upstream = 3000L,
    downstream = 2000L)
}
\arguments{
  \item{annotation}{ a data.frame containing gene annotation in SAF format or a character string giving the name of a genome with built-in annotation. If using built-in annotation, the character string should be one of the following: \code{mm10}, \code{mm9}, \code{hg38} or \code{hg19} corresponding to the NCBI RefSeq annotations for the genomes `mm10', `mm9', `hg38' and `hg19', respectively.}
  \item{upstream}{ an integer giving the number of upstream bases that will be inclued in the promoter region generated for each gene. These bases are taken immediately upstream (5' end) from transcriptional start site of each gene.}
  \item{downstream}{ an integer giving the number of downstream bases that will be inclued in the promoter region generated for each gene. These bases are taken immediately downstream (3' end) from transcriptional start site of each gene.}
}
\details{
This function takes as input a SAF format gene annotation and produces a SAF format data.frame containing the chromosomal coordinates of the specified promoter region for each gene.
See \code{\link{featureCounts}} for definition of the SAF format.

Regardless of the \code{upstream} or \code{downstream} values, the downstream end of the region never extends past the end of the gene and the upstream end never extends outside the relevant chromosome.
Setting \code{downstream} to an infinite or large value will cause the body of each gene to be included.
}
\value{ 
A SAF format \code{data.frame} with columns \code{GeneID}, \code{Chr}, \code{Start}, \code{End} and \code{Strand}.
}
%\references{
%}
\author{Gordon K Smyth}
%\note{}
\seealso{
\code{\link{featureCounts}}, \code{\link{getInBuiltAnnotation}}}
\examples{
# To get whole gene bodies (from TSS to TES) for the latest mouse genome:
x <- promoterRegions("mm39", upstream = 0, downstream = Inf)
head(x)
}

\name{getInBuiltAnnotation}
\alias{getInBuiltAnnotation}
\title{Retrieve inbuilt gene annotations}
\description{Retrieve an inbuilt gene annotation and save it to a data frame.}
\usage{
getInBuiltAnnotation(annotation = "mm39")
}
\arguments{
  \item{annotation}{ a character string specifying the inbuilt gene annotation to be retrieved. It has five possible values including \code{mm39}, \code{mm10}, \code{mm9}, \code{hg38} and \code{hg19}, which correspond to the NCBI RefSeq gene annotations for genomes `mm39', `mm10', `mm9', `hg38' and `hg19', respectively. \code{mm39} by default.}
}
\details{
The inbuilt gene annotations included in the Rsubread package were generated based on the NCBI RefSeq gene annotations.
The inbuilt annotations are much simpler than the original RefSeq annotations in that they only contain essential data required for the processing of sequencing data such as RNA-seq data.
Also in each inbuilt annotation, duplicate exons within the same gene are removed and overlapping exons within the same gene are merged.
For more information about the inbuilt annotations, please refer to the help page for \code{\link{featureCounts}} function.
}
\value{ 
A data frame with five columns including \code{GeneID}, \code{Chr}, \code{Start}, \code{End} and \code{Strand}.
}
%\references{
%}
\author{Wei Shi}
%\note{}
\seealso{
\code{\link{featureCounts}}}
\examples{
x <- getInBuiltAnnotation("hg38")
head(x)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{exactSNP}
\alias{exactSNP}
\title{Accurately and Efficiently call SNPs}
\description{Measure background noises and perform Fisher's Exact tests to detect SNPs.}
\usage{
exactSNP(

    # basic input/output options
    readFile,
    isBAM = FALSE,
    refGenomeFile,
    SNPAnnotationFile = NULL,
    outputFile = paste0(readFile, ".exactSNP.VCF"),

    # fine tuning parameters 
    qvalueCutoff = 12,
    minAllelicFraction = 0,
    minAllelicBases = 1,
    minReads = 1,
    maxReads = 1000000,
    minBaseQuality = 13,
    nTrimmedBases = 3,
    nthreads = 1)
}
\arguments{
  \item{readFile}{ a character string giving the name of a file including read mapping results. This function takes as input a SAM file by default. If a BAM file is provided, the \code{isBAM} argument should be set to \code{TRUE}. If the input is paired-end data, the reads have to be name sorted.}
  \item{isBAM}{ logical indicating if the file provided via \code{readFile} is a BAM file. \code{FALSE} by default.}
  \item{refGenomeFile}{ a character string giving the name of a file that includes reference sequences (FASTA format).}
  \item{SNPAnnotationFile}{ a character string giving the name of a VCF-format file that includes annotated SNPs (the file can be uncompressed or gzip compressed). Such annotation can be downloaded from public databases such as dbSNP. Incorporating known SNPs into SNP calling has been found to be helpful. However note that the annotated SNPs may or may not be called for the sample being analyzed.}
  \item{outputFile}{ a character string giving the name of the output file to be generated by this function. The output file includes all the reported SNPs (in VCF format). It includes discovered indels as well.}
  \item{qvalueCutoff}{ a numeric value giving the q-value cutoff for SNP calling at sequencing depth of 50X. \code{12} by default. The q-value is calcuated as -log10(p), where p is the p-value yielded from the Fisher's Exact test. Note that this function automatically adjusts the q-value cutoff for each chromosomal location according to its sequencing depth, based on this cutoff.}
  \item{minAllelicFraction}{ a numeric value giving the minimum fraction of allelic bases out of all read bases included at a chromosomal location required for SNP calling. Its value must be within \code{0} and \code{1}. \code{0} by default.}
  \item{minAllelicBases}{ an integer giving the minimum number of allelic (mis-matched) bases a SNP must have at a chromosomal location. \code{1} by default.}
  \item{minReads}{ an integer giving the minimum number of mapped reads a SNP-containing location must have (ie. the minimum coverage). \code{1} by default.}
  \item{maxReads}{ an integer specifying the maximum depth a SNP-containing location is allowed to have. \code{1000000} by default. Any location having number of mapped reads higher than this threshold will not be considered for SNP calling. This option is useful for removing PCR artefacts.}
  \item{minBaseQuality}{ a numeric value giving the minimum base quality score (Phred score) read bases should satisfy before being used for SNP calling. \code{13} by default(corresponding to base calling p value of 0.05). Read bases with quality scores less than 13 will be excluded from analysis.}
  \item{nTrimmedBases}{ a numeric value giving the number of bases trimmed off from each end of the read. \code{3} by default.}
  \item{nthreads}{ a numeric value giving the number of threads/CPUs used. \code{1} by default.}
}
\details{
This function takes as input a SAM/BAM format file, measures local background noise for each chromosomal location and then performs Fisher's exact tests to find statistically significant SNPs .

This function implements a novel algorithm for discovering SNPs.
This algorithm is comparable with or better than existing SNP callers, but it is fast more efficient.
It can be used to call SNPs for individual samples (ie. no control samples are required).
Detail of the algorithm is described in a manuscript which is currently under preparation.
}
\value{
No value is produced but but a VCF format file is written to the current working directory. This file contains detailed information for discovered SNPs including chromosomal locations, reference bases, alternative bases, read coverages, allele frequencies and p values. 
}
%\references{
%}
\author{Yang Liao and Wei Shi}
%\note{}
%\seealso{}
%\examples{}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{findCommonVariants}
\alias{findCommonVariants}
\title{Finding the Common Variants Among All Input VCF Files}
\description{
The common variants (inc. SNPs and indels) among all the input files are found. A data frame containing these common variants is returned. The data frame has a similar format as VCF files. }
\usage{
  findCommonVariants(VCF_files)
}
\arguments{
  \item{VCF_files}{ a character vector giving the names of VCF format files.}
}
\details{
This function loads all variants (SNPs and indels) from the input VCF files, and find the common variants that are reported in all the VCF files. If a variant record in a input VCF file has multiple alternative sequences (split by `,'), each alternative sequence is treated as a single variant. Two variants in two VCF files are the same only if their genomic locations, their reference sequences, their alternative sequences and their variant types are identical.

This function currently does not support other types of variants other than SNPs and indels. 

There are eight columns in the returned data frame: chromosome name, position, identity, reference sequence, alternative sequence, quality, filter and extra information. The input may have more columns; these columns are not included in the data frame. If the identity, the quality, the filter and the extra information for the same variant are different among the input VCF files, those information associated with the lowest quality value of this variant among the VCF files is reported in the resulted data frame. For example, if an SNP on chrX:12345 (A=>G) is reported in all the three input VCF files, and the quality scores in the three VCF files are 100, 10, 50 respectively, the identity, the quality, the filter and the extra information in the second VCF file are reported in the resulted data frame for this SNP.
}
\value{ 
A data frame containing the common variants among all the input VCF files is returned. The first eight columns are: chromosome name, position, identity, reference sequence, alternative sequence, quality, filter and extra information.

If there are not any common variants, this function returns an NA value.
}
%\references{
%}
\author{Yang Liao and Wei Shi}

%\note{}
%\seealso{}
\examples{\dontrun{
# finding the common variants between to input VCF files: a.vcf and b.vcf
library(Rsubread)
findCommonVariants(c('a.vcf','b.vcf'))
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{propmapped}
\alias{propmapped}
\title{Calculate the Proportion of Mapped Reads or Fragments in SAM/BAM Files}
\description{Number of mapped reads/fragments will be counted and fraction of such reads/fragments will be calculated.}
\usage{
propmapped(

    files,
    countFragments = TRUE,
    properlyPaired = FALSE,
    verbose = FALSE)
}
\arguments{
  \item{files}{ a character vector giving the names of SAM/BAM format files. Format of input files is automatically determined by the function.}
  \item{countFragments}{ logical indicating whether reads or fragments (read pairs) should be counted. If \code{TRUE}, fragments will be counted when paired-end read data are provided. This function automatically detects if the data are single end or paired end. For single end data, each read is treated as a fragment and therefore the value of this parameter should be set to \code{TRUE}.}
  \item{properlyPaired}{ logical indicating if only properly paired reads will be counted. This is only applicable for paired end data. \code{FALSE} by default.}
  \item{verbose}{ logical indicating if verbose information should be displayed.}
}
\details{
This function uses the \code{FLAG} field in the SAM/BAM to look for mapped reads and count them.
Reads/fragments, which have more than one reported location, will be reported only once.

When counting single end reads, counting reads has the same meaning as counting fragments (the results are identical).

Note that \code{align} and \code{subjunc} return the same mapping statistics as \code{propmapped} as a by-product of the alignment process, so saving the output from \code{align} or \code{subjunc} will be faster and more informative than running \code{propmapped} separately.
}
\value{ 
A data frame containing the total number of reads, number of mapped reads and proportion of mapped reads for each library.
}
%\references{
%}
\author{Wei Shi and Yang Liao}
%\note{}
%\seealso{}
\examples{
# build an index using the sample reference sequence provided in the package
# and save it to the current directory
ref <- system.file("extdata","reference.fa",package="Rsubread")
buildindex(basename="./reference_index",reference=ref)

# align the sample read data provided in this package to the sample reference
# and save the mapping results to the current directory
reads <- system.file("extdata","reads.txt.gz",package="Rsubread")
stat <- align(index="./reference_index",readfile1=reads,output_file="./Rsubread_alignment.BAM")
stat

# get the percentage of successfully mapped reads
propmapped("./Rsubread_alignment.BAM")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{sam2bed}
\alias{sam2bed}
\title{Convert a SAM Format File to a BED File}
\description{This function performs SAM to BED conversion. Each read in the SAM input is converted into an interval in the BED file.}
\usage{
sam2bed(

    samfile,
    bedfile,
    readlen)
}
\arguments{
  \item{samfile}{ a character string giving the name of input file. Input format should be in SAM format.}
  \item{bedfile}{ a character string giving the name of output file. Output file is in BED format.}
  \item{readlen}{ a numeric value giving the length of reads included in the input file.}
  }
\details{
This function converts a SAM format file to a BED format file, which can then be displayed in a genome browser like UCSC genome browser, IGB, IGV. This function does not find the read length from the SAM file, but requires the user to specify the read length.
}
\value{ 
No value is produced but a BED format file is written to the current working directory. This file contains six columns including chromosomal name, start position, end position, name(`.'), mapping quality score and strandness.
}
%\references{}
\author{Wei Shi}
%\note{}
%\seealso{}
%\examples{}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{featureCounts}
\alias{featureCounts}
\title{Count Reads by Genomic Features}
\description{Assign mapped sequencing reads to specified genomic features.}
\usage{
featureCounts(files,

    # annotation
    annot.inbuilt = "mm39",
    annot.ext = NULL,
    isGTFAnnotationFile = FALSE,
    GTF.featureType = "exon",
    GTF.attrType = "gene_id",
    GTF.attrType.extra = NULL,
    chrAliases = NULL,
    
    # level of summarization
    useMetaFeatures = TRUE,
    
    # overlap between reads and features
    allowMultiOverlap = FALSE,
    minOverlap = 1,
    fracOverlap = 0,
    fracOverlapFeature = 0,
    largestOverlap = FALSE,
    nonOverlap = NULL,
    nonOverlapFeature = NULL,

    # Read shift, extension and reduction
    readShiftType = "upstream",
    readShiftSize = 0,
    readExtension5 = 0,
    readExtension3 = 0,
    read2pos = NULL,
    
    # multi-mapping reads
    countMultiMappingReads = TRUE,

    # fractional counting
    fraction = FALSE,

    # long reads
    isLongRead = FALSE,

    # read filtering
    minMQS = 0,
    splitOnly = FALSE,
    nonSplitOnly = FALSE,
    primaryOnly = FALSE,
    ignoreDup = FALSE,
    
    # strandness
    strandSpecific = 0,
    
    # exon-exon junctions
    juncCounts = FALSE,
    genome = NULL,
    
    # parameters specific to paired end reads
    isPairedEnd = FALSE,
    countReadPairs = TRUE,
    requireBothEndsMapped = FALSE,
    checkFragLength = FALSE,
    minFragLength = 50,
    maxFragLength = 600,
    countChimericFragments = TRUE,    
    autosort = TRUE,
    
    # number of CPU threads
    nthreads = 1,

    # read group
    byReadGroup = FALSE,

    # report assignment result for each read
    reportReads = NULL,
    reportReadsPath = NULL,

    # miscellaneous
    tmpDir = ".",
    verbose = FALSE)
}
\arguments{
  \item{files}{ a character vector giving names of input files containing read mapping results. The files can be in either SAM format or BAM format. The file format is automatically detected by the function.}
  \item{annot.inbuilt}{ a character string specifying an inbuilt gene annotation used for read summarization. It has five possible values \code{"mm39"}, \code{"mm10"}, \code{"mm9"}, \code{"hg38"} and \code{"hg19"}, corresponding to the NCBI RefSeq annotations for genomes `mm39`, `mm10', `mm9', `hg38' and `hg19', respectively. \code{"mm39"} by default. The inbuilt annotation has a SAF format (see below).}
  \item{annot.ext}{ A character string giving name of a user-provided annotation file or a data frame including user-provided annotation data. If the annotation is in GTF format, it can only be provided as a file. If it is in SAF format, it can be provided as a file or a data frame. See below for more details about SAF format annotation. If an annotation file is provided, it can be uncompressed or gzip compressed. Note that \code{annot.ext} will override \code{annot.inbuilt} if both provided.}
  \item{isGTFAnnotationFile}{ logical indicating whether the annotation provided via the \code{annot.ext} argument is in GTF format or not. \code{FALSE} by default. This option is only applicable when \code{annot.ext} is not \code{NULL}.}
  \item{GTF.featureType}{ a character string or a vector of character strings giving the feature type or types used to select rows in the GTF annotation which will be used for read summarization. \code{"exon"} by default. This argument is only applicable when \code{isGTFAnnotationFile} is \code{TRUE}. Feature types can be found in the third column of a GTF annotation.}
  \item{GTF.attrType}{ a character string giving the attribute type in the GTF annotation which will be used to group features (eg. exons) into meta-features (eg. genes). \code{"gene_id"} by default. This argument is only applicable when \code{isGTFAnnotationFile} is \code{TRUE}. Attributes can be found in the ninth column of a GTF annotation.}
  \item{GTF.attrType.extra}{ a character vector specifying extra GTF attribute types that will also be included in the counting output. These attribute types will not be used to group features. \code{NULL} by default.}
  \item{chrAliases}{ a character string giving the name of a chromosome name alias file. This should be a two-column comma-delimited text file. Chromosome name aliases included in this file are used to match chr names in annotation with those in the reads. First column in the file should include chr names in the annotation and second column should include chr names in the reads. Chr names are case sensitive. No column header should be included in the file.}
  \item{useMetaFeatures}{ logical indicating whether the read summarization should be performed at the feature level (eg. exons) or meta-feature level (eg. genes). If \code{TRUE}, features in the annotation (each row is a feature) will be grouped into meta-features, using their values in the \code{GeneID} column in the SAF-format annotation file or using the \code{GTF.attrType} attribute in the GTF-format annotation file, and then reads will be assiged to the meta-features instead of the features. See below for more details.}
  \item{allowMultiOverlap}{ logical indicating if a read is allowed to be assigned to more than one feature (or meta-feature) if it is found to overlap with more than one feature (or meta-feature). \code{FALSE} by default.}
  \item{minOverlap}{ \code{integer} giving the minimum number of overlapped bases required for assigning a read to a feature (or a meta-feature). For assignment of read pairs (fragments), number of overlapping bases from each read in the same pair will be summed. If a negative value is provided, then a gap of up to specified size will be allowed between read and the feature that the read is assigned to. \code{1} by default.}
  \item{fracOverlap}{ \code{numeric} giving minimum fraction of overlapping bases in a read that is required for read assignment. Value should be within range [0,1]. \code{0} by default. Number of overlapping bases is counted from both reads if paired end. Both this option and \code{minOverlap} option need to be satisfied before a read can be assigned.}
  \item{fracOverlapFeature}{ \code{numeric} giving minimum fraction of bases included in a feature that is required for overlapping with a read or a read pair. Value should be within range [0,1]. \code{0} by default.}
  \item{largestOverlap}{ If \code{TRUE}, a read (or read pair) will be assigned to the feature (or meta-feature) that has the largest number of overlapping bases, if the read (or read pair) overlaps with multiple features (or meta-features).}
  \item{nonOverlap}{ \code{integer} giving the maximum number of bases in a read (or a read pair) that are allowed not to overlap the assigned feature. \code{NULL} by default (ie. no limit is set).}
  \item{nonOverlapFeature}{ \code{integer} giving the maximum number of non-overlapping bases allowed in a feature during read assignment. \code{NULL} by default (ie. no limit is set).}
  \item{readShiftType}{ a character string indicating how reads should be shifted. It has four possible values including \code{upstream}, \code{downstream}, \code{left} and \code{right}. Read shifting is performed before read extension (\code{readExtension5} and \code{readExtension3}) and reduction (\code{read2pos}).}
  \item{readShiftSize}{ \code{integer} specifying the number of bases the reads will be shifted by. \code{0} by default. Negative value is not allowed.}
  \item{readExtension5}{ \code{integer} giving the number of bases extended upstream from 5' end of each read. \code{0} by default. Read extension is performed after read shifting but before read reduction. Negative value is not allowed.}
  \item{readExtension3}{ \code{integer} giving the number of bases extended downstream from 3' end of each read. \code{0} by default. Negative value is not allowed.}
  \item{read2pos}{ Specifying whether each read should be reduced to its 5' most base or 3' most base. It has three possible values: \code{NULL}, \code{5} (denoting 5' most base) and \code{3} (denoting 3' most base). Default value is \code{NULL}, ie. no read reduction will be performed. If a read is reduced to a single base, only that base will be considered for the read assignment. Read reduction is performed after read shifting and extension.}
  \item{countMultiMappingReads}{ logical indicating if multi-mapping reads/fragments should be counted, \code{TRUE} by default. `NH' tag is used to located multi-mapping reads in the input BAM/SAM files.}
  \item{fraction}{ logical indicating if fractional counts are produced for multi-mapping reads and/or multi-overlapping reads. \code{FALSE} by default. See below for more details.}
  \item{isLongRead}{ logical indicating if input data contain long reads. This option should be set to \code{TRUE} if counting Nanopore or PacBio long reads.}
  \item{minMQS}{ \code{integer} giving the minimum mapping quality score a read must satisfy in order to be counted. For paired-end reads, at least one end should satisfy this criteria. \code{0} by default.}
  \item{splitOnly}{ logical indicating whether only split alignments (their CIGAR strings contain letter 'N') should be included for summarization. \code{FALSE} by default. Example split alignments are exon-spanning reads from RNA-seq data. \code{useMetaFeatures} should be set to \code{FALSE} and \code{allowMultiOverlap} should be set to \code{TRUE}, if the purpose of summarization is to assign exon-spanning reads to all their overlapping exons.}
  \item{nonSplitOnly}{ logical indicating whether only non-split alignments (their CIGAR strings do not contain letter 'N') should be included for summarization. \code{FALSE} by default.}
  \item{primaryOnly}{ logical indicating if only primary alignments should be counted. Primary and secondary alignments are identified using bit 0x100 in the Flag field of SAM/BAM files. If \code{TRUE}, all primary alignments in a dataset will be counted no matter they are from multi-mapping reads or not (ie. \code{countMultiMappingReads} is ignored).}
  \item{ignoreDup}{ logical indicating whether reads marked as duplicates should be ignored. \code{FALSE} by default. Read duplicates are identified using bit Ox400 in the FLAG field in SAM/BAM files. The whole fragment (read pair) will be ignored if paired end.}
  \item{strandSpecific}{ an integer vector indicating if strand-specific read counting should be performed. Length of the vector should be either \code{1} (meaning that the value is applied to all input files), or equal to the total number of input files provided. Each vector element should have one of the following three values: \code{0} (unstranded), \code{1} (stranded) and \code{2} (reversely stranded). Default value of this parameter is \code{0} (ie. unstranded read counting is performed for all input files).}
  \item{juncCounts}{logical indicating if number of reads supporting each exon-exon junction will be reported. Junctions will be identified from all the exon-spanning reads included in the input data. \code{FALSE} by default.}
  \item{genome}{ a character string giving the name of a FASTA-format file that includes the reference sequences used in read mapping that produced the provided SAM/BAM files. \code{NULL} by default. This argument should only be used when \code{juncCounts} is \code{TRUE}. Note that providing reference sequences is optional when \code{juncCounts} is set to \code{TRUE}.}
  \item{isPairedEnd}{ A logical scalar or a logical vector, indicating whether libraries contain paired-end reads or not. \code{FALSE} by default. For any library that contains paired-end reads, the 'countReadPairs' parameter controls if read pairs or reads should be counted.}
  \item{countReadPairs}{ A logical scalar or a logical vector, indicating if read pairs, instead of reads, should be counted for paired-end read data. \code{TRUE} by default. This parameter is only applicable for paired-end data. For single-end data, it is ignored.}
  \item{requireBothEndsMapped}{ logical indicating if both ends from the same fragment are required to be successfully aligned before the fragment can be assigned to a feature or meta-feature. This parameter is only appliable when \code{isPairedEnd} is \code{TRUE}.}
  \item{checkFragLength}{ logical indicating if the two ends from the same fragment are required to satisify the fragment length criteria before the fragment can be assigned to a feature or meta-feature. This parameter is only appliable when \code{isPairedEnd} is \code{TRUE}. The fragment length criteria are specified via \code{minFragLength} and \code{maxFragLength}.}
  \item{minFragLength}{ \code{integer} giving the minimum fragment length for paired-end reads. \code{50} by default.}
  \item{maxFragLength}{ \code{integer} giving the maximum fragment length for paired-end reads. \code{600} by default. \code{minFragLength} and \code{maxFragLength} are only applicable when \code{isPairedEnd} is \code{TRUE}. Note that when a fragment spans two or more exons, the observed fragment length might be much bigger than the nominal fragment length.}
  \item{countChimericFragments}{ logical indicating whether a chimeric fragment, which has its two reads mapped to different chromosomes, should be counted or not. \code{TRUE} by default.}
  \item{autosort}{ logical specifying if the automatic read sorting is enabled. This option is only applicable for paired-end reads. If \code{TRUE}, reads will be automatically sorted by their names if reads from the same pair are found not to be located next to each other in the input. No read sorting will be performed if there are no such reads found.}
  \item{nthreads}{ \code{integer} giving the number of threads used for running this function. \code{1} by default.}
  \item{byReadGroup}{ logical indicating if read counting will be performed for each individual read group. \code{FALSE} by default.}
  \item{reportReads}{ output detailed read assignment results for each read (or fragment if paired end). The detailed assignment results can be saved in three different formats including \code{CORE}, \code{SAM} and \code{BAM} (note that these values are case sensitive). Default value of this option is \code{NULL}, indicating not to report assignment results for reads. \code{CORE} format represents a tab-delimited text file that contains four columns including read name, status (assigned or the reason if not assigned), number of targets and target list. A target is a feature or a meta-feature. Items in the target lists is separated by comma. If a read is not assigned, its number of targets will be set as -1. For each input file, a text file is generated and its name is the input file name added with `.featureCounts'. When \code{SAM} or \code{BAM} format is specified, the detailed assignment results will be saved to SAM and BAM format files. Names of generated files are the input file names added with `.featureCounts.sam' or `.featureCounts.bam'. Three tags are used to describe read assignment results: XS, XN and XT. Tag XS gives the assignment status. Tag XN gives number of targets. Tag XT gives comma separated target list.}
  \item{reportReadsPath}{ a character string specifying the directory where files including detailed assignment results are saved. If \code{NULL}, the results will be saved to the current working directory.}
  \item{tmpDir}{ a character string specifying the directory under which intermediate files are saved (later removed). By default, current working directory is used.}
  \item{verbose}{ logical indicating if verbose information for debugging will be generated. This may include information such as unmatched chromosomes/contigs between reads and annotation.}
  }
\details{
\code{featureCounts} is a general-purpose read summarization function that can assign mapped reads from genomic DNA and RNA sequencing to genomic features or meta-features.

The function takes as input a set of SAM or BAM files containing read mapping results.
The files might be generated by \code{\link{align}} or \code{\link{subjunc}} or any suitable aligner.

\code{featureCounts} accepts two annotation formats to specify the genomic features: SAF (Simplified Annotation Format) or GTF/GFF.
The GTF/GFF format is specified at \url{https://genome.ucsc.edu/FAQ/FAQformat.html}.
SAF is a Simplified Annotation Format with five columns.
It can be either a data.frame or a tab-delimited text file in the following style:

\preformatted{
GeneID		Chr	Start	End	Strand
497097		chr1	3204563	3207049	-
497097		chr1	3411783	3411982	-
497097		chr1	3660633	3661579	-
100503874	chr1	3637390	3640590	-
100503874	chr1	3648928	3648985	-
100038431	chr1	3670236	3671869	-
...
}

SAF annotation includes the following five required columns: \code{GeneID}, \code{Chr}, \code{Start}, \code{End} and \code{Strand}.
The \code{GeneID} column includes identifiers of features.
These identifiers can be integer or character string.
The \code{Chr} column includes chromosome names of features and these names should match the chromosome names includes in the provided SAM/BAM files.
The \code{Start} and \code{End} columns include start and end coordinates of features, respectively.
Both start and end coordinates are inclusive.
The \code{Strand} column indicates the strand of features (\code{"+"} or \code{"-"}).
Column names in a SAF annotation should be the same as those shown in the above example (case insensitive).
Columns can be in any order.
Extra columns are allowed to be added into the annotation.

Inbuilt annotations, which were generated based on NCBI RefSeq gene annotations, are provided to faciliate convenient read summarization.
We provide inbuilt annotations for the following genomes: \code{"hg38"}, \code{"hg19"}, \code{"mm39"}, \code{"mm10"} and \code{"mm9"}.
The content of inbuilt annotations can be accessed via the \code{\link{getInBuiltAnnotation}} function.
These annotations have a SAF format.
 
The inbuilt annotations are a modified version of NCBI RefSeq gene annotations. 
For inbuilt annotations \code{"hg38"}, \code{"hg19"}, \code{"mm10"} and \code{"mm9"}, their original RefSeq annotations were downloaded from NCBI RefSeq MapView.
We then used these downloaded annotations to create inbuilt annotations. 
For each gene, we used its CDS and UTR regions provided in the original annotation to construct a list of exons, by merging and concatenating all CDSs and UTRs belonging to the same gene. 
Exons within each gene include all chromosomal bases included in the original CDS and UTR regions, but they include each base only once. 
Also, exons within the same gene in the inbuilt annotation do not overlap with each other.

For the inbuilt annotation \code{"mm39"}, its original RefSeq annotation was downloaded from \url{https://ftp.ncbi.nlm.nih.gov/genomes/all/annotation_releases/10090/GCF_000001635.27-RS_2023_04/GCF_000001635.27_GRCm39_genomic.gtf.gz}. 
This is a GTF-format annotation. 
We changed the format of chromosome names in this annotation from \code{"NC_xxxxxx"} to \code{"chr"} followed by a number. 
For example, \code{"NC_000067.7"} was changed to \code{"chr1"}. 
The \code{\link{flattenGTF}} function was then used to merge overlapping exons within the same gene to generate the inbuilt annotation. 
Entrez gene identifiers were used in this annotation.

Users may provide an external annotation to \code{featureCounts} for read summarization via the \code{annot.ext} parameter.
If the provided external annotation is in SAF format, it can be provided as either a \code{data.frame} or a tab-delimited text file with proper column names included.
If it is in GTF/GFF format, it should be provided as a file only (and \code{isGTFAnnotationFile} should be set to \code{TRUE}).

\code{featureCounts} function uses the \code{GTF.attrType} attribute in a GTF/GFF annotation to group features to form meta-features when performing read summarization at meta-feature level.

The argument \code{useMetaFeatures} specifies whether read summarization should be performed at feature level or at meta-feature level.
A feature represents a continuous genomic region and a meta-feature is a group of features.
For instance, an exon is a feature and a gene comprising one or more exons is a meta-feature.
To assign reads to meta-features, \code{featureCounts} firstly groups into meta-features the features that have the same gene identifiers.
\code{featureCounts} looks for gene identifiers in \code{GeneID} column of a SAF annotation or by using \code{GTF.attrType} attribute in a GTF/GFF annotation.
Then for each read \code{featureCounts} searches for meta-features that have at least one feature that overlaps with the read.
A read might be found to overlap with more than one feature within the same meta-feature (eg. an exon-spanning read overlaps with more than one exon from the same gene), however this read will still be counted only once for the meta-feature.

RNA-seq reads are often summarized to meta-features to produce read counts for genes.
Further downstream analysis can then be carried out to discover differentially expressed genes.
Feature-level summarization of RNA-seq data often yields exon-level read counts, which is useful for investigating alternative splicing of genes.

\code{featureCounts} provides multiple options to count multi-mapping reads (reads mapping to more than one location in the reference genome).
Users can choose to ignore such reads by setting \code{countMultiMappingReads} to \code{FALSE}, or fully count every alignment reported for a multi-mapping read by setting \code{countMultiMappingReads} to \code{TRUE} (each alignment carries \code{1} count), or count each alignment fractionally by setting both \code{countMultiMappingReads} and \code{fraction} to \code{TRUE} (each alignment carries \code{1/x} count where \code{x} is the total number of alignments reported for the read).

\code{featureCounts} also provides multiple options to count multi-overlapping reads (reads overlapping with more than one meta-feature when conducting meta-feature-level summarization or overlapping with more than one feature when conducting feature-level summarization).
Users can choose to ignore such reads by setting \code{allowMultiOverlap} to \code{FALSE}, or fully count them for each overlapping meta-feature/feature by setting \code{allowMultiOverlap} to \code{TRUE} (each overlapping meta-feature/feature receives a count of 1 from a read), or assign a fractional count to each overlapping meta-feature/feature by setting both \code{allowMultiOverlap} and \code{fraction} to \code{TRUE} (each overlapping meta-feature/feature receives a count of \code{1/y} from a read where \code{y} is the total number of meta-features/features overlapping with the read).

If a read is both multi-mapping and multi-overlapping, then each overlapping meta-feature/feature will receive a fractional count of \code{1/(x*y)} if \code{countMultiMappingReads}, \code{allowMultiOverlap} and \code{fraction} are all set to \code{TRUE}.

When \code{isPairedEnd} is \code{TRUE}, fragments (pairs of reads) instead of reads will be counted.
\code{featureCounts} function checks if reads from the same pair are adjacent to each other (this could happen when reads were for example sorted by their mapping locations), and it automatically reorders those reads that belong to the same pair but are not adjacent to each other in the input read file.
}
\value{ 
A list with the following components:
\item{counts}{ a data matrix containing read counts for each feature or meta-feature for each library.}

\item{counts_junction (optional)}{ A data frame generated when \code{juncCounts=TRUE}, containing information on detected exon-exon junctions and their associated splicing points. A splicing point refers to the chromosomal base immediately before the donor site or after the acceptor site. The data frame includes the following columns:
\itemize{
\item Gene_SP1: Gene(s) annotated for a splicing point. This represents one of the two splicing points associated with an exon-exon junction. A splicing point refers to the chromosomal base immediately before the donor site or after the acceptor site. The annotation provided to featureCounts is used to label junctions and their corresponding splicing points. Gene(s) associated with a splicing point are determined based on the following priority order: (1) genes containing a transcript that supports the existence of this junction; (2) genes containing an exon whose start or end base coincides with this splicing point; (3) genes within whose span this splicing point is located. If no such genes are found, the value will be \code{NA}. If an \code{SAF} format annotation is provided, the first priority will be ignored as the \code{SAF} annotation does not contain transcript information.

\item Gene_SP2: See description for \code{Gene_SP1}.

\item Transcript: Transcript(s) that support this junction. If none are found, the value is \code{NA}.

\item Status: If at least one transcript in the provided annotation supports the junction, the value is \code{KNOWN}; otherwise, it is \code{NOVEL}. \code{NA} if an \code{SAF} annotation is provided.

\item Donor: If the junction's donor and acceptor sites can be identified based on the canonical donor/acceptor sequences (GT/AG), the value will be \code{SP1} or \code{SP2}. Otherwise, it will be \code{NA}.

\item Acceptor: See description for \code{Donor}. 

\item Chr_SP1: Name of chromosome where splicing point 1 is located. 

\item Location_SP1: Chromosomal coordinate of splicing point 1.

\item Strand_SP1: Strand of splicing point 1, which can be \code{+}, \code{-}, or \code{NA} if unknown. Strandness is determined based on the donor/acceptor sequences (GT/AG). 

\item Chr_SP2: See description for \code{Chr_SP1}.

\item Location_SP2: See description for \code{Location_SP1}.

\item Strand_SP2 : See description for \code{Strand_SP1}.

\item NearestExonBoundary_SP1: Providing information about the nearest exon boundary (either the start or end base of an exon) relative to the splicing point, including chromosomal coordinate, gene name, distance, and direction (left or right of the splicing point). If the splicing point coincides with an exon boundary (as expected in most cases), the distance will be 0, and direction information will be omitted. Example formats: \code{chr1:1000,genename,0}, or \code{chr2:2000,genename,100,left}.

\item NearestExonBoundary_SP2: See description for \code{NearestExonBoundary_SP1}.

\item Columns for junction counts: Columns containing read counts supporting each junction for each sample.
}}
\item{annotation}{ a data frame with six columns including \code{GeneID}, \code{Chr}, \code{Start}, \code{End} and \code{Length}. When read summarization was performed at feature level, each row in the data frame is a feature and columns in the data frame give the annotation information for the features. When read summarization was performed at meta-feature level, each row in the data frame is a meta-feature and columns in the data frame give the annotation information for the features included in each meta feature except the \code{Length} column. For each meta-feature, the \code{Length} column gives the total length of genomic regions covered by features included in that meta-feature.   Note that this length will be less than the sum of lengths of features included in the meta-feature when there are features overlapping with each other. Also note the \code{GeneID} column gives Entrez gene identifiers when the inbuilt annotations are used.}
\item{targets}{ a character vector giving sample information.}
\item{stat}{ a data frame giving number of successfully assigned reads in each library and also number of unassigned reads falling in each filtering category (unmapped, read type, singleton, mapping quality, chimera, fragment length, duplicate, multi-mapping, secondary alignment, split alignment, no features, overlapping length and assignment ambiguity). See Users Guide for more details.}
}
\references{
Yang Liao, Gordon K Smyth and Wei Shi (2019).
The R package Rsubread is easier, faster, cheaper and better for alignment and quantification of RNA sequencing reads.
\emph{Nucleic Acids Research}, 47(8):e47.
\url{http://www.ncbi.nlm.nih.gov/pubmed/30783653}

Yang Liao, Gordon K Smyth and Wei Shi (2014).
featureCounts: an efficient general-purpose program for assigning sequence reads to genomic features.
\emph{Bioinformatics}, 30(7):923-30.
\url{http://www.ncbi.nlm.nih.gov/pubmed/24227677}
}
\author{Wei Shi and Yang Liao}
%\note{}
\seealso{
\code{\link{getInBuiltAnnotation}}}
\examples{\dontrun{
# Summarize SAM format single-end reads using built-in RefSeq annotation for mouse genome mm39:
featureCounts(files="mapping_results_SE.sam",annot.inbuilt="mm39")

# Summarize single-end reads using a user-provided GTF annotation file:
featureCounts(files="mapping_results_SE.sam",annot.ext="annotation.gtf",
isGTFAnnotationFile=TRUE,GTF.featureType="exon",GTF.attrType="gene_id")

# Summarize single-end reads using 5 threads:
featureCounts(files="mapping_results_SE.sam",nthreads=5)

# Summarize BAM format single-end read data:
featureCounts(files="mapping_results_SE.bam")

# Perform strand-specific read counting (strandSpecific=2 if reversely stranded):
featureCounts(files="mapping_results_SE.bam",strandSpecific=1)

# Summarize paired-end reads and counting fragments (instead of reads):
featureCounts(files="mapping_results_PE.bam",isPairedEnd=TRUE)

# Count fragments satisfying the fragment length criteria, eg. [50bp, 600bp]:
featureCounts(files="mapping_results_PE.bam",isPairedEnd=TRUE,
checkFragLength=TRUE,minFragLength=50,maxFragLength=600)

# Count fragments that have both ends successfully aligned without checking the fragment length:
featureCounts(files="mapping_results_PE.bam",isPairedEnd=TRUE,requireBothEndsMapped=TRUE)

# Exclude chimeric fragments from fragment counting:
featureCounts(files="mapping_results_PE.bam",isPairedEnd=TRUE,countChimericFragments=FALSE)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{detectionCallAnnotation}
\alias{detectionCallAnnotation}
\title{Generate Annotation Data Used for Calculating Detection P Values}
\description{This is for internal use only. This function generates the annotation files for calculating p values in the \code{detectionCall} function.}
\usage{
detectionCallAnnotation(

    species = "hg",
    binsize = 2000)
}
\arguments{
  \item{species}{ a character string specifying the species to analyase}
  \item{binsize}{ an integer value specifying the bin-size of integenic region}
}
\details{
This is an internal function and should not be called by users directly.

It takes as input the annotation files produced by \code{\link{processExons}} function, calculates GC percentages for each exon of genes and also for intergenic regions and add GC info into the annotations.
The new annotation data are then saved to files which can be used by \code{\link{detectionCall}} function for calling absolutely expressed genes.
}
\value{
Two annotation files, which contain GC content for exons of genes and for intergenic regions respectively, are written to the current working directory. This function returns a \code{NULL} object.
}
%\references{}
\author{Zhiyin Dai and Wei Shi}
%\note{}
%\seealso{}
% Add one or more standard keywords, see file 'KEYWORDS' in the 
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{simReads}
\alias{simReads}
\alias{scanFasta}
\title{Generate Simulated Reads from a Set of Transcripts}
\description{The \code{simReads} function generates simulated reads from a given set of transcripts with specified expression levels.}
\usage{
simReads(

    # the transcript sequences and relative expression levels
    transcript.file,
    expression.levels,
  
    # the name of the output files
    output.prefix,
  
    # options on the output
    library.size = 1e5,
    read.length = 75,
    truth.in.read.names = FALSE,
  
    # simulating sequencing errors
    simulate.sequencing.error = TRUE,
    quality.reference = NULL,
  
    # distribution of fragment lengths
    paired.end = FALSE,
    fragment.length.min = 100,
    fragment.length.max = 500,
    fragment.length.mean = 180,
    fragment.length.sd = 40,
  
    # manipulating transcript names
    simplify.transcript.names = FALSE,

    # strand-specific read generation
    strandSpecific = 0)

scanFasta(
  
    # the file containing the transcript database
    transcript.file,
  
    # manipulating transcript names
    simplify.transcript.names = FALSE,
  
    # miscellaneous options
    quiet = FALSE)
}
\arguments{
  \item{transcript.file}{ a character string giving the name of a file that contains the transcript names and sequences. The format can be FASTA or gzipped-FASTA. All transcript names must be unique and any duplicate sequences (two or more transcripts with the same sequence) will trigger warning messages.}
  \item{expression.levels}{ a numeric vector giving the relative expression levels of the transcripts, in the order of transcripts in \code{transcript.file}. The sum of the values must be positive, and no negative value is allowed.}
  \item{output.prefix}{ a character string giving the basename of all the output files.}
  \item{library.size}{ a numeric value giving the number of reads or read-pairs to be generated. One million by default.}
  \item{read.length}{a anumeric value giving the length of each read in the output. Maximum length is 250bp. Transcripts that are shorter than the read length will not be used for generating simulated reads. 75 by default.}
  \item{truth.in.read.names}{ logical indicating if the true mapping location of reads or read-pairs should be encoded into the read names. \code{FALSE} by default.}
  \item{simulate.sequencing.error}{ logical indicating if sequencing errors should be simulated in the output reads. If \code{TRUE}, the \code{quality.reference} parameter must be specified unless the output read length is 100-bp or 75-bp. If the output read length is 100-bp or 75-bp, the \code{quality.reference} parameter can be optionally omitted, and the function will use its inbuilt quality strings.}
  \item{quality.reference}{ a character string giving the name of a file that contains one or multiple sequencing quality strings in the Phred+33 format. The file should have Unix rather than Windows line ends and the sequencing quality strings must have the same length as \code{read.length}.}
  \item{paired.end}{ logical indicating if paired-end reads should be generated. \code{FALSE} by default.}
  \item{fragment.length.min}{ a numeric value giving the minimum fragment length. The minimum fragment length must be equal to or greater than the output read length. 100 by default.}
  \item{fragment.length.max}{ a numeric value giving the maximum fragment length. 500 by default.}
  \item{fragment.length.mean}{ a numeric value giving the mean of fragment lengths. 180 by default.}
  \item{fragment.length.sd}{ a numeric value giving the standard deviation of fragment lengths. The fragment lengths are drawn from a truncated gamma distribution that is defined by \code{fragment.length.min}, \code{fragment.length.max}, \code{fragment.length.mean} and \code{fragment.length.sd}. 40 by default.}
  \item{simplify.transcript.names}{ logical indicating if transcript names should be simplified. If \code{TRUE}, the transcript names are truncated to the first \code{|} or space. \code{FALSE} by default.}
  \item{strandSpecific}{ a numeric value specifying the strand from which reads are generated. In single-end mode, and for read 1 in paired-end mode, \code{0} means reads are generated randomly from either the same strand as the transcript (as in the FASTA input) or the opposite strand, \code{1} means reads are generated only from the same strand as the transcript, and \code{2} means reads are generated only from the opposite strand. In paired-end mode, read 2 is always generated from the strand opposite to read 1. Thus, when \code{1} is specified, read 2 only comes from the opposite strand of the transcript; when \code{2} is specified, read 2 only comes from the same strand as the transcript. \code{0} by default.}
  \item{quiet}{ logical indicating if the warning message for repeated sequences should be suppressed in the \code{scanFasta} function. \code{FALSE} by default.}
}
\details{
  \code{simReads} generates simulated reads from a set of transcript sequences at specified abundances. The input includes a transcript file in FASTA format and a numeric vector specifying the relative expression levels the transcripts. The output consists of one or two gzipped FASTQ files that contain the simulated reads or read-pairs.

  The number of fragments for each transcript are drawn from a multinomial distribution, summing to the specified library.size.
  The RNA fragment lengths are drawn from a truncated gamma distribution with mean and standard deviation specified by \code{fragment.length.mean} and \code{fragment.length.sd} respectively and lower and upper limits specified by \code{fragment.length.min} and \code{fragment.length.max}.
  The sequence reads are then taken from one or both ends of the simulated fragments to simulate short-read sequencing.

  To have reads generated from it, a transcript must have length equal to or greater than the minimum fragment length.

  Substitution sequencing errors can be simulated in the reads by emulating the sequencing quality of a real High-Throughput Sequencing sample. When \code{simulate.sequencing.error = TRUE} and a set of Phred+33 encoded quality strings are provided to \code{simReads}, a quality string is randomly chosen for each output read and read bases are substituted with random base values according to the probabilities described in the quality string. Inbuilt quality strings are provided for generating 100-bp and 75-bp long reads, hence the \code{quality.reference} can be optionally omitted when \code{read.length} is 100 or 75.

  The \code{scanFasta} function checks and processes the FASTA or gzipped-FASTA file. It scans through the file that defines the transcript sequences and returns a data.frame of transcript names and sequence lengths. It additionally checks the transcript sequences for uniqueness.
  
  Baldoni et al (2024) uses \code{simReads} to generate realistic RNA-seq data with specified levels of biological and technical variation.
}
\value{
  \code{simReads} writes a FASTQ file, or a pair of FASTQ files if \code{paired.end}, containing the simulated reads.
  It also returns a \code{data.frame} with three columns:
  \tabular{lll}{
    \code{TranscriptID} \tab character \tab transcript name\cr
    \code{Length} \tab integer \tab length of transcript sequence\cr
    \code{Count} \tab integer \tab simulated read count
  }

  \code{scanFasta} returns a \code{data.frame} with six columns:
  \tabular{lll}{
    \code{TranscriptID} \tab character \tab transcript name\cr
    \code{Length} \tab integer \tab length of transcript sequence\cr
    \code{MD5} \tab character \tab MD5 digest of the transcript sequence\cr
    \code{Unique} \tab logical \tab is this transcript's sequence unique in the FASTA file?\cr
    \code{Occurrence} \tab integer \tab number of times this transcript's sequence was observed\cr
    \code{Duplicate} \tab logical \tab this transcript's sequence is a duplicate of a previous sequence.
  }
  Note that selecting transcripts with \code{Duplicate == FALSE} will ensure unique sequences, i.e., any sequence that was observed multiple times in the FASTQ file will be only included only once in the selection.
}
\references{
Baldoni PL, Chen Y, Hediyeh-zadeh S, Liao Y, Dong X, Ritchie ME, Shi W, Smyth GK (2024).
Dividing out quantification uncertainty allows efficient assessment of differential transcript expression with edgeR.
\emph{Nucleic Acids Research} 52(3), e13.
\doi{10.1093/nar/gkad1167}.
}
\author{Yang Liao, Gordon K Smyth and Wei Shi}
\examples{
\dontrun{
# Scan through the fasta file to get transcript names and lengths
transcripts <- scanFasta("GENCODE-Human-transcripts.fa.gz")
nsequences <- nrow(transcripts) - sum(transcripts$Duplicate)

# Assign a random TPM value to each non-duplicated transcript sequence
TPMs <- rep(0, nrow(transcripts))
TPMs[!transcripts$Duplicate] <- rexp(nsequences)

# Generate actual reads.
# The output read file is my-simulated-sample_R1.fastq.gz 
# The true read counts are returned.
true.counts <- simReads("GENCODE-Human-transcripts.fa.gz", TPMs, "my-simulated-sample")
print(true.counts[1:10,])
}
}

\name{RsubreadUsersGuide}
\alias{RsubreadUsersGuide}

\title{View Rsubread Users Guide}
\description{Users Guide for Rsubread and Subread}

\usage{
RsubreadUsersGuide()
}

%\arguments{}

\value{Character string giving the file location.}

\details{
The Subread/Rsubread Users Guide provides detailed description to the functions and programs included in the Subread and Rsubread software packages.
It also includes case studies for analyzing next-gen sequencing data.

The Subread package is written in C and it can be downloaded from \url{http://subread.sourceforge.net}.
The Rsubread package provides R wrappers functions for many of the programs included in Subread package.

}

\seealso{
\code{\link{vignette}}
}

\author{Wei Shi}

%\examples{}

\keyword{documentation}

\name{cellCounts}
\alias{cellCounts}
\title{Map and quantify single-cell RNA-seq data generated by 10X Genomics}
\description{Process raw 10X scRNA-seq data and generate UMI counts for each gene in each cell.}
\usage{
cellCounts(

    # input data
    index,
    sample,
    input.mode = "BCL",
    cell.barcode = NULL,
  
    # parameters used for mapping reads
    nsubreads = 15,
    minVotes = 1,
    maxMismatches = 10,
    minMappedLength = 1,
  
    # parameters used for assigning and counting UMIs
    annot.inbuilt = "mm39",
    annot.ext = NULL,
    isGTFAnnotationFile = FALSE,
    GTF.featureType = "exon",
    GTF.attrType = "gene_id",
    useMetaFeatures = TRUE,
    
    # parameter for junction detection
    detectJunctions = FALSE,

    # user provided UMI cutoff for cell calling
    umi.cutoff = NULL,

    # number of threads
    nthreads = 10,

    # parameters for alignment of multi-mapping reads
    nBestLocations = 1,
    uniqueMapping = FALSE,

    # report UMI counts for cell barcodes that were filtered out
    reportExcludedBarcodes = FALSE
    )
}
\arguments{
  \item{index}{ A character string providing the base name of index files that were created for a reference genome by using \code{\link{buildindex}} function.}
  \item{sample}{ A data frame or a character string providing sample-related information. The value provided to this parameter depends on the \code{input.mode} parameter. See Details section below for more details.}
  \item{input.mode}{ A character string specifying the input mode. The supported input modes include \code{BCL}, \code{FASTQ}, \code{FASTQ-dir} and \code{BAM}. The \code{BCL} mode includes \code{BCL} and \code{CBCL} formats, which are used by Illumina for storing the raw reads directly generated from their sequencers. When \code{BCL} mode is specified, \code{cellCounts} will automatically identify whether the input data are in \code{BCL} format or \code{CBCL} format. \code{FASTQ} is the FASTQ format of sequencing reads. \code{FASTQ-dir} is a directory where FASTQ-format reads are saved. \code{FASTQ-dir} is useful for providing \code{cellCounts} the FASTQ data generated by \code{bcl2fastq} program or \code{bamtofastq} program (developed by 10X). \code{BAM} is the BAM format of mapped read data with cell barcodes and UMI sequences included (See the Details section below for more details). \code{BCL} by default.}
  \item{cell.barcode}{ A character string giving the name of a text file (can be gzipped) that contains the set of cell barcodes used in sample preparation. If \code{NULL}, a cell barcode set will be determined for the input data by \code{cellCounts} based on the matching of cell barcodes sequences of the first 100,000 reads in the data with the three cell barcode sets used by 10X Genomics. \code{NULL} by default.}
  \item{nsubreads}{ A numeric value giving the number of subreads (seeds) extracted from each read. \code{15} by default.}
  \item{minVotes}{ A numeric value giving the minimum number of votes required for reporting a hit. \code{1} by default.}
  \item{maxMismatches}{ A numeric value giving the maximum number of mis-matched bases allowed in the mapping of a read. \code{10} by default. Mis-matches found in soft-clipped bases are not counted.}
  \item{minMappedLength}{ A numeric value giving the minimum number of mapped bases in a read required for reporting a hit. \code{1} by default.}
  \item{annot.inbuilt}{ Specify an inbuilt annotation for UMI counting. See \code{\link{featureCounts}} for more details. \code{mm39} by default.}
  \item{annot.ext}{ Specify an external annotation for UMI counting. See \code{\link{featureCounts}} for more details. \code{NULL} by default.}
  \item{isGTFAnnotationFile}{ See \code{\link{featureCounts}} for more details. \code{FALSE} by default.}
  \item{GTF.featureType}{ See \code{\link{featureCounts}} for more details. \code{exon} by default.}
  \item{GTF.attrType}{ See \code{\link{featureCounts}} for more details. \code{gene_id} by default.} 
  \item{useMetaFeatures}{ Specify if UMI counting should be carried out at the meta-feature level (eg. gene level). See \code{\link{featureCounts}} for more details. \code{TRUE} by default.}
  \item{detectJunctions}{ Perform junction detection on reads. \code{FALSE} by default.}
  \item{umi.cutoff}{ Specify a UMI count cutoff for cell calling. All the cells with a total UMI count greater than this cutoff will be called. If \code{NULL}, a bootstrapping procedure will be performed to determine this cutoff. \code{NULL} by default. }
  \item{nthreads}{ A numeric value giving the number of threads used for read mapping and counting. \code{10} by default.}
  \item{nBestLocations}{A numeric value giving the maximum number of reported alignments for each multi-mapping read. \code{1} by default.}
  \item{uniqueMapping}{A logical value specifying if the multi-mapping reads should not be reported as mapped (i.e. reporting uniquely mapped reads only). \code{FALSE} by default.}
  \item{reportExcludedBarcodes}{If \code{TRUE}, report UMI counts for those cell barcodes that were filtered out during cell calling. \code{FALSE} by default.}
}

\details{
The \code{cellCounts} function takes as input scRNA-seq reads generated by the 10X platform, maps them to the reference genome and then produces UMI (Unique Molecular Identifier) counts for each gene in each cell.
It also performs sample demultiplexing, cell barcode demultiplexing and read deduplication, before generating UMI counts.
It can process multiple datasets at the same time.

The sample information can be provided to \code{cellCounts} via the \code{sample} parameter.
If the input format is \code{BCL} or \code{CBCL}, the provided sample information should include the location where the read data are stored, flowcell lanes used for sequencing, sample names and names of index sets used for indexing samples. 
If a sample was sequenced in all lanes, then its lane number can be set as \code{*}.
Alternatively, all the lane numbers can be listed for this sample. 
The sample information should be saved to a \code{data.frame} object and then provided to the \code{sample} parameter.
Below shows an example of this data frame:


\preformatted{
InputDirectory		Lane		SampleName	IndexSetName
/path/to/dataset1	1		Sample1		SI-GA-E1
/path/to/dataset1	1		Sample2		SI-GA-E2
/path/to/dataset1	2		Sample1		SI-GA-E1
/path/to/dataset1	2		Sample2		SI-GA-E2
/path/to/dataset2	1		Sample3		SI-GA-E3
/path/to/dataset2	1		Sample4		SI-GA-E4
/path/to/dataset2	2		Sample3		SI-GA-E3
/path/to/dataset2	2		Sample4		SI-GA-E4
...
}


It is compulsory to have the four column headers shown in the example above when generating this data frame for a 10X dataset.
If more than one datasets are provided for analysis, the \code{InputDirectory} column should include more than one distinct directory.
Note that this data frame is different from the Sample Sheet generated by the Illumina sequencer.
The \code{cellCounts} function uses the index set names included in this data frame to generate an Illumina Sample Sheet and then uses it to demultiplex all the samples.  

If the input format is \code{FASTQ}, a \code{data.frame} object containing the following three columns, \code{BarcodeUMIFile}, \code{ReadFile} and \code{SampleName}, should be provided to the \code{sample} parameter.
Each row in the data frame represents a sample.
The \code{BarcodeUMIFile} column should include names of FASTQ files containing cell barcode and UMI sequences for each read, and the \code{ReadFile} column should include names of FASTQ files containing genomic sequences for corresponding reads.

If the input format is \code{FASTQ-dir}, a character string, which includes the path to the directory where the FASTQ-format read data are stored, should be provided to the \code{sample} parameter.
The data in this directory are expected to be generated by the \code{bcl2fastq} program (developed by Illumina), or by the \code{cellranger mkfastq} command (developed by 10x), or by the \code{bamtofastq} program (developed by 10x).

Finally, if the input format is \code{BAM}, a \code{data.frame} object containing the following two columns, \code{BAMFile} and \code{SampleName}, should be provided to the \code{sample} parameter.
Each row in the data frame represents a sample.
The \code{BAMFile} column should include names of BAM files containing genomic sequences of reads with associated cell barcode and UMI sequences. 
The cell barcode and UMI sequences should be provided in the "CR" and "UR" tags included in the BAM files. 
The Phred-encoded quality strings of the cell barcode and UMI sequences should be provided in the "CY" and "UY" tags. 
These tags were originally defined in CellRanger BAM files.
}

\value{
The \code{cellCounts} function returns a \code{List} object to R.
It also outputs one BAM file for each sample. The BAM file includes location-sorted read mapping results.
If the input mode is neither \code{FASTQ} nor \code{FASTQ-dir}, it also outputs three or four gzipped FASTQ files, which include cell barcode and UMI sequences (R1), sample index sequences (I1, and optionally I2 for dual-indexed samples) and the actual genomic sequences of the reads (R2), respectively. 

The returned \code{List} object contains the following components:
\item{counts}{a \code{List} object including UMI counts for each sample. Each component in this object is a matrix that contains UMI counts for a sample. Rows in the matrix are genes and columns are cells.}

\item{annotation}{a \code{data.frame} object containing a gene annotation. This is the annotation that was used for the assignment of UMIs to genes during quantification. Rows in the annotation are genes. Columns of the annotation include \code{GeneID}, \code{Chr}, \code{Start}, \code{End} and \code{Length}.}

\item{sample.info}{a \code{data.frame} object containing sample information and quantification statistics.
It includes the following columns: \code{SampleName}, \code{InputDirectory} (if the input format is \code{BCL}), \code{TotalCells}, \code{HighConfidenceCells} (if \code{umi.cutoff} is \code{NULL}), \code{RescuedCells} (if \code{umi.cutoff} is \code{NULL}), \code{TotalUMI}, \code{MinUMI}, \code{MedianUMI}, \code{MaxUMI}, \code{MeanUMI}, \code{TotalReads}, \code{MappedReads} and \code{AssignedReads}.
Each row in the data frame is a sample.}

\item{cell.confidence}{a \code{List} object indicating if a cell is a high-confidence cell or a rescued cell (low confidence). Each component in the object is a logical vector indicating which cells in a sample are high-confidence cells. \code{cell.confidence} is included in the output only if \code{umi.cutoff} is \code{NULL}.}

\item{counts.excluded.barcodes}{a \code{List} object including UMI counts for excluded cell barcodes for each sample.}
}

\author{Yang Liao and Wei Shi}

\seealso{
\code{\link{buildindex}}, \code{\link{align}}, \code{\link{featureCounts}}
}

\examples{
# Data used in this example (71MB) can be downloaded from https://shilab-bioinformatics.github.io/cellCounts-Example/cellCounts-Example.zip
\dontrun{
library(Rsubread)
buildindex("chr1", "hg38_chr1.fa.gz")
sample.sheet <- data.frame(BarcodeUMIFile="reads_R1.fastq.gz", ReadFile="reads_R2.fastq.gz", SampleName="Example")
counts <- cellCounts("chr1", sample.sheet, input.mode="FASTQ", annot.inbuilt="hg38")
}
}

\name{qualityScores}
\alias{qualityScores}
\title{Extract Quality Score Data in a Sequencing Read Dataset}
\description{Extract quality strings and convert them to Phred scores for generating boxplots.
}
\usage{
qualityScores(

    # basic input/output options
    filename,
    input_format = "gzFASTQ",
    offset = 33,
    nreads = 10000)
}
\arguments{
  \item{filename}{ a character string giving the name of an input file containing sequence reads.}
  \item{input_format}{ a character string specifying format of the input file. \code{gzFASTQ} (gzipped FASTQ) by default. Acceptable formats include \code{gzFASTQ}, \code{FASTQ}, \code{SAM} and \code{BAM}. Character string is case insensitive.}
  \item{offset}{ a numeric value giving the offset added to the base-calling Phred scores. Possible values include \code{33} and \code{64}. By default, \code{33} is used.}
  \item{nreads}{ a numeric value giving the number of reads from which quality scores are extracted. \code{10000} by default. A value of \code{-1} indicates that quality scores will be extracted from all the reads.}
}
\details{
Quality scores of read bases are represented by ASCII characters in next-gen sequencing data.
This function extracts the quality characters from each base in each read and then converts them to Phred scores using the provided offset value (\code{offset}).

If the total number of reads in a dataset is \code{n}, then every \code{n}/\code{nreads} read is extracted from the input data.
}
\value{ 
A data matrix containing Phred scores for read bases. Rows in the matrix are reads and columns are base positions in each read.
}
%\references{}
\author{Wei Shi, Yang Liao and Zhiyin Dai}
%\note{}
%\seealso{}
\examples{
reads <- system.file("extdata","reads.txt.gz",package="Rsubread")
x <- qualityScores(filename=reads,offset=64,nreads=1000)
x[1:10,1:10]
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{txUnique}
\alias{txUnique}
\title{Count Number of Bases Unique to Each Transcript}
\description{For each transcript, number of unique bases and total number of bases will be reported. }
\usage{
txUnique(

    # basic input/output options
    GTF_Annotation_File,
    Feature_Type = "exon",
    Gene_ID_Attribute = "gene_id",
    Transcript_ID_Attribute = "transcript_id")
}
\arguments{
  \item{GTF_Annotation_File}{ a character string giving the name of a GTF file containing the transcript-level annotations.}
  \item{Feature_Type}{ a character string specifying the type of annotations. Only the annotations of the given type will be loaded from the GTF file. \code{exon} by default. The third column in the GTF file contains the type of the annotation in each line}
  \item{Gene_ID_Attribute}{ a character string specifying the attribute name in the 9-th column in the GTF file for the gene identifier. \code{gene_id} by default.}
  \item{Transcript_ID_Attribute}{ a character string specifying the attribute name in the 9-th column in the GTF file for the transcript identifier. \code{transcript_id} by default.}
}
\details{
This function compares the transcripts belonging to the same gene and then counts the number of bases unique to each transcript. It also reports the total number of bases for each transcript. When a transcript is found to contain overlapping exons, the overlapping exons will be merged and each overlapping base will be counted only once.
}
\value{
A data matrix in which each row represents a transcript. The matrix includes four columns: gene identifier, transcript identifier, number of bases unique to each transcript and total number of bases each transcript has.
}
%\references{}
\author{Yang Liao and Wei Shi}
%\note{}
%\seealso{}
%\examples{
%}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line

\name{repair}
\alias{repair}
\title{Re-Order Paired-End Reads to Place Reads}
\description{Fast re-ordering of paired-end reads using read names and mapping locations.}
\usage{
repair(

    inFiles,
    inFormat = "BAM",
    outFiles = paste(inFiles,"repair",sep="."),
    addDummy = TRUE,
    fullData = TRUE,
    compress = FALSE,
    nthreads = 8)
}
\arguments{
  \item{inFiles}{ a character vector giving names of input files. These files are typically location-sorted BAM files.}
  \item{inFormat}{ a character string specifying format of input files. Supported formats include \code{BAM} and \code{SAM}.}
  \item{outFiles}{ a character string giving names of output files. Re-ordered reads are saved to BAM-format files.}
  \item{addDummy}{ logical indicating if a dummy read will be added to each singleton read which has a missing pair in the input. \code{TRUE} by default.}
  \item{fullData}{ logical indicating if sequences and base-calling quality scores of reads will be included in the output. \code{TRUE} by default.}
  \item{compress}{ logical indicating if compression should be turned on when generating BAM output. \code{FALSE} by default.}
  \item{nthreads}{ a numeric value giving number of CPU threads. 8 by default.}
}
\details{
This function takes as input paired-end BAM or SAM files, re-orders reads to make reads from the same pair be adjacent to each other and outputs the re-ordered reads into new BAM files.

The function makes use of both read names and mapping information of reads (eg. mapping coordinates) to identify reads belonging to the same pair.
This makes sure that all paired-end reads are correctly re-ordered, especially those multi-mapping read pairs that include more than one reported alignment in the input.

The BAM files produced by this function are compatible with \code{\link{featureCounts}}, meaning that no further re-ordering needs to be performed by \code{\link{featureCounts}}.
}
\value{
No value is produced but BAM files with re-ordered reads are written to the current working directory.
}
%\references{}
\author{Wei Shi and Yang Liao}
%\note{}
%\seealso{}
%\examples{}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{}
%\keyword{}% __ONLY ONE__ keyword per line
